#include <string.h>
#include <stdio.h>
#include <allegro.h>

#include "../melee.h"
#include "../ais.h"
#include "../melee/mcontrol.h"
#include "../melee/mframe.h"
#include "../melee/mship.h"
#include "../melee/mmain.h"

#define OPTION_UNKNOWN 0
#define OPTION_NONE 1
#define OPTION_FRONT 2
#define OPTION_NO_FRONT 3
#define OPTION_SIDES 4
#define OPTION_BACK 5
#define OPTION_FEILD 6
#define OPTION_NARROW 7
#define OPTION_HOMING 8
#define OPTION_PROXIMITY 9
#define OPTION_NO_PROXIMITY 10
#define OPTION_NO_RANGE 11
#define OPTION_HOLD 12
#define OPTION_PRECEDENCE 13
#define OPTION_DEFENSE 14
#define OPTION_CLOAK 15
#define OPTION_MAX_BATT 16
#define OPTION_BATTERY 17
#define OPTION_RESERVE_BATT 18
#define OPTION_PLUS_FIRE 19
#define OPTION_PLUS_SPECIAL 20
#define OPTION_LAUNCHED 21
#define OPTION_NEXT_STATE 22
#define OPTION_RESET_STATE 23
#define OPTION_ALWAYS_WHEN_FULL 24
#define OPTION_MINE 25

#define STATE_TOO_CLOSE 0
#define STATE_TOO_FAR 1

#define TACTIC_UNKNOWN 1
#define TACTIC_INDIRECT_INTERCEPT 2
#define TACTIC_DIRECT_INTERCEPT 3
#define TACTIC_RANGE 4

double ControlWussie::check_danger() {
	double d = 0;
	Query q;
	q.begin(ship, OBJECT_LAYERS, ship->w+ship->h+200);
	for (;q.currento;q.next()) {
		if ((ship->distance(q.currento) < (ship->w+ship->h+q.currento->w+q.currento->h+5)) && 
				(q.currento->damage_factor > 0) && (!ship->sameShip(q.currento))) {
			double  ai_x = ship->normal_x();
			double  ai_y = ship->normal_y();
			double ai_vx = ship->get_vx(); 
			double ai_vy = ship->get_vy(); 

			double  enemy_x = q.currento->normal_x();
			double  enemy_y = q.currento->normal_y();
			double enemy_vx = q.currento->get_vx(); 
			double enemy_vy = q.currento->get_vy(); 

			double      range = ship->distance(q.currento);
			double next_range = distance_from(ai_x + ai_vx, ai_y + ai_vy, 
					enemy_x + enemy_vx, enemy_y + enemy_vy);

			if (next_range < range) d += q.currento->damage_factor;

//			double range_step = range - next_range;
			}
		}
	return d;
	}

const char *ControlWussie::getTypeName() {
	return "WussieBot";
	}

int absf(double x) {
  if (x >= 0)
    return ((int)x);
  else return ((int)(-1 * x));
}

double ControlWussie::evasion(Ship* ship) {
  double closetime = 500;
  double angle,dodgeangle = -1;
  Query b;
  SpaceObject *shot;
  int collideshot;
  double shipslope,shotslope,shottime,shiptime;
  double shipint,shotint;
//  double shipspeed,shotspeed;
  double xs,ys;
  double velship,velshot;
  for (b.begin(ship, OBJECT_LAYERS &~ bit(LAYER_CBODIES) &~ bit(LAYER_SHIPS),
      500);b.current;b.next()) {
    shot = b.currento;
    if (shot->canCollide(ship)) {
      if (ship->get_vy() == 0)
        shipslope = ship->get_vx() / 0.0000001;
      else shipslope = ship->get_vx() / ship->get_vy();
      if (shot->get_vy() == 0)
        shotslope = shot->get_vx() / 0.0000001;
      else shotslope = shot->get_vx() / shot->get_vy();
      collideshot = TRUE;
      shipint = ship->normal_y() - (shipslope * ship->normal_x());
      shotint = shot->normal_y() - (shotslope * shot->normal_x());
      if (shotint == shipint) {
        collideshot = FALSE; }
      else {
        xs = (shipint - shotint)/(shotslope - shipslope);
        ys = (shipslope * xs) + shipint;
      }
      velship = distance_from(0,0,ship->get_vx(),ship->get_vy());
      if ((velship == 0) || (!collideshot))
        collideshot = FALSE;
      else {
      shiptime = distance_from(xs,ys,ship->normal_x(),ship->normal_y()) / velship;
      velshot = distance_from(0,0,shot->get_vx(),shot->get_vy());
      if (!((velshot == 0) || (!collideshot))) {
      shottime = distance_from(xs,ys,shot->normal_x(),shot->normal_y()) / velshot;
      if (absf(shottime - shiptime) < closetime) {
        angle = ship->get_angle() - ship->trajectory_angle(shot);
        closetime = absf(shottime - shiptime);
        if ((angle < 15) || (angle > 345))
          angle += 180;
        else if (normalize(angle,360) > normalize(-angle,360))
          angle -= 90;
        else angle += 90;
        dodgeangle = normalize(angle,360);
      }
    }
  }
 } }
  return dodgeangle;
}

int ControlWussie::think() {
	int action = 0;
	float velocity,distance;
 double angle,va,pangle,dangle;
 int avoid_planet = FALSE;
 Query ap;
 SpaceObject *p;
 for (ap.begin(ship, bit(LAYER_CBODIES),planet_safe[state]); ap.current; ap.next()) {
   p = ap.currento;
   if (p->isPlanet()) {
     pangle = ship->trajectory_angle(p);
     va = normalize(atan3(ship->get_vy(), ship->get_vx()) * 180 / PI ,360);
     if (absf(pangle-va) < 60) {
       avoid_planet = TRUE;
         if (normalize(pangle - va,360) <
           normalize (va - pangle,360))
         angle = -90 + ship->get_angle() - ship->trajectory_angle(p);
         else angle = 90 + ship->get_angle() - ship->trajectory_angle(p);
   } } }
 if (!avoid_planet) {
  	if (!ship->target) return 0;
	  if (!ship->target->exists()) {
	  ship->target = NULL;
	  return 0;  }
   distance = ship->distance(ship->target);
 switch (tactic[state]) {
 default:
 case TACTIC_UNKNOWN:
 case TACTIC_INDIRECT_INTERCEPT:
	  if (distance < option_range[state][0]) velocity = option_velocity[state][0];
	  else velocity = ship->speed_max;

	  double rx, ry;
	  if (velocity == 0) velocity = GLOBAL_MAXSPEED;
	  rx = -ship->normal_x() + ship->target->normal_x() + (ship->target->get_vx()) * distance / velocity;
	  rx = normalize(rx, X_MAX);
	  if (rx > X_MAX / 2) rx -= X_MAX;
	  ry = -ship->normal_y() + ship->target->normal_y() + (ship->target->get_vy()) * distance / velocity;
	  ry = normalize(ry, Y_MAX);
	  if (ry > Y_MAX / 2) ry -= Y_MAX;
	  angle = atan3(ry, rx) * 180 / PI - ship->get_angle();
 break;

 case TACTIC_DIRECT_INTERCEPT:
   angle = ship->trajectory_angle(ship->target) - ship->get_angle();
 break;

 case TACTIC_RANGE:
   if (tactic_state == STATE_TOO_FAR) {
     angle = ship->trajectory_angle(ship->target) - ship->get_angle();
     if (distance < min_range[state])
       tactic_state = STATE_TOO_CLOSE; }
   else {
     angle = ship->trajectory_angle(ship->target) - ship->get_angle() + 180;
     if (distance > max_range[state])
       tactic_state = STATE_TOO_FAR; }
   break;

}
   dangle = evasion(ship);
   if (dangle >= 0)
     angle = dangle;
}

 while (angle < 0) angle += 360;
	while (angle > 360) angle -= 360;
	if (angle > 180) {
  angle -= 360;
  action |= keyflag::left;
		}
	else {
		action |= keyflag::right;
		}
	action |= keyflag::thrust;
 int i,j;
	if (!ship->target) return action;
 if (!ship->target->exists()) {
 ship->target = NULL;
 return action; }

 for (j=0;j<2;j++) {
   fireoption[j] = FALSE;
   dontfireoption[j] = FALSE;
   sweep[j] = 20;
   for (i=0;i<MAX_OPTION;i++) {
     if (option_type[state][j][i] == OPTION_NARROW)
       sweep[j] = 5;
     if (option_type[state][j][i] == OPTION_HOMING)
       sweep[j] = 35;
   }
 }
 double a;
 int range_fire,fire_front,field_fire;
for (j=0;j<2;j++) {

 if (j==0) range_fire = TRUE;
    else range_fire = FALSE;
 if (j==0) fire_front = TRUE;
    else fire_front = FALSE;
 if (j==0) field_fire = FALSE;
    else field_fire = TRUE;

 for (i=0;i<MAX_OPTION;i++) {

  switch (option_type[state][j][i]) {
    default:
    case OPTION_UNKNOWN:
     if (i==0)
       if (j==0) {
         if ((distance < option_range[state][j]) && (absf(angle) < sweep[j]))
           fireoption[0] = TRUE; }
       else
         if (ship->batt != ship->batt_max)
           dontfireoption[1] = TRUE;
     break;

     case OPTION_FRONT:
         fire_front = TRUE;
         field_fire = FALSE;
     break;

     case OPTION_NO_FRONT:
         fire_front = FALSE;
         field_fire = FALSE;
     break;

     case OPTION_BACK:
     if (absf(angle) > (180-sweep[j]))
         fireoption[j] = TRUE;
     field_fire = FALSE;
     break;

     case OPTION_SIDES:
     if ((absf(angle) < 90+sweep[j]) && (absf(angle) > 90-sweep[j]))
         fireoption[j] = TRUE;
     field_fire = FALSE;
     break;

     case OPTION_FEILD:
        fireoption[j] = TRUE;
        field_fire = TRUE;
     break;

     case OPTION_NO_RANGE:
       range_fire = FALSE;
     break;

     case OPTION_NO_PROXIMITY:
       if (distance < option_range[state][j])
         dontfireoption[j] = TRUE;
       range_fire = FALSE;
     break;

     case OPTION_PROXIMITY:
       range_fire = TRUE;
     break;

		   case OPTION_BATTERY:
			    if (ship->batt <= batt_level[state][j] )
         fireoption[j] = TRUE;
       field_fire = FALSE;
      break;

     case OPTION_MINE:
        a = normalize(atan3(ship->target->get_vy(), ship->target->get_vx()) * 180 / PI +90,360);
        if (absf(normalize(ship->target->trajectory_angle(ship)+90,360)-a) < sweep[j])
          fireoption[j] = TRUE;
        field_fire = FALSE;
        fire_front = FALSE;
     break;

     case OPTION_CLOAK:
       if (!(ship->isInvisible()))
         fireoption[j] = TRUE;
       else dontfireoption[j] = TRUE;
     break;

		   case OPTION_DEFENSE:
			    if (check_danger() > (4/option_freq[state][j]))
         fireoption[j] = TRUE;
       field_fire = FALSE;
     break;

     case OPTION_MAX_BATT:
       if (ship->batt != ship->batt_max)
         if (!option_held[j])
           dontfireoption[j] = TRUE;
     break;

     case OPTION_RESERVE_BATT:
       if (ship->batt < batt_level[state][j])
         if (!option_held[j])
          dontfireoption[j] = TRUE;
     break;

     case OPTION_LAUNCHED:
       if (option_held[j]) {
         bombx[j] += (bombvx[j] * frame_time);
         bomby[j] += (bombvy[j] * frame_time);
         normalize(bombx[j],X_MAX);
         normalize(bomby[j],Y_MAX);
         bomb = new SpaceLocation(NULL, bombx[j],bomby[j],0);
       if (ship->target->distance(bomb) > bombdistance[j]) {
         option_held[j] = FALSE;
         dontfireoption[j] = TRUE; }
       else {
         bombdistance[j] = ship->target->distance(bomb);
         }
         delete bomb;
         }
     break;

     case OPTION_NONE:
         dontfireoption[j] = TRUE;
        break;
     }
    }

 if (range_fire)
   if (distance > option_range[state][j])
     dontfireoption[j] = TRUE;

 if (fire_front)
   if (absf(angle) < sweep[j])
         fireoption[j] = TRUE;

 if (field_fire)
   fireoption[j] = TRUE;
}
for (j=0;j<2;j++)
 for (i=0;i<MAX_OPTION;i++) {
  if (option_type[state][j][i] == OPTION_LAUNCHED) {
     if ((!option_held[j]) && (fireoption[j]) && (!dontfireoption[j])) {
       bombx[j] = ship->normal_x();
       bomby[j] = ship->normal_y();
       bombvx[j] = (ship->get_vx() * rel[state][j]) +
         (option_velocity[state][j] * cos(ship->get_angle() * ANGLE_RATIO));
       bombvy[j] = (ship->get_vy() * rel[state][j]) +
         (option_velocity[state][j] * sin(ship->get_angle() * ANGLE_RATIO));
       bombdistance[j] = ship->distance(ship->target); }   }
  if (option_type[state][j][i] == OPTION_HOLD) {
     if ((option_held[j]) && (fireoption[j]) && (!dontfireoption[j])) {
       dontfireoption[j] = TRUE;
       option_held[j] = FALSE; }
     else if (option_held[j]) {
       option_held[j] = TRUE;
       fireoption[j] = TRUE;
       dontfireoption[j] = FALSE;
       }
     else if (!option_held[j]) {
       option_held[j] = TRUE;
       fireoption[j] = TRUE;
       dontfireoption[j] = FALSE;}
     }
}
for (j=0;j<2;j++)
 for (i=0;i<MAX_OPTION;i++) {
   if (option_time[j] > 0) {
     option_time[j] -= frame_time;
     dontfireoption[j] = TRUE;
}  if (option_type[state][j][i] == OPTION_PRECEDENCE)
     if (fireoption[j] && (!dontfireoption[j]))
       dontfireoption[(!j)] = TRUE;
   if (option_type[state][j][i] == OPTION_ALWAYS_WHEN_FULL)
     if (ship->batt >= ship->batt_max) {
       fireoption[j] = TRUE;
       dontfireoption[j] = FALSE;
     }
}

int newstate = state;
for (j=0;j<2;j++)
  if (fireoption[j] && (!dontfireoption[j])) {
      if (j==0) action |= keyflag::fire;
      else action |= keyflag::special;
      option_time[j] = option_timer[state][j];
      for (i=0;i<MAX_OPTION;i++) {
         if (option_type[state][j][i] == OPTION_LAUNCHED)
              option_held[state] = TRUE;
         if (option_type[state][j][i] == OPTION_HOLD)
              option_held[state] = TRUE;
         if (option_type[state][j][i] == OPTION_PLUS_SPECIAL)
              action |= keyflag::special;
         if (option_type[state][j][i] == OPTION_PLUS_FIRE)
              action |= keyflag::fire;
         if (option_type[state][j][i] == OPTION_NEXT_STATE)
              newstate++;
         if (option_type[state][j][i] == OPTION_RESET_STATE)
              newstate = 0; }
  } else option_held[j] = FALSE;

 state = newstate;

	if ((rand() % 4000) < frame_time) action |= keyflag::closest;
  return action;
	}

ControlWussie::ControlWussie(const char *name) : Control(name) {}

//void ControlWussie::set_target(int i) {
//	Control::set_target(i);
//	}

void ControlWussie::select_ship(Ship* ship_pointer, const char* ship_name) {
	char tmp[20];
	int i,j,k;
	Control::select_ship(ship_pointer, ship_name);
	if (ship_name) {
		replace_extension(tmp, ship_name, "ini", 19);
  char states[20],sstr[20];
  const char *w,*s;
  for (k=0;k<MAX_STATES;k++){
  for (j=0;j<2;j++) {
    strcpy(states,"AI3_Default");
    if (k != 0) sprintf(states+strlen(states), "%d", k+1);
    for (i=0; i<MAX_OPTION; i++) {
    if (j==0)
      strcpy(sstr,"Weapon");
    else
      strcpy(sstr,"Special");
  if (i != 0) sprintf(sstr+strlen(sstr), "%d", i+1);
  w = get_config_string (states,sstr,"");
  option_type[k][j][i] = OPTION_UNKNOWN;
  if      (!strcmp (w , "No_Front")) option_type[k][j][i] = OPTION_NO_FRONT;
  else if (!strcmp (w , "Front")) option_type[k][j][i] = OPTION_FRONT;
  else if (!strcmp (w , "Sides")) option_type[k][j][i] = OPTION_SIDES;
  else if (!strcmp (w , "Field")) option_type[k][j][i] = OPTION_FEILD;
  else if (!strcmp (w , "Narrow")) option_type[k][j][i] = OPTION_NARROW;
  else if (!strcmp (w , "Homing")) option_type[k][j][i] = OPTION_HOMING;
  else if (!strcmp (w , "No_range")) option_type[k][j][i] = OPTION_NO_RANGE;
  else if (!strcmp (w , "Back")) option_type[k][j][i] = OPTION_BACK;
  else if (!strcmp (w, "Precedence")) option_type[k][j][i] = OPTION_PRECEDENCE;
		else if (!strcmp (w, "Defense")) option_type[k][j][i] = OPTION_DEFENSE;
		else if (!strcmp (w, "Battery")) option_type[k][j][i] = OPTION_BATTERY;
  else if (!strcmp (w, "Max_Battery")) option_type[k][j][i] = OPTION_MAX_BATT;
  else if (!strcmp (w, "Reserve_Battery")) option_type[k][j][i] = OPTION_RESERVE_BATT;
  else if (!strcmp (w, "Cloak")) option_type[k][j][i] = OPTION_CLOAK;
  else if (!strcmp (w, "Proximity")) option_type[k][j][i] = OPTION_PROXIMITY;
  else if (!strcmp (w, "Plus_Fire")) option_type[k][j][i] = OPTION_PLUS_FIRE;
  else if (!strcmp (w, "Plus_Special")) option_type[k][j][i] = OPTION_PLUS_SPECIAL;
  else if (!strcmp (w, "Launched")) option_type[k][j][i] = OPTION_LAUNCHED;
  else if (!strcmp (w , "Hold")) option_type[k][j][i] = OPTION_HOLD;
  else if (!strcmp (w , "No_Proximity")) option_type[k][j][i] = OPTION_NO_PROXIMITY;
  else if (!strcmp (w , "Next_State")) option_type[k][j][i] = OPTION_NEXT_STATE;
  else if (!strcmp (w , "Reset_State")) option_type[k][j][i] = OPTION_RESET_STATE;
  else if (!strcmp (w , "Always_When_Full")) option_type[k][j][i] = OPTION_ALWAYS_WHEN_FULL;
  else if (!strcmp (w , "Mine")) option_type[k][j][i] = OPTION_MINE;
  else if (!strcmp (w , "None" )) option_type[k][j][i] = OPTION_NONE;

  s = get_config_string (states,"Tactic","");
  tactic[k] = TACTIC_UNKNOWN;
  if      (!strcmp (s , "Indirect")) tactic[k] = TACTIC_INDIRECT_INTERCEPT;
  else if (!strcmp (s , "Direct")) tactic[k] = TACTIC_DIRECT_INTERCEPT;
  else if (!strcmp (s , "Range")) tactic[k] = TACTIC_RANGE;

  min_range[k] = scale_range(get_config_float(states,"Tactic_Min",10));
  max_range[k] = scale_range(get_config_float(states,"Tactic_Max",20));
  tactic_state = 0;
  option_held[j] = FALSE;
  batt_level[k][j] = get_config_int (states, "BattRecharge", 0);
} }
  planet_safe[k] = get_config_int(states,"Planet_Distance",0);
//  if (planet_safe[k] == 0); //Launchpad, is this supposed to be here?
    planet_safe[k] = 75 * get_config_int("ship","Mass",8);
  option_velocity[k][0] = scale_velocity(get_config_float(states, "Weapon_Velocity", 0));
  if (option_velocity[k][0] == 0)
  option_velocity[k][0] = scale_velocity(get_config_float("Weapon", "Velocity", 999));
  option_velocity[k][1] = scale_velocity(get_config_float(states, "Special_Velocity", 0));
  if (option_velocity[k][1] == 0)
  option_velocity[k][1] = scale_velocity(get_config_float("Special", "Velocity", 999));
  option_range[k][0] = scale_range(get_config_float(states,"Weapon_Range",0));
  if (option_range[k][0] == 0)
    option_range[k][0] = scale_range(get_config_float("Weapon", "Range", 50));
  option_range[k][1] = scale_range(get_config_float(states,"Special_Range",0));
  if (option_range[k][1] == 0)
    option_range[k][1] = scale_range(get_config_float("Special", "Range", 50));
		option_freq[k][0] = 0.5 + get_config_float (states, "WeaponFreq", 1);
		option_freq[k][1] = 0.5 + get_config_float (states, "SpecialFreq", 1);
  option_timer[k][0] = scale_frames(get_config_int(states, "Weapon_Timer",-999));
  option_timer[k][1] = scale_frames(get_config_int(states, "Special_Timer",-999));
  rel[k][0] = get_config_float(states,"WeaponRel",.5);
  rel[k][1] = get_config_float(states,"SpecialRel",.5);
  option_time[0] = option_timer[0][0];
  option_time[1] = option_timer[0][1];
  }
  state = 0;
 }
	return;
}

