#ifndef _FRAME_H
#define _FRAME_H


typedef struct DirtyItem {
  int x, y, a, b;

  void (*erase_item)(DirtyItem *item, BITMAP *frame);
  void (*draw_item)(DirtyItem *item, BITMAP *frame, BITMAP *child);
} DirtyItem;

void erase_pixel(DirtyItem *item, BITMAP *frame);
void draw_pixel(DirtyItem *item, BITMAP *frame, BITMAP *child);

void erase_box(DirtyItem *item, BITMAP *frame);
void draw_box(DirtyItem *item, BITMAP *frame, BITMAP *child);

void erase_line(DirtyItem *item, BITMAP *frame);
void draw_line(DirtyItem *item, BITMAP *frame, BITMAP *child);

class Frame {
  public:
  int list_size;

  DirtyItem *item;
  int        item_count;
  DirtyItem *old_item;
  int        old_item_count;

	int background_color;

  BITMAP *frame;
  BITMAP *child;

  Frame(int x, int y, int w, int h, int max_items);
  virtual ~Frame();

  void enlarge_list(int increment);

  void add_to_list(int x, int y, int a, int b,
    void (*erase_item)(DirtyItem *item, BITMAP *frame),
    void (*draw_item)(DirtyItem *item, BITMAP *frame, BITMAP *child));
  void add_to_old_list(int x, int y, int a, int b,
    void (*erase_item)(DirtyItem *item, BITMAP *frame),
    void (*draw_item)(DirtyItem *item, BITMAP *frame, BITMAP *child));

  void add_pixel(int x, int y, int a, int b);
  void add_box(int x, int y, int a, int b);
  void add_line(int x, int y, int a, int b);

  void add_old_pixel(int x, int y, int a, int b);
  void add_old_box(int x, int y, int a, int b);
  void add_old_line(int x, int y, int a, int b);

  virtual void erase();
  virtual void draw();
};

#endif
