/*
#include <stdlib.h>
#include <string.h>
#include <stdio.h>

#include <allegro.h>

#include "../melee.h"
REGISTER_FILE
#include "../scp.h"

#include "../melee/mgame.h"
#include "../melee/mmain.h"
#include "../melee/mview.h"
#include "../melee/mcontrol.h"
#include "../melee/mcbodies.h"
#include "../melee/mshppan.h"
#include "../melee/mship.h"
#include "../melee/mshot.h"
#include "../melee/mlog.h"
#include "../melee/manim.h"

#include "ggob.h"
#include "gobships.h"


#define gobgame ((GobGame*)game)

////////////////////////////////////////////////////////////////////////
//				Gob stuff
////////////////////////////////////////////////////////////////////////


void GobAsteroid::handle_damage(SpaceLocation *source) {
	if ((damage == 0) && (directDamage == 0)) return;
	if (!exists()) return;
	int i;
	for (i = gobgame->first_gob_player; i < gobgame->first_gob_player + gobgame->max_gob_players; i += 1) {
		if (gobgame->gobplayer[i]->ship && gobgame->gobplayer[i]->ship->sameShip(source)) {
			gobgame->gobplayer[i]->buckazoids += 1;
			}
		}

	game->addItem(new Animation(this, x, y, 
			explosion, 0, ASTEROIDEXPLOSION_FRAMES, time_ratio, LAYER_CBODIES));
	game->addItem(new GobAsteroid());
	damage = 0;
	directDamage = 0;
	state = 0;
	return;
	}

void GobGame::preinit() {
	Game::preinit();

	int i;
	for (i = 0; i < 3; i += 1)
		stationSprite[i] = NULL;
	for (i = 0; i < 3; i += 1)
		station_pic_name[i] = NULL;
	for (i = 0; i < 3; i += 1)
		station_build_name[i] = NULL;
	}

void GobGame::init(Log *log) {
	int i;
	switch(log->type) {
		case Log::log_net1server:
		case Log::log_net1client: {
			error("unsupported game type");
			}
		break;
		default: {
			}
		break;
		}
	Game::init(log);

	width = 16384;
	height = 16384;

	first_gob_enemy = max_gob_players;
	max_gob_enemies = 8;
	num_players = max_gob_players + max_gob_enemies;
	num_asteroids = 16;
	enemy_team = new_team();

	set_resolution(screen_x, screen_y);

	first_local_player = first_gob_player;
	num_local_players = max_gob_players;

	control = new Control*[num_players];
	name    = new char*[num_players];
	panel = new ShipPanel*[num_players];
	gobplayer = new GobPlayer*[num_players];
	gobenemy = new GobEnemy*[num_players];
	for (i = 0; i < num_players; i += 1) {
		control[i] = NULL;
		name[i] = NULL;
		panel[i] = NULL;
		gobplayer[i] = NULL;
		gobenemy[i] = NULL;
		}

	i = 0; {
		gobplayer[i] = new GobPlayer();
		set_config_file("tmp.ini");
		name[i] = strdup("Captain Donut");
		control[i] = getController("Keyboard", name[i]);
		control[i]->load("scp.ini", "Config0");
		}
	for (i = first_gob_enemy; i < first_gob_enemy + max_gob_enemies; i += 1) {
		name[i]= strdup("an enemy");
		control[i] = getController("WussieBot", "an enemy");
		control[i]->load("scp.ini", "Config0");
		gobenemy[i] = new GobEnemy();
		gobenemy[i]->set_index(i);
		}
	for (i = 0; i < num_players; i += 1) {
		if (control[i]) control[i]->initialize();
		}


	DATAFILE *tmpdata; 
	tmpdata = load_datafile_object("gob.dat", "station0sprite");
	if (!tmpdata) error( "couldn't find gob.dat#station0sprite");
	stationSprite[0] = new SpaceSprite(tmpdata, 1, SpaceSprite::MASKED, 64);
	unload_datafile_object(tmpdata);
	tmpdata = load_datafile_object("gob.dat", "station1sprite");
	if (!tmpdata) error ("couldn't find gob.dat#station1sprite");
	stationSprite[1] = new SpaceSprite(tmpdata, 1, SpaceSprite::MASKED, 64);
	unload_datafile_object(tmpdata);
	tmpdata = load_datafile_object("gob.dat", "station2sprite");
	if (!tmpdata) error ("couldn't find gob.dat#station2sprite");
	stationSprite[2] = new SpaceSprite(tmpdata, 1, SpaceSprite::MASKED, 64);
	unload_datafile_object(tmpdata);

	station_pic_name[0] = "gob.dat#station0picture.bmp";
	station_pic_name[1] = "gob.dat#station1picture.bmp";
	station_pic_name[2] = "gob.dat#station2picture.bmp";
	station_build_name[0] = "supbl";
	station_build_name[1] = "orzne";
	station_build_name[2] = "kohma";

	prepare();
	SpaceLocation *p;
	p = addItem (new Planet (width/2, height/2, planetSprite, 0));
	addItem(new Station(stationSprite[0], p, station_build_name[0], station_pic_name[0]) );
	p = addItem (new Planet (width/2, height/2, planetSprite, 1));
	while (true) {
		SpaceLocation *n;
		n = p->nearest_planet();
		if (!n || (p->distance(n) > 1500)) break;
		p->translate(random() % int(width), random() % int(height));
		}
	addItem(new Station(stationSprite[1], p, station_build_name[1], station_pic_name[1]) );
	//p = this->addItem (new Planet (this->planetSprite. 2) );
	p = addItem (new Planet (width/2, height/2, planetSprite, 2));
	while (true) {
		SpaceLocation *n;
		n = p->nearest_planet();
		if (!n || (p->distance(n) > 1500)) break;
		p->translate(random() % int(width), random() % int(height));
		}
	addItem(new Station(stationSprite[2], p, station_build_name[2], station_pic_name[2]) );
	i = random() % 3;
	p = addItem (new Planet (width/2, height/2, planetSprite, i));
	while (true) {
		SpaceLocation *n;
		n = p->nearest_planet();
		if (!n || (p->distance(n) > 1500)) break;
		p->translate(random() % int(width), random() % int(height));
		}
	addItem(new Station(stationSprite[i], p, station_build_name[i], station_pic_name[i]) );
	for (i = 0; i < num_asteroids; i += 1) addItem(new GobAsteroid());

	gobplayer[0]->set_index(0);
	gobplayer[0]->new_ship(shiptype("supbl"));
	Ship *s = control[0]->ship;
	s->translate(8192-s->normal_x(), 8192-s->normal_y());
	s->translate(250, 100);
	s->accelerate(s, 90, 0.1, GLOBAL_MAXSPEED);
	next_add_new_enemy_time = 1000;
	add_new_enemy();
	set_view(view2number("Hero"));
	view_locked = true;
	return;
	}

void GobGame::fps() {
	Game::fps();
	if (gobplayer[0]) {
		if (gobplayer[0]->ship) {
			message.print(msecs_per_fps, 15, "coordinates: %d x %d", 
					int(control[0]->ship->normal_x()), 
					int(control[0]->ship->normal_y()));
			}
		message.print(msecs_per_fps, 15, "starbucks: %d", gobplayer[0]->starbucks);
		message.print(msecs_per_fps, 15, "buckazoids: %d", gobplayer[0]->buckazoids);
		message.print(msecs_per_fps, 15, "kills: %d", gobplayer[0]->kills);
		}
	message.print(msecs_per_fps, 15, "time: %d", game_time / 1000);
	return;
	}
GobGame::~GobGame() {
	set_config_file("client.ini");
	set_view(view2number(get_config_string("View", "View", "Enemy")));		
	}
void GobGame::calculate(int time) {
	if (next_add_new_enemy_time <= game_time) {
		int t = 28;
		if ((random() % t) < 4) add_new_enemy();
		next_add_new_enemy_time += 5000;
		}
	Game::calculate(time);
	return;
	}
void GobGame::ship_died(Ship *who, SpaceLocation *source) {
	int i;
	int victim=-999, killer = -1;
	for (i = 0; i < num_players; i += 1) {
		if (control[i] && (control[i]->ship == who)) victim = i;
		}
	for (i = 0; i < num_players; i += 1) {
		if (control[i] && control[i]->ship && control[i]->ship->sameShip (source)) killer = i;
		}
	if (gobplayer[victim] && gobplayer[victim]->divine_favor) {
		if (random() & 1) {
			who->state = 1;
			who->crew = who->crew_max;
			return;
			}
		}
	if ((killer >= 0) && gobplayer[killer]) {
		if (gobenemy[victim]) {
			gobplayer[killer]->starbucks += gobenemy[victim]->starbucks;
			gobplayer[killer]->buckazoids += gobenemy[victim]->buckazoids;
			gobplayer[killer]->kills += 1;
			}
		}
	if (gobenemy[victim]) {
		gobenemy[victim]->ship = 0;
		}
	if (gobplayer[victim]) {
		gobplayer[victim]->ship = 0;
		}
	Game::ship_died(who, source);
	return;
	}
void GobGame::set_resolution(int screen_x, int screen_y) {
//	panels_per_column = screen_y / PANEL_HEIGHT;
	int view_x, view_y;
	view_x = screen_x - PANEL_WIDTH;
	view_y = screen_y;
	view->set_window(screen, 0, 0, view_x, view_y);
	if (panel) {
		panel[0]->locate(view_x, 0);
		}
	return;
	}
void GobGame::add_new_enemy() {
	const int num_enemy_types = 15;
	static char *enemy_types[num_enemy_types] = {
		"thrto", "zfpst", "shosc", 
		"ktesa", "kahbo", "syrpe", 
		"druma", "mmrxf", "kzedr", 
		"virli", "earcr", "plopl", 
		"chmav", "herex", "yehte"
		};
	int i;
	for (i = 0; i < num_players; i += 1)  {
		if (!gobenemy[i] || gobenemy[i]->ship) continue;
		if (panel[i]) delete panel[i];
		panel[i] = NULL;
		int e = 99999;
		while (e >= num_enemy_types) {
			e = (2 + game_time / 30 / 1000);
			e = random() % (e + 1);
			e = random() % (e + 1);
			e = random() % (e + 1);
			e = random() % (e + 1);
			e = e*3 + (random() % 3);
			}
		Ship *ship = create_ship(channel_server2, enemy_types[e], "WussieBot", random() % (int)width, random() % (int)height, random() % 360, enemy_team);
		addItem(ship->get_ship_phaser());
		gobenemy[i]->ship = ship;
		gobenemy[i]->starbucks = 1+e/3;
		if (!strcmp(enemy_types[e], "shosc")) ((ShofixtiScout*)ship)->specialDamage /= 2;
		int b = ((e-9)+2) / 3;
		if (b < 0) b = 0;
		gobenemy[i]->buckazoids = b;
		panel[i] = new ShipPanel(ship);
		panel[i]->hide();
		addItem(panel[i]->ship->get_ship_phaser());
		control[i]->select_ship(panel[i]->ship, panel[i]->ship->data->type->id);
		for (int t = first_gob_player; t < first_gob_player + max_gob_players; t += 1) {
//			if (control[t] && control[t]->ship) control[i]->add_target(panel[t]->ship);
//			if (control[t]) control[t]->add_target(control[i]->ship);
			}
		return;
		}
	return;
	}







void GobEnemy::set_index(int i) {
	index = i;
	ship = NULL;
	return;
	}
int GobPlayer::charge (char *name, int price_starbucks, int price_buckazoids) {
	char buffy1[512];
	sprintf(buffy1, "Price: %d starbucks plus %d buckazoids", price_starbucks, price_buckazoids);
	if ((starbucks < price_starbucks) || (buckazoids < price_buckazoids)) {
		alert("You don't have enough.", name, buffy1, "Cancel", NULL, 0, 0);
		return 0;
		}
	int r = alert ("Do you wish to make this purchase?", name, buffy1, "&No", "&Yes", 'n', 'y');
	if (r == 2) {
		starbucks -= price_starbucks;
		buckazoids -= price_buckazoids;
		return 1;
		}
	return 0;
	}
void GobPlayer::set_index(int i) {
	index = i;
	ship = NULL;
	return;
	}
void GobPlayer::new_ship(shiptype_type *type) {
	Ship *old = ship;
	double x, y, a;
	int i;
	x = y = a = 0;
	if (old) {
		x = old->normal_x();
		y = old->normal_y();
		a = old->get_angle();
		}
	else {
		starbucks = 0;
		buckazoids = 0;
		kills = 0;
		total = 0;
		value_buckazoids = 0;
		value_starbucks = 0;
		}

	load_ship_data(type);
	char buffy[256];
	sprintf (buffy, "./ships/%s.ini", type->id);
	gobgame->log_file(buffy);
	ship = type->getShip(x, y, a, random());
	gobgame->control[index]->select_ship(ship, type->id);

	for (i = 0; upgrade_list[i]; i += 1) {
		upgrade_list[i]->clear(old, ship, this);
		}
	if (old) {
		old->state = 0;
		game->addItem(ship);
		}
	else game->addItem(ship->get_ship_phaser());
	if (game->panel[index]) delete game->panel[index];
	game->panel[index] = new ShipPanel(ship);
	game->panel[index]->locate(screen_x - PANEL_WIDTH, 0);
	game->control[index]->select_ship(ship, "Captain Kablooey");
	for (i = gobgame->first_gob_enemy; i < gobgame->first_gob_enemy + gobgame->max_gob_enemies; i += 1) {
//		if (gobgame->control[i]) gobgame->control[i]->add_target(ship);
		}
	return;
	}
void Station::buy_new_ship_menu(GobPlayer *s) {
	char buffy1[512], buffy2[512];
	shiptype_type *otype = shiptype(s->ship->data->type->id);
	shiptype_type *ntype = shiptype(build_type);
	if (otype == ntype) {
		sprintf (buffy1, "You already have a %s", ntype->name);
		alert(buffy1, NULL, NULL, "&Cancel", NULL, 'c', 0);
		return;
		}
	int ossb = (s->value_starbucks*3) / 4 + (s->ship->data->type->cost*1)/1;
	int osbz = (s->value_buckazoids*3) / 4 + (s->ship->data->type->cost*1)/1;
	int nssb = ntype->cost;
	int nsbz = ntype->cost;
	sprintf (buffy1, "You have a %s worth %d s$ / %d b$", otype->name, ossb, osbz);
	sprintf (buffy2, "A %s costs %d s$ / %d b$", ntype->name, nssb, nsbz);
	if ((nssb <= (ossb + s->starbucks)) && (nsbz <= (osbz + s->buckazoids))) {
		if (alert(buffy1, buffy2, "Do you wish to buy it?", "Yeah!", "No", 'y', 'n') == 1) {
			s->starbucks -= nssb - ossb;
			s->buckazoids -= nsbz - osbz;
			s->new_ship(ntype);
			}
		}
	else alert (buffy1, buffy2, "You don't have enough to buy it", "Cancel", NULL, 0, 0);
	return;
	}

Station::Station ( SpaceSprite *pic, SpaceLocation *orbit_me, char *ship, char *background) : 
		SpaceObject(NULL, orbit_me->normal_x(), orbit_me->normal_y(), random() % 360, pic) 
	{
	build_type = ship;
	background_pic = background;
	layer = LAYER_CBODIES;
	mass = 99;
	planet = orbit_me;
	radius = random() % 200 + 500;
	x -= cos(angle * PI / 180) * radius;
	y -= sin(angle * PI / 180) * radius;
	accelerate(this, angle +90 + 180*(random()&1), 0.15, GLOBAL_MAXSPEED);
	}

#define STATION_DIALOG_DEPART  0
#define STATION_DIALOG_UPGRADE 1
#define STATION_DIALOG_NEWSHIP 2
#define STATION_DIALOG_REPAIR  3
static DIALOG station_dialog[] =
{// (dialog proc)     (x)   (y)   (w)   (h)   (fg)  (bg)  (key) (flags)     (d1)  (d2)  (dp)
  { d_button_proc,     385,  50,   150,  30,   255,  0,    0,    D_EXIT,     0,    0,    (void *)"Depart Station" , NULL, NULL },
  { d_button_proc,     385,  90,   150,  30,   255,  0,    0,    D_EXIT,     0,    0,    (void *)"Upgrade Ship" , NULL, NULL },
  { d_button_proc,     385,  130,  150,  30,   255,  0,    0,    D_EXIT,     0,    0,    (void *)"Buy New Ship" , NULL, NULL },
  { d_button_proc,     385,  170,  150,  30,   255,  0,    0,    D_EXIT,     0,    0,    (void *)"Repair Ship" , NULL, NULL },
  { d_text_proc,       185,  420,  270,  30,   255,  0,    0,    0,          0,    0,    dialog_string[0], NULL, NULL },
  { NULL,              0,    0,    0,    0,    255,  0,    0,    0,          0,    0,    NULL, NULL, NULL }
};
void Station::station_screen(GobPlayer *s) {
	set_dialog_color(station_dialog, pallete_color[0], pallete_color[15]);
	BITMAP *background = load_bitmap(background_pic, NULL);
	if (!background) {
		message.print(1000, 15, "%s", background_pic);
		error ("couldn't load station background");
		}
	stretch_blit(background, screen, 0, 0, background->w, background->h, 0, 0, screen_x, screen_y);
	while (true) {
		sprintf(dialog_string[0], "%03d Starbucks  %03d Buckazoids", s->starbucks, s->buckazoids);
		int r = do_dialog(station_dialog, STATION_DIALOG_DEPART);
		switch (r) {
			case STATION_DIALOG_UPGRADE: {
				upgrade_menu(this, s);
				stretch_blit(background, screen, 0, 0, background->w, background->h, 0, 0, screen_x, screen_y);
				}
			break;
			case STATION_DIALOG_NEWSHIP: {
				buy_new_ship_menu(s);
				}
			break;
			case STATION_DIALOG_REPAIR: {
				if (s->ship->crew == s->ship->crew_max) {
					alert("You don't need repairs", "", "", "Oh, okay", "I knew that", 0, 0);
					break;
					}
				int p = alert3("Which would you prefer", "to pay for your repairs", "", "1 &Starbuck", "1 &Buckazoid", "&Nothing!", 's', 'b', 'n');
				switch (p) {
					case 1: {
						if (s->starbucks) {
							s->starbucks -= 1;
							s->ship->crew = s->ship->crew_max;
							}
						else {
							alert("You don't have enough!", NULL, NULL, "&Shit", NULL, 's', 0);
							}
						}
					break;
					case 2: {
						if (s->buckazoids) {
							s->buckazoids -= 1;
							s->ship->crew = s->ship->crew_max;
							}
						else {
							alert("You don't have enough!", NULL, NULL, "&Shit", NULL, 's', 0);
							}
						}
					break;
					case 3: {
						r = STATION_DIALOG_DEPART;
						}
					break;
					}
				}
			break;
			}
		if (r == STATION_DIALOG_DEPART) break;
		}
	return;
	}
void Station::inflict_damage(SpaceObject *other) {
	SpaceObject::inflict_damage(other);
	if (!other->isShip()) return;
	int i;
	for (i = gobgame->first_gob_player; i < gobgame->first_gob_player + gobgame->max_gob_players; i += 1) {
		if (gobgame->gobplayer[i] && (gobgame->gobplayer[i]->ship == other)) {
			gobgame->pause();
			station_screen(gobgame->gobplayer[i]);
			gobgame->unpause();
			}
		}
	return;
	}
void Station::calculate() {
	angle = trajectory_angle(planet) + 180;
  sprite_index = ((int)(angle / 5.625) + 24) & 63;
	double r = distance(planet) / radius;
	if (r < 1) {
		accelerate(this, trajectory_angle(planet), 0.0001 * (r-1) * frame_time, GLOBAL_MAXSPEED);
		}
	else {
		accelerate(this, 180+trajectory_angle(planet), 0.0001 * (1-r) * frame_time, GLOBAL_MAXSPEED);
		if (r > 4) translate(cos(angle*ANGLE_RATIO) * radius*(4-r), sin(angle*ANGLE_RATIO) * radius*(4-r));
		}
	if (random() & 3) return;
	double  va, vb, a, dx, dy;
	dx = x - nearest_x(planet);
	dy = y - nearest_y(planet);
	a = sqrt(dx*dx + dy*dy);
	dx /= a;
	dy /= a;
	va = vx * dx + vy * dy;
	vb = vx * dy - vy * dx;
	if ((r > 1) && (va > 0)) {
		va *= 1 - 0.001 * frame_time;
		}
	else if ((r < 1) && (va < 0)) {
		vb *= 1 + 0.001 * frame_time;
		va *= 1 - 0.001 * frame_time;
		}
	vx = va * cos(angle*PI/180) + vb * sin(angle*PI/180);
	vy = va * sin(angle*PI/180) - vb * cos(angle*PI/180);
	return;
	}



int num_upgrade_indexes;
int upgrade_index[999];
char *upgradeListboxGetter(int index, int *list_size) {
	static char tmp[150];
	if(index < 0) {
		*list_size = num_upgrade_indexes;
		return NULL;
		}
	int i = upgrade_index[index];
	sprintf(tmp, "%1d %3d s$ / %3d b$  :  %s", upgrade_list[i]->num, upgrade_list[i]->starbucks, upgrade_list[i]->buckazoids, upgrade_list[i]->name);
	return tmp;
	}
#define UPGRADE_DIALOG_EXIT 0
#define UPGRADE_DIALOG_LIST 3
static DIALOG upgrade_dialog[] =
{// (dialog proc)     (x)   (y)   (w)   (h)   (fg)  (bg)  (key) (flags)     (d1)  (d2)  (dp)
  { d_button_proc,     10,  415,  170,  30,   255,  0,    0,    D_EXIT,     0,    0,    (void *)"Station menu" , NULL, NULL },
  { d_textbox_proc,    20,  40,   250,  40,   255,  0,    0,    D_EXIT,     0,    0,    (void *)"Upgrade Menu", NULL, NULL },
  { d_text_proc,       10,  100,  540,  20,   255,  0,    0,    D_EXIT,     0,    0,    (void *)" # Starbucks Buckazoids Description                     ", NULL, NULL },
  { d_list_proc,       10,  120,  540,  280,  255,  0,    0,    D_EXIT,     0,    0,    (void *) upgradeListboxGetter, NULL, NULL },
  { d_text_proc,       185, 420,  270,  30,   255,  0,    0,    0,          0,    0,    dialog_string[0], NULL, NULL },
  { NULL,              0,    0,    0,    0,   255,  0,    0,    0,          0,    0,    NULL, NULL, NULL }
};

void Station::upgrade_menu(Station *station, GobPlayer *gs) {
	set_dialog_color(upgrade_dialog, pallete_color[0], pallete_color[15]);
	int i;
	clear_to_color(screen, palette_color[8]);
	while (true) {
		sprintf(dialog_string[0], "%03d Starbucks  %03d Buckazoids", gs->starbucks, gs->buckazoids);
		int j = 0;
		for (i = 0; upgrade_list[i]; i += 1) {
			if (upgrade_list[i]->update(gs->ship, station, gs)) {
				upgrade_index[j] = i;
				j += 1;
				}
			}
		num_upgrade_indexes = j;
		int m = do_dialog(upgrade_dialog, UPGRADE_DIALOG_EXIT);
		if (m == UPGRADE_DIALOG_EXIT) return;
		if (m == UPGRADE_DIALOG_LIST) {
			int i = upgrade_dialog[UPGRADE_DIALOG_LIST].d1;
			i = upgrade_index[i];
			Upgrade *u = upgrade_list[i];
			if (gs->charge(u->name, u->starbucks, u->buckazoids)) {
				u->execute(gs->ship, station, gs);
				u->charge(gs);
				}
			}
		}
	return;
	}







void Upgrade::clear(Ship *oship, Ship *nship, GobPlayer *gs) {
	gs->total -= num;
	num = 0;
	return;
	}
void Upgrade::charge(GobPlayer *gs) {
	gs->total += 1;
	num += 1;
	gs->value_starbucks += this->starbucks;
	gs->value_buckazoids += this->buckazoids;
	return;
	}

class UpCrewpod : public Upgrade {
	bool update(Ship *ship, Station *station, GobPlayer *gs) {
		if (ship->crew_max >= 42) return false;
		name = "Crewpod";
		starbucks = 2;
		buckazoids = gs->total / 3;
		return true;
		}
	void execute(Ship *ship, Station *station, GobPlayer *gs) {
		ship->crew_max += 4;
		if (ship->crew_max > 42) ship->crew_max = 42;
		ship->crew += 4;
		if (ship->crew > 42) ship->crew = 42;
		}
	} crewpod;

class UpBattery : public Upgrade {
	bool update(Ship *ship, Station *station, GobPlayer *gs) {
		if (ship->batt_max >= 42) return false;
		name = "Battery";
		starbucks = 1;
		buckazoids = gs->total / 3;
		return true;
		}
	void execute(Ship *ship, Station *station, GobPlayer *gs) {
		ship->batt_max += 8;
		if (ship->batt_max > 42) ship->batt_max = 42;
		ship->batt += 8;
		if (ship->batt > 42) ship->batt = 42;
		}
	} battery;

class UpThrusters : public Upgrade {
	bool update(Ship *ship, Station *station, GobPlayer *gs) {
		name = "Thrusters";
		starbucks = 3 + num * 3;
		buckazoids = gs->total / 3;
		return true;
		}
	void execute(Ship *ship, Station *station, GobPlayer *gs) {
		ship->speed_max *= 1.3;
		ship->accel_rate *= 1.18;
		}
	} thrusters;

class UpControlJets : public Upgrade {
	bool update(Ship *ship, Station *station, GobPlayer *gs) {
		name = "Control Jets";
		starbucks = 2 + num * 2;
		buckazoids = gs->total / 3;
		return true;
		}
	void execute(Ship *ship, Station *station, GobPlayer *gs) {
		ship->turn_rate *= 1.3;
		ship->accel_rate *= 1.05;
		}
	} controljets;

class UpDynamo : public Upgrade {
	bool update(Ship *ship, Station *station, GobPlayer *gs) {
		starbucks = 16 / (1 + ship->recharge_amount-num) + num;
		if (!strcmp("supbl", ship->data->type->id)) starbucks /= 2;
		name = "Dynamo";
		buckazoids = gs->total / 3;
		return true;
		}
	void execute(Ship *ship, Station *station, GobPlayer *gs) {
		ship->recharge_amount += 1;
		}
	} dynamo;

class UpSupoxRange : public Upgrade {
	bool update(Ship *ship, Station *station, GobPlayer *gs) {
		if (strcmp("supbl", ship->data->type->id)) return false;
		name = "Increase Range (Supox)";
		starbucks = 2 + num;
		buckazoids = gs->total / 3;
		return true;
		}
	void execute(Ship *ship, Station *station, GobPlayer *gs) {
		((SupoxBlade*)ship)->weaponRange *= 1.25;
		((SupoxBlade*)ship)->weaponVelocity *= 1.15;
		}
	} supoxrange;

class UpSupoxDamage : public Upgrade {
	bool update(Ship *ship, Station *station, GobPlayer *gs) {
		if (strcmp("supbl", ship->data->type->id)) return false;
		if (gs->ship->recharge_amount < (1<<num)) return false;
		if (num > 7) return false;
		name = "Increase Damage (Supox)";
		starbucks = 5;
		buckazoids = gs->total / 3;
		return true;
		}
	void execute(Ship *ship, Station *station, GobPlayer *gs) {
		((SupoxBlade*)ship)->weaponDamage += 1;
		((SupoxBlade*)ship)->weaponArmour += 1;
		((SupoxBlade*)ship)->weapon_drain += num + 1;
		if (num > 1) ((SupoxBlade*)ship)->recharge_amount += 1;
		}
	} supoxdamage;

class UpSupoxBLADE : public Upgrade {
	bool update(Ship *ship, Station *station, GobPlayer *gs) {
		if (strcmp("supbl", ship->data->type->id)) return false;
		name = "B.L.A.D.E. (Supox)";
		starbucks = 2 + num;
		buckazoids = gs->total / 3;
		return true;
		}
	void execute(Ship *ship, Station *station, GobPlayer *gs) {
		((SupoxBlade*)ship)->damage_factor += 3;
		}
	} supoxblade;

class UpOrzMissile : public Upgrade {
	bool update(Ship *ship, Station *station, GobPlayer *gs) {
		if (strcmp("orzne", ship->data->type->id)) return false;
		name = "Upgrade Missiles (ORZ)";
		starbucks = 6;
		buckazoids = gs->total / 2 + 2;
		return true;
		}
	void execute(Ship *ship, Station *station, GobPlayer *gs) {
		((OrzNemesis*)ship)->weaponDamage += 1;
		((OrzNemesis*)ship)->weaponArmour += 1;
		((OrzNemesis*)ship)->weaponRange *= 1.15;
		((OrzNemesis*)ship)->weapon_drain += 1;
		}
	} orzmissile;

class UpOrzMarineSpeed : public Upgrade {
	bool update(Ship *ship, Station *station, GobPlayer *gs) {
		if (strcmp("orzne", ship->data->type->id)) return false;
		name = "Increase Marine Speed (ORZ)";
		starbucks = 3 + num * 2;
		buckazoids = gs->total / 3;
		return true;
		}
	void execute(Ship *ship, Station *station, GobPlayer *gs) {
		((OrzNemesis*)ship)->specialSpeedMax *= 1.2;
		((OrzNemesis*)ship)->specialAccelRate *= 1.2;
		}
	} orzmarinespeed;

class UpOrzAbsorbtion : public Upgrade {
	bool update(Ship *ship, Station *station, GobPlayer *gs) {
		if (strcmp("orzne", ship->data->type->id)) return false;
		if (num) return false;
		name = "Absorbtion (ORZ)";
		starbucks = 15;
		buckazoids = gs->total / 3;
		return true;
		}
	void execute(Ship *ship, Station *station, GobPlayer *gs) {
		((OrzNemesis*)ship)->absorption = 256 / 3;
		}
	void charge(GobPlayer *gs) {
		Upgrade::charge(gs);
		gs->total += 2;
		}
	} orzabsorption;

class UpKohrAhBladeDamage : public Upgrade {
	bool update(Ship *ship, Station *station, GobPlayer *gs) {
		if (strcmp("kohma", ship->data->type->id)) return false;
		name = "Increase Shuriken Sharpness (Kohr-Ah)";
		starbucks = 2 + num;
		buckazoids = gs->total / 3;
		return true;
		}
	void execute(Ship *ship, Station *station, GobPlayer *gs) {
		((KohrAhMarauder*)ship)->weaponDamage += 1;
		((KohrAhMarauder*)ship)->weaponArmour += 1;
		((KohrAhMarauder*)ship)->weapon_drain += 1;
		}
	} kohrahbladedamage;

class UpKohrAhBladeSpeed : public Upgrade {
	bool update(Ship *ship, Station *station, GobPlayer *gs) {
		if (strcmp("kohma", ship->data->type->id)) return false;
		name = "Increase Shuriken Velocity (Kohr-Ah)";
		starbucks = 2 + num * 2;
		buckazoids = gs->total / 3;
		return true;
		}
	void execute(Ship *ship, Station *station, GobPlayer *gs) {
		((KohrAhMarauder*)ship)->weaponVelocity *= 1.2;
		}
	} kohrahbladespeed;

class UpKohrAhFireRange : public Upgrade {
	bool update(Ship *ship, Station *station, GobPlayer *gs) {
		if (strcmp("kohma", ship->data->type->id)) return false;
		if (num) return false;
		name = "double F.R.I.E.D. range (Kohr-Ah)";
		starbucks = 30;
		buckazoids = gs->total / 3;
		return true;
		}
	void execute(Ship *ship, Station *station, GobPlayer *gs) {
		((KohrAhMarauder*)ship)->specialRange *= 2;
		((KohrAhMarauder*)ship)->specialVelocity *= 1.4;
		}
	} kohrahfirerange;

class UpKohrAhFireDamage : public Upgrade {
	bool update(Ship *ship, Station *station, GobPlayer *gs) {
		if (strcmp("kohma", ship->data->type->id)) return false;
		if (num) return false;
		name = "double F.R.I.E.D. damage (Kohr-Ah)";
		starbucks = 13;
		buckazoids = gs->total / 3;
		return true;
		}
	void execute(Ship *ship, Station *station, GobPlayer *gs) {
		((KohrAhMarauder*)ship)->specialDamage *= 2;
		}
	} kohrahfiredamage;

class UpDivineFavor : public Upgrade {
	bool update(Ship *ship, Station *station, GobPlayer *gs) {
		if (strcmp(station->build_type, "orzne")) return false;
		if (gs->divine_favor) return false;
		name = "Divine Favor (unique)";
		starbucks = 80;
		buckazoids = 0;
		return true;
		}
	void execute(Ship *ship, Station *station, GobPlayer *gs) {
		gs->divine_favor = true;
		}
	void clear(Ship *oship, Ship *nship, GobPlayer *gs) {
		if (!oship) gs->divine_favor = false;
		return;
		}
	void charge(GobPlayer *gs) {
		}
	} divinefavor;

Upgrade *_upgrade_list[] = {
	&crewpod, 
	&battery,
	&thrusters,
	&controljets,
	&dynamo,
	&supoxrange,
	&supoxdamage,
	&supoxblade,
	&orzmissile,
	&orzmarinespeed,
	&orzabsorption,
	&kohrahbladedamage,
	&kohrahbladespeed,
	&kohrahfirerange,
	&kohrahfiredamage,
	&divinefavor,
	NULL
	};

Upgrade **upgrade_list = _upgrade_list;

//REGISTER_GAME(GobGame, "GOB")
*/


/* intended upgrades:

faster marines       == faster Orz Marines, cost 4s
upgrade battle armor == tougher Orz Marines, cost 4s/4b
improve range        == long range Orz cannons, cost 3s
regeneration         == crew regeneration for Orz, cost 10s/25b, only purchasable once
sharper shurikens    == +1 damage for Kohr-Ah blades, cost 5s
faster shurikens     == higher velocity for Kohr-Ah blades, cost 4s
larger corona        == longer range for Kohr-Ah FRIED, cost 15s, only purchasable once
hotter corona        == double damage for Kohr-Ah FRIED, cost 10s, only purchasable once
divine favor         == pkunk respawn, only available from one base, cost 48s/0b, only purchasable once, kept when ship is sold
sentinel system      == Chmmr ZapSats, only available from one base, cost 30s/30b
long range scanners  == can zoom farther out, gives radar, only available from one base, cost 8s/20b

*/
