/*
#ifndef _MELEE_H
#include "../melee.h"
#endif
#ifndef _MFRAME_H
#include "../melee/mframe.h"
#endif
#ifndef _MGAME_H
#include "../melee/mgame.h"
#endif

class GobPlayer {
	public:
	Ship *ship;
	int total;
	int starbucks;
	int buckazoids;
	int kills;
	int value_starbucks;
	int value_buckazoids;
	int index;
	void set_index(int i);
	void new_ship(shiptype_type *type);
	int charge (char *name, int price_starbucks, int price_buckazoids) ;


	int divine_favor;
	} ;

class GobEnemy {
	public:
	View *old_view;
	Ship *ship;
	int starbucks;
	int buckazoids;
	int index;
	void set_index(int i);
	} ;

class GobAsteroid : public Asteroid {
	public:
	virtual void handle_damage(SpaceLocation *source);
	};

class GobGame : public Game {

	public:
	virtual ~GobGame();

	TeamCode enemy_team;

	virtual void calculate(int time);
	virtual void ship_died(Ship *who, SpaceLocation *source);
	virtual void preinit();
	virtual void init (Log *log);

	virtual void set_resolution(int screen_x, int screen_y) ;

	int gobplayers
	GobPlayer **gobplayer;
	int gobenemies;
	GobEnemy **gobenemy;

	protected:
	virtual void fps ();


	void add_new_enemy();

	int next_add_new_enemy_time;

	SpaceSprite *stationSprite[3];
	char *station_pic_name[3];
	char *station_build_name[3];
	};

class Station : public SpaceObject {
	public:
	double radius;
	SpaceLocation *planet;
	char *build_type;
	char *background_pic;
	Station ( SpaceSprite *pic, SpaceLocation *orbit_me, char *ship, char *background);
	virtual void buy_new_ship_menu(GobPlayer *s) ;
	virtual void calculate();
	virtual void inflict_damage(SpaceObject *other);
	virtual void station_screen (GobPlayer *s);
	virtual void upgrade_menu(Station *station, GobPlayer *gs) ;
	};


class Upgrade {
	public:
	enum {
		active, inactive
		};
	char *name;
	int starbucks;
	int buckazoids;
	int status;
	int num;
	virtual bool update(Ship *ship, Station *station, GobPlayer *gp) = 0;
//true if listed
	virtual void execute(Ship *ship, Station *station, GobPlayer *gp) = 0;
	virtual void charge(GobPlayer *gp);
	virtual void clear(Ship *oship, Ship *nship, GobPlayer *gp);
	};
extern Upgrade **upgrade_list;

*/