#include <allegro.h>

#include "../melee.h"

#include "../melee/mframe.h"
#include "../melee/mgame.h"
#include "../melee/mmain.h"
#include "../melee/mview.h"
#include "../melee/mcbodies.h"

class HyperMelee : public NormalGame {
	double friction;
	virtual void calculate(int time);
	virtual void init(Log *_log);
	virtual void set_resolution (int screen_x, int screen_y);
	virtual void init_objects();
	};

void HyperMelee::init_objects() {
	Planet *p;
	int i, m;
	log_file("server.ini");
	m = get_config_int("Hyperspace", "Pholes", 2);
	for (i = 0; i < m; i += 1) {
		p = new Planet (random()%int(width), random()%int(height), hotspotSprite, random()%hotspotSprite->frames());
		p->collide_flag_anyone = 0;
		p->gravity_force *= 0.5;
		p->accelerate(NULL, random() % 360, 0.1 + (random()%36)/100., GLOBAL_MAXSPEED);
		addItem (p);
		}
	m = get_config_int("Hyperspace", "Nholes", 2);
	for (i = 0; i < m; i += 1) {
		p = new Planet (random()%int(width), random()%int(height), hotspotSprite, random()%hotspotSprite->frames());
		p->collide_flag_anyone = 0;
		p->gravity_force *= -1;
		p->accelerate(NULL, random() % 360, 0.1 + (random()%36)/100., GLOBAL_MAXSPEED);
		addItem (p);
		}
	}

void HyperMelee::init(Log *_log) {
	NormalGame::init(_log);
	turbo *= 1.414;
	log_file("server.ini");
	friction = get_config_float("Hyperspace", "Friction", 0.0006);
	//units on friction are fraction of velocity lost per millisecond
	return;
	}

void HyperMelee::set_resolution (int screen_x, int screen_y) {
	NormalGame::set_resolution(screen_x, screen_y);
	view->set_background(makecol(64,0,0));
	return;
	}

void HyperMelee::calculate(int time) {
	int i;
	for (i = 0; i < num_items; i += 1) {
		if (item[i]->exists() && !item[i]->isPlanet()) {
			item[i]->vx *= 1 - friction * time;
			item[i]->vy *= 1 - friction * time;
			}
		}
	NormalGame::calculate(time);
	}

REGISTER_GAME ( HyperMelee, "Melee in Hyperspace");