#include <string.h>
#include <allegro.h>
#include "melee.h"
REGISTER_FILE
#include "libs.h"

#ifndef NO_ALLEGRO_4
char *key_string[128] = {
   "(none)",     "A",          "B",          "C",         //  0 -   3
   "D",          "E",          "F",          "G",         //  4 -   7
   "H",          "I",          "J",          "K",         //  8 -  11
   "L",          "M",          "N",          "O",         // 12 -  15
   "P",          "Q",          "R",          "S",         // 16 -  19
   "T",          "U",          "V",          "W",         // 20 -  23
   "X",          "Y",          "Z",          "0",         // 24 -  27
   "1",          "2",          "3",          "4",         // 28 -  31
   "5",          "6",          "7",          "8",         // 32 -  35
   "9",          "0_PAD",      "1_PAD",      "2_PAD",     // 36 -  39
   "3_PAD",      "4_PAD",      "5_PAD",      "6_PAD",     // 40 -  43
   "7_PAD",      "8_PAD",      "9_PAD",      "F1",        // 44 -  47
   "F2",         "F3",         "F4",         "F5",        // 48 -  51
   "F6",         "F7",         "F8",         "F9",        // 52 -  55
   "F10",        "F11",        "F12",        "ESC",       // 56 -  59
   "TILDE",      "MINUS",      "EQUALS",     "BACKSPACE", // 60 -  63
   "TAB",        "OPENBRACE",  "CLOSEBRACE", "ENTER",     // 64 -  67
   "COLON",      "QUOTE",      "BACKSLASH",  "BACKSLASH2",// 68 -  71
   "COMMA",      "STOP",       "SLASH",      "SPACE",     // 72 -  75
   "INSERT",     "DEL",        "HOME",       "END",       // 76 -  79
   "PGUP",       "PGDN",       "LEFT",       "RIGHT",     // 80 -  83
   "UP",         "DOWN",       "SLASH_PAD",  "ASTERISK",  // 84 -  87
   "MINUS_PAD",  "PLUS_PAD",   "DEL_PAD",    "ENTER_PAD", // 88 -  91
	"PRTSCR",     //  92
	"PAUSE",      //  93
	"ABNT_C1",    //  94
	"YEN",        //  95
	"KANA",       //  96
	"CONVERT",    //  97
	"NOCONVERT",  //  98
	"AT",         //  99
	"CIRCUMFLEX", // 100
	"COLON2",     // 101
	"KANJI",      // 102
	"LSHIFT",     // 103
	"RSHIFT",     // 104
	"LCONTROL",   // 105
	"RCONTROL",   // 106
	"ALT",        // 107
	"ALTGR",      // 108
	"LWIN",       // 109
	"RWIN",       // 110
	"MENU",       // 111
	"SCRLOCK",    // 112
	"NUMLOCK",    // 112
	"CAPSLOCK",   // 114
	NULL,         // 115
	NULL, NULL, NULL, NULL, // 116-119
	NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL //120-127
	};
#else
char *key_string[128] = {
		"(none)",     "ESC",        "1",          "2",					// 0-3*
		"3",          "4",          "5",          "6",					// 4-7
		"7",          "8",          "9",          "0",					// 8-11
		"MINUS",      "EQUALS",     "BACKSPACE",  "TAB",				//12-15
		"Q",          "W",          "E",          "R",					//16-19*
		"T",          "Y",          "U",          "I",					//20-23
		"O",          "P",          "OPENBRACE",  "CLOSEBRACE",	//24-27
		"ENTER",      "RCONTROL",   "A",          "S",					//28-31
		"D",          "F",          "G",          "H",					//32-35*
		"J",          "K",          "L",          "COLON",			//36-39
		"QUOTE",      "TILDE",     "LSHIFT",     "BACKSLASH",		//40-43
		"Z",          "X",          "C",          "V",					//44-47
		"B",          "N",          "M",          "COMMA",			//48-51*
		"STOP",       "SLASH",      "RSHIFT",     "ASTERISK",		//52-55
		"SLASH_PAD",  "SPACE",      "CAPSLOCK",   "F1",					//56-59
		"F2",         "F3",         "F4",         "F5",					//60-63
		"F6",         "F7",         "F8",         "F9",					//64-67*
		"F10",        "(none)",     "(none)",     "7_PAD",			//68-71
		"8_PAD",			"9_PAD",      "(none)",     "4_PAD",			//72-75
		"5_PAD",      "6_PAD",      "PLUS_PAD",   "1_PAD",			//76-79
		"DOWN",       "PGDN",       "INS_PAD",    "DEL_PAD",		//80-83*
		"(none)",     "(none)",     "(none)",     "F11",				//84-87
		"F12",        "(none)",     "(none)",     "(none)",			//88-91
		"(none)",     "(none)",     "(none)",     "(none)",			//92-94
		"(none)",     "(none)",     "(none)",     "(none)",			//96-99*
		"(none)",     "(none)",     "(none)",     "(none)",			//100-103
		"(none)",     "(none)",     "(none)",     "(none)",			//104-107
		"(none)",     "(none)",     "(none)",     "(none)",			//108-111
		"(none)",     "(none)",     "(none)",     "(none)",			//112-115*
		"(none)",     "(none)",     "(none)",     "(none)",			//116-119
		"(none)",     "(none)",     "(none)",     "(none)",			//120-123
		"(none)",     "(none)",     "(none)",     NULL    			//124-127
		};
#endif

int key_num(const char *name) {
	int i = 0;
	if (!name) return 0;
	while (true) {
		if (!key_string[i]) return 0;
		if (!strcmp(name, key_string[i])) return i;
		i += 1;
		}
	}

int get_key() {
	unsigned i;
	while (true) {
		poll_keyboard();
		for (i = 0; i < KEY_MAX; i += 1) {
			if (key[i]) break;
			}
		if (i != KEY_MAX) break;
		}
	if (keypressed()) readkey();
	return i;
	}
