#ifndef _MFRAME_H
#include "mframe.h"
#endif

#ifndef _MANIM_H
#define _MANIM_H


class Animation : public SpaceObject {
  protected:
  int frame_count;
  int frame_size;
  int frame_step;

  public:
	Animation(SpaceLocation *creator, double ox, double oy, SpaceSprite *osprite, 
			int first_frame, int num_frames, int frame_size, double depth) ;

  virtual void calculate();
};

class FixedAnimation : public Animation {
  SpaceLocation *pos;

  public:
	FixedAnimation(SpaceLocation *creator, SpaceLocation *opos, SpaceSprite *osprite,
		int first_frame, int num_frames, int frame_length, int olayer) ;

  virtual void calculate();
};

class PositionedAnimation : public FixedAnimation {
protected:
  double rx, ry;
  SpaceLocation *pos;

public:
  PositionedAnimation(SpaceLocation *creator, SpaceLocation *opos, double ox, double oy,
               SpaceSprite *osprite, int first_frame,
               int num_frames, int frame_length, int olayer);
  virtual void calculate();
};

#endif