
#include <string.h>
#include <stdio.h>
#include <allegro.h>

#include "../melee.h"
REGISTER_FILE
#include "../util/net_tcp.h"


const char *fleet_id[MAX_FLEET_SIZE];
const char *fleet_name[MAX_FLEET_SIZE];

char fleet_title[80];
int  fleet_size = 0;
int  fleet_cost = 0;

char strEmptySlotID[] = "?????";
char strEmptySlotName[] = "[Empty slot]";

char *shipListboxGetter(int index, int *list_size)
{
  static char shipSelection[80];
  if(index < 0) {
    *list_size = num_shiptypes;
    return NULL;
  } else {
    sprintf(shipSelection, "%2d %s", shiptypes[index].cost, shiptypes[index].name);
    return shipSelection;
  }
}

void *serialize_fleet(int *size) {
	unsigned char buffy[65536];
	int s = 0;
	int j;
	j = intel_ordering(fleet_size);
	memcpy(&buffy[s], &j, sizeof(j)); s += sizeof(j);
	for (j = 0; j < fleet_size; j += 1) {
		char k = strlen(fleet_id[j]);
		if (k > 64) error ("serialize_fleet - that's a hell of a long ship id");
		memcpy(&buffy[s], &k, sizeof(k)); s += sizeof(k);
		}
	for (j = 0; j < fleet_size; j += 1) {
		memcpy(&buffy[s], fleet_id[j], strlen(fleet_id[j])); s += strlen(fleet_id[j]);
		}
	unsigned char *holder = (unsigned char *) malloc(s);
	memcpy(holder, buffy, s);
	*size = s;
	return holder;
	}

void deserialize_fleet(void *data, int size) {
#define READ(a) if (int(s+sizeof(a))>size) {delete k;error ("deserialize_fleet - bad!");}memcpy(&a, &buffy[s], sizeof(a)); s += sizeof(a);
#define READ2(a,b) if (b+s>size) {delete k;error ("deserialize_fleet - bad!");}memcpy(&a, &buffy[s], b); s += b;
	unsigned char *buffy = (unsigned char *) data;
	int s = 0;
	int j;
	char *k = NULL;

	READ(j);
	init_fleet();
	int _fleet_size = intel_ordering(j);
	if (_fleet_size > MAX_FLEET_SIZE) error ("fleet too large! (%d ships)", _fleet_size);
	k = new char[_fleet_size];
	for (j = 0; j < _fleet_size; j += 1) {
		READ(k[j]);
		if (k[j] > MAX_SHIP_ID) {
			error ("deserialize_fleet - that's a long shipid! (%d)", k[j]);
			}
		}
	char sname[64];
	for (j = 0; j < _fleet_size; j += 1) {
		READ2(sname, k[j]);
		sname[k[j]] = '\0';
		select_fleet_slot(j, shiptype(sname));
		}
	if (s != size) error ("deserialize_fleet - didn't use all the data...");
	delete k;
#undef READ
#undef READ2
	return;
	}

void init_fleet()
{
  int i;

  for(i = 0; i < MAX_FLEET_SIZE; i++) {
    fleet_id[i] = strEmptySlotID;
    fleet_name[i] = strEmptySlotName;
  }

  fleet_size = 0;
  fleet_cost = 0;
  sprintf(fleet_title, "Untitled");
}

void select_fleet_slot(int slot, shiptype_type *type) {
	if (slot < 0) return;
	if (!type) error ("select_fleet_slot - bad type");
	if(fleet_id[slot] == strEmptySlotID)
		fleet_size++;
	else
		fleet_cost -= shiptype(fleet_id[slot])->cost;
	fleet_cost += type->cost;

	fleet_id[slot] = type->id;
	fleet_name[slot] = type->name;
	return;
	}

void clear_fleet_slot(int slot)
{
	if (slot < 0) return;
  if(fleet_id[slot] == strEmptySlotID)
    return;

  fleet_cost -= shiptype(fleet_id[slot])->cost;
  fleet_id[slot] = strEmptySlotID;
  fleet_name[slot] = strEmptySlotName;
  fleet_size--;
}

void save_fleet(const char *filename, const char *section) {
	int i, count = 0;
	char slot_str[8];

	if (filename) set_config_file(filename);

	for(i = 0; i < MAX_FLEET_SIZE; i++) {
		if(strcmp(fleet_id[i], strEmptySlotID) != 0) {
			  sprintf(slot_str, "Slot%d", count);
			  set_config_string(section, slot_str, fleet_id[i]);
			  count++;
			}
		}

	for(i = count; i < MAX_FLEET_SIZE; i++) {
		sprintf(slot_str, "Slot%d", i);
		set_config_string(section, slot_str, NULL);
		}

	set_config_int(section, "Size", count);
	set_config_string(section, "Title", fleet_title);

	return;
	}

int ship_idtoindex(const char *id_str)
{
  int i = 0, found = FALSE;

  if(id_str == NULL) return -1;

  while((i < num_shiptypes) && (!found)) {
    if(strcmp(id_str, shiptypes[i].id) == 0)
      found = TRUE;
    else
      i++;
  }

  if(found)
     return(i);
  else
    return(-1);
}

void load_fleet(const char *filename, const char *section) {
  int i, count;
	shiptype_type *type;
  char slot_str[8];
  const char *slot_id, *title;

  init_fleet();

  if (filename) set_config_file(filename);
  fleet_size = get_config_int(section, "Size", 0);
  title = get_config_string(section, "Title", "");
  sprintf(fleet_title, title);

	count = 0;
  for(i = 0; i < fleet_size; i++) {
		sprintf(slot_str, "Slot%d", i);
		slot_id = get_config_string(section, slot_str, "?????");
		type = shiptype(slot_id);
		if (type) {
			select_fleet_slot(count, type );
			count += 1;
			}
		}
	fleet_size = count;
	return;
	}

char *fleetListboxGetter(int index, int *list_size)
{
  if(index < 0) {
    *list_size = MAX_FLEET_SIZE;
    return NULL;
  } else
    return (char *) fleet_name[index];
}

