
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <time.h>
#include <allegro.h>

#include "../melee.h"
REGISTER_FILE
#include "../scp.h"


#include "mmain.h"
#include "mview.h"
#include "mcontrol.h"
#include "mcbodies.h"
#include "mshppan.h"
#include "mship.h"
#include "mlog.h"
#include "mnet1.h"

/*void Game::player_said(int who, const char *what) {
	if ((who < 0) || (who >= num_players)) error ("Who said that?!?");
	message.print(8000, 15, "%s: %s", name[who], what);
	return;
	}*/
int NormalGame::add_player (Control *c, const char *name, const char *fleet, const char *fleet_file) {
	int i = num_players;
	num_players += 1;
	player_control = (Control**) realloc(player_control,     sizeof(Control*)   * num_players);
	player_name    =    (char**) realloc(player_name,        sizeof(char*)      * num_players);
	player_panel = (ShipPanel**) realloc(player_panel,       sizeof(ShipPanel*) * num_players);
	player_team =    (TeamCode*) realloc(player_team,   sizeof(TeamCode) * num_players);
	player_control[i] = c;
	add_focus(c, c->channel);
	player_panel[i] = NULL;
	player_name[i] = strdup(name);
	player_team[i] = new_team();
	char sect[40];
	sprintf(sect, "Player%d", i+1);
	if (c->channel == channel_none) {
		error("channel_none not allowed here");
		log_file(fleet_file);
		load_fleet(NULL, fleet);
		}
	else if (log->get_direction(c->channel) & Log::direction_write) {
		load_fleet(fleet_file, fleet);
		log_fleet(c->channel);
		}
	else {
		log_fleet(c->channel);
		}
	set_config_file("tmp.ini");
	set_config_string(sect, "Name", name);
	set_config_string(sect, "Type", c->getTypeName());
	set_config_int(sect, "Channel", c->channel);
	set_config_int(sect, "StartingFleetCost", fleet_cost);
	set_config_int(sect, "StartingFleetSize", fleet_size);
	save_fleet(NULL, sect);
	save_fleet("fleets.tmp", sect);
	return i;
	}
void NormalGame::init_objects() {
	int i;
	addItem (new Planet (width/2, height/2, planetSprite, random() % planetSprite->frames()));
	for (i = 0; i < num_asteroids; i += 1) addItem(new Asteroid());
	}
void NormalGame::init_players() {
	switch (log->type) {
		case Log::log_normal: {
			for (int i = 0; true; i += 1) {
				char buffy[64];
				sprintf(buffy, "Player%d", i + 1);
				set_config_file("scp.ini");
				const char *type = get_config_string(buffy, "Type", NULL);
				if (!type) break;
				if (strcmp(type, "none") == 0) continue;
				const char *name = get_config_string(buffy, "Name", buffy);
				char config[64];
				sprintf(config, "Config%d", get_config_int(buffy, "Config", 0));
				add_player(create_control(channel_server, type, config), name, buffy);
				}
			}
		break;
		case Log::log_net1client:
		case Log::log_net1server: {
			add_player(create_control(channel_server, "Keyboard", "Config0"), "Player 1", "Player1");
			add_player(create_control(channel_client, "Keyboard", "Config0"), "Player 2", "Player1");
			}
		break;
		}
	return;
	}

void NormalGame::set_resolution(int screen_x, int screen_y) {
	int view_x, view_y;
	view_x = screen_x;
	view_y = screen_y;
	int n, m, i;
	n = 99;//int(ceil(double(num_players) / int(view_y / PANEL_HEIGHT)));
	if (n) m = int(ceil(num_players / (double)n));
	else m = 0;
	view->set_window(screen, 0, 0, view_x - PANEL_WIDTH * m, view_y);
	if (n) for (i = 0; i < num_players; i += 1) {
		if (player_panel[i]) player_panel[i]->locate(view_x - PANEL_WIDTH * (1+i/n), (i%n) * PANEL_HEIGHT);
		}
	redraw();
	return;
	}

void NormalGame::preinit() {
	Game::preinit();
	player_control = NULL;
	player_name = NULL;
	player_panel = NULL;

	player_team = NULL;
	num_kills = 0;
	kills = NULL;
	num_players = 0;
	}
void NormalGame::init(Log *_log) {
	Game::init(_log);

	delete_file("tmp.ini");
	delete_file("fleets.tmp");
	if (!log->playback) init_players();
	log_file("tmp.ini");
	if (log->playback) {
		for (int i = 0; true; i += 1) {
			char buffy[64];
			sprintf(buffy, "Player%d", i + 1);
			log_file("tmp.ini");
			const char *type = get_config_string(buffy, "Type", NULL);
			if (!type) break;
			const char *name = get_config_string(buffy, "Name", buffy);
			int channel = get_config_int(buffy, "Channel", -2);
			add_player(create_control(channel, type), name, buffy);
			load_fleet(NULL, buffy);
			save_fleet("fleets.tmp", buffy);
			}
		}
/*
	int i;
	set_config_file("tmp.ini");
	int num_players        = get_config_int("Game", "NumPlayers", 0);
	for (i = 0; i < num_players; i += 1) {
		add_player();
		}

	char tmp[80];
	const char *t;

	for (i = 0; i < num_players; i += 1) {
		set_config_file("tmp.ini");
		sprintf (tmp, "Player%d", i+1);
		name[i] = strdup(get_config_string(tmp, "Name", "nameless"));
		panel[i] = NULL;
		load_fleet(NULL, tmp);
		total_fleet[i] = fleet_cost;
		slot[i] = -2;
		save_fleet("./fleets.tmp", tmp);
		if ((i < first_local_player) || (i >= first_local_player + num_local_players)) {
			control[i] = getController("VegetableBot", name[i]);
			}
		else {
			set_config_file("./tmp.ini");
			t = get_config_string(tmp, "Type", NULL);
			control[i] = getController(t, name[i]);
			if (!control[i]) error("bad Controller type! (%s)", t);
			sprintf(tmp, "Config%d", get_config_int(tmp, "Config", 0));
			player_control[i]->initialize();
			player_control[i]->load("scp.ini", tmp);
			}
		}*/


	prepare();
	init_objects();

	next_choose_new_ships_time = game_time + 200;

	return;
	}

NormalGame::~NormalGame() {
	if (player_control) free (player_control);
	int i;
	if (player_name) {
		for (i = 0; i < num_players; i += 1) {
			free(player_name[i]);
			}
		free(player_name);
		}
	if (player_panel) free (player_panel);

	if (player_team) free(player_team);
	if (kills) free(kills);
	}

void NormalGame::calculate(int time) {
	Game::calculate(time);
	if (next_choose_new_ships_time <= game_time) {
		choose_new_ships();
		next_choose_new_ships_time = game_time + 24*60*60*1000;
		}
	return;
	}

void NormalGame::ship_died(Ship *who, SpaceLocation *source) {
	int n = game_time + 4000;
	if (next_choose_new_ships_time > n) next_choose_new_ships_time = n;
	Game::ship_died(who, source);

	if (!(num_kills & 31)) kills = (ShipKill*) realloc(kills, (num_kills+32) * sizeof(ShipKill) );
	kills[num_kills].time = this->game_time;
	kills[num_kills].victim_type = who->data->type;
	if (who->control) kills[num_kills].victim_player = who->control->player;
	if (source && source->data) kills[num_kills].killer_type = source->data->type;
	else kills[num_kills].killer_type = NULL;
//	kills[num_kills].killer_player = get_player(source);
	num_kills += 1;
	return;
	}
void NormalGame::display_stats() {
	pause();
	int i;
	char buffy[1024];
	switch (log->type) {
		case Log::log_net1client:
		case Log::log_net1server: {
			for (i = 0; i < num_players; i += 1) {
				sprintf(buffy, "Player%d", i+1);
				load_fleet("./fleets.tmp", buffy);
//				if ((i >= first_local_player) && (i < first_local_player + num_local_players)) 
					message.print(6000, 15, "%s status: : %d / ?? Ships, %d / ??? points", buffy, fleet_size, fleet_cost);
//				else
//					message.print(6000, 15, "%s status: : %d / %d points", buffy, fleet_cost, player_total_fleet[i]);
				}
			}
		break;
		default: {
			for (i = 0; i < num_players; i += 1) {
				sprintf(buffy, "Player%d", i+1);
				load_fleet("./fleets.tmp", buffy);
				message.print(6000, 15, "%s status: : %d / ?? Ships, %d / ??? points", buffy, fleet_size, fleet_cost);
				}
			}
		break;
		}
	unpause();
	}
void NormalGame::handle_key(int k) {
	switch (k >> 8) {
		default: {
			Game::handle_key(k);
			}
		break;
		case KEY_F5: {
			display_stats();
			}
		break;
		case KEY_F7: {
			if (log->type == Log::log_normal) Game::handle_key(k);
			}
		break;
		case KEY_F9: {
			if (log->type != Log::log_normal) return;
			message.out("MUHAHAHAHAHA!!!!", 5000, 12);
			addItem(new Planet(random() % (int)width, random() % (int)height, planetSprite, random()%planetSprite->frames()));
			}
		break;
		}
	return;
	}
void NormalGame::choose_new_ships() {
	char tmp[40];
	int i;
	pause();
	message.out("Selecting ships...", 1000);
	int *slot = new int[num_players];
	for (i = 0; i < num_players; i += 1) {
		slot[i] = -2;
		if (player_control[i]->ship) {
			}
		else {
			//if (player_panel[i]) delete player_panel[i];
			player_panel[i] = NULL;
			sprintf (tmp, "Player%d", i+1);
			load_fleet("./fleets.tmp", tmp);
			if (fleet_size == 0) continue;
			char buffy[512];
			sprintf(buffy, "%s\n%s\n%d of ??? points", player_name[i], fleet_title, fleet_cost);
			slot[i] = player_control[i]->choose_ship(buffy);
			if (player_control[i]->channel != channel_none) {
				slot[i] = intel_ordering(slot[i]);
				log->buffer(player_control[i]->channel, &slot[i], sizeof(int));
				log->flush();
				//slot[i] = intel_ordering(slot[i]);
				}
			}
		}
	log->listen();
	for (i = 0; i < num_players; i += 1) {
		if (slot[i] == -2) continue;
		if (player_control[i]->channel != channel_none) {
			log->unbuffer(player_control[i]->channel, &slot[i], sizeof(int));
			slot[i] = intel_ordering(slot[i]);
			}
		}
	for (i = 0; i < num_players; i += 1) {
		if (slot[i] == -2) continue;
		sprintf (tmp, "Player%d", i+1);
		load_fleet("./fleets.tmp", tmp);
		if (slot[i] == -1) slot[i] = random() % fleet_size;
		Ship *s = create_ship(fleet_id[slot[i]], player_control[i], random()%(int)width, random()%(int)height, random() % 360, player_team[i]);
		clear_fleet_slot(slot[i]);
		save_fleet("./fleets.tmp", tmp);
		s->locate();
		player_panel[i] = new ShipPanel(s);
		addPresence(player_panel[i]);
		addItem(s->get_ship_phaser());
		}
	set_resolution(screen_x, screen_y);
	delete slot;
	message.out("Finished selecting ships...", 1500);
	unpause();
	return;
	}

REGISTER_GAME(NormalGame, "Melee")