
#include "../melee.h"
REGISTER_FILE
#include "mview.h"

double atan3(double y, double x) {
	if (y == 0) {
		if (x >= 0) return 0;
		else return PI;
		}
	if (x == 0) {//probably doesn't help
		if (y >= 0) return PI / 2;
		else return PI * 3.0 / 2;
		}
	return atan2(y, x);
	}

double normalize(double value, double max)
{
	if (max < 0) 
		error ("normalize - bad \n%f\n %% %f", value, max);
	if ((value > 999 * max) || (value < -999 * max))
		error ("normalize - bad \n%f\n %% %f", value, max);
  while(value < 0.0)
    value += max;
  while(value >= max)
    value -= max;
  return(value);
}

double wcorner(double x, double w)
{
  double value = (x - (w / 2.0) - space_x);

  while(value < (-w))
    value += X_MAX;
  while(value > (X_MAX - w))
    value -= X_MAX;
  value *= space_zoom;

  return(value);
}

double hcorner(double y, double h)
{
  double value = (y - (h / 2.0) - space_y);

  while(value < (-h))
    value += Y_MAX;
  while(value > (Y_MAX - h))
    value -= Y_MAX;
  value *= space_zoom;

  return(value);
}

double min_delta(double from, double to, double max)
{
  double d1 = from - to;
  double d2 = (from + max) - to;
  double d3 = from - (to + max);
  double val = d1;

  if(fabs(val) > fabs(d2)) val = d2;
  if(fabs(val) > fabs(d3)) val = d3;
  return(val);
}

double nearest_coord(double from, double to, double max)
{
  return(from - min_delta(from, to, max));
}

double distance_from(double x, double y, double to_x, double to_y)
{
  double dx = min_delta(x, to_x, X_MAX);
  double dy = min_delta(y, to_y, Y_MAX);

  return(sqrt((dx * dx) + (dy * dy)));
}
