#ifndef _MMAIN_H
#include "mmain.h"
#endif
#ifndef _NET_TCP_H
#include "../util/net_tcp.h"
#endif
#ifndef _MLOG_H
#include "mlog.h"
#endif
#ifndef _MSHIP_H
#include "mship.h"
#endif

class ControlLagTransmitter : public Presence {
	public:
	KeyCode *buffer;
	int lag;
	int already;
	int index;
	int channel;
	Control *control;
	ControlLagTransmitter ( Control *c, int channel );
	~ControlLagTransmitter ();
	virtual void calculate();
//	virtual void increase_latency ();
//	virtual void decrease_latency ();
	};


class NetLog : public Log { //Logging system, usefull for networking & demo recording/playback
	protected:

	int *log_transmitted;      //the number of bytes transmitted in each channel
	void expand_logs(int num_channels) ; //intializes these extensions to the logging
	unsigned char buffy[4096]; //a buffer for sending and recieving packets
	void handle_code(unsigned int code) ;
	void send_code(unsigned int code) ;
	enum code {
		NET1_CODE_QUIT    = 0x80000001,
		NET1_CODE_PAUSE   = 0x80000002,
		NET1_CODE_UNPAUSE = 0x80000003,
		NET1_CODE_INCREASE_LAG = 0x80000004,
		NET1_CODE_DECREASE_LAG = 0x80000005,
		NET1_CODE_MESSAGE = 0x90000000
		};
	void send_message(char *string) ;

	void send_packet(); //sends a packet

	public:

	bool need_to_transmit;
	NetTCP net;       // the TCP network connection to the opponent player

	enum {
		direction_immediate = 4
		};

	void recv_packet(); //recieves a packet

	int remote_time; //used in calculating ping
	int ping;            //the most recently measured ping

	virtual void init();
	virtual void deinit();
	virtual ~NetLog();
	virtual void _log(int channel, const void *data, int size);   //used for recording data.  this version may transmit it over the network
	virtual void _unlog(int channel, void *data, int size); //used for playing back data.  this version may recieve it over the network
	void log_file(const char *fname) ;
	virtual int ready(int channel);

	virtual void flush() ;
	virtual bool listen();


	};
