#include <stdio.h>
#include <string.h>
#include <allegro.h>

#include "../melee.h"
REGISTER_FILE
#include "../util/aastr.h"

static BITMAP *copy_bitmap(BITMAP *old) {
	BITMAP *r;
	r = create_bitmap(old->w, old->h);
	blit (old, r, 0, 0, 0, 0, old->w, old->h);
	return r;
	}
// 384, 424, 468, 347
/*#include <aautil.h>
void rotate_bitmap (BITMAP *src, BITMAP *dest, double radians) {
	int x, y;
	for (y = 0; y < dest->h; y += 1) {
		double fy = y+.5 - dest->h / 2.0;
		for (x = 0; x < dest->w; x += 1) {
			double fx = x+.5 - dest->w / 2.0;
			double ry = cos(radians) * fy - sin(radians) * fx;
			double rx = cos(radians) * fx + sin(radians) * fy;
			int ix, iy;
			ix = (int)floor(rx + dest->w/2.0);
			iy = (int)floor(ry + dest->h/2.0);
			int c = getpixel(src, ix, iy);
			if (c == -1) c = bitmap_mask_color(dest);
			putpixel(dest, x, y, c);
			}
		}
	}
void weird_spacesprite ( SpaceSprite *blah ) {
	int i;
	for (i = 1; i < 64; i += 2) {
		BITMAP *src = blah->get_bitmap(i-1), *dest = blah->get_bitmap(i);
		clear_to_color(dest, bitmap_mask_color(dest));
		rotate_bitmap(src, dest, 2*PI / 64);
//		_aa_rotate_bitmap(src, dest, src->w/2-1, src->h/2, itofix(4), 64500, 64500, 1);
		//aa_rotate_sprite(blah->get_bitmap(i), blah->get_bitmap(i-1), 0, 0, itofix(256)/64);
		}
/*	for (i = 1; i < 64; i += 2) {
		BITMAP *src = blah->get_bitmap(i), *dest = blah->get_bitmap(i-1);
		clear_to_color(dest, bitmap_mask_color(dest));
		_aa_rotate_bitmap(src, dest, src->w/2-1, src->h/2-1, itofix(-4), 64500, 64500, 1);
		//aa_rotate_sprite(blah->get_bitmap(i), blah->get_bitmap(i-1), 0, 0, itofix(256)/64);
		}
	}*/
/*void compress_bitmap (BITMAP *bmp, BITMAP *key) {
	int x, y, c, oc;
	BITMAP *tmp = create_bitmap(key->w, key->h);
	clear_to_color(tmp, bitmap_mask_color(tmp));
//	rotate_bitmap(key, bmp, 2*PI / -64);
//	rotate_scaled_sprite(tmp, key, 0,0, itofix(256) / -64, 65536);
	for (y = 0; y < bmp->h; y += 1) {
		for (x = 0; x < bmp->w; x += 1) {
			c = getpixel(bmp, x, y);
			oc = getpixel(tmp, x, y);
			int r, g, b;
			r = (128+getr32(c) - getr32(oc)) & 255;
			g = (128+getg32(c) - getg32(oc)) & 255;
			b = (128+getb32(c) - getb32(oc)) & 255;
			putpixel(bmp, x, y, makecol32(r, g, b));
			}
		}
	return;
	}*/
void save_spacesprite2(SpaceSprite *ss, const char *spritename, const char *destination, const char *extension) {
	int i;
	char buf[512];
	if (ss->frames() != 64) error ("save_spacesprite2 - error");
	BITMAP *tmp = create_bitmap(int(ss->width() * 8), int(ss->height() * 8));
	for (i = 0; i < ss->frames(); i += 1) {
		blit(ss->get_bitmap(i), tmp, 0, 0, (i&7) * (int)ss->width(), int((i/8) * ss->height()), (int)ss->width(), (int)ss->height());
		sprintf(buf, "%s.bmp", spritename, i, extension);
		save_bitmap(buf, tmp, NULL);
		}
	return;
	}


void save_spacesprite(SpaceSprite *ss, const char *spritename, const char *destination, const char *extension) {
	int i;
	char buf[512];
	if (!ss) return;
	if (ss->frames()) {
		for (i = 0; i < ss->frames(); i += 1) {
			if (strchr(extension, '.')) {
				sprintf(buf, "tmp/%s%03d%s", spritename, i, extension);
				}
			else {
				sprintf(buf, "tmp/%s%03d.bmp", spritename, i);
				}
//			if ((i != ss->frames() - 1) && (ss->frames() == 64)) compress_bitmap(ss->get_bitmap(i), ss->get_bitmap(i+1));
			save_bitmap(buf, ss->get_bitmap(i), NULL);
			}
/*		chdir("tmp");
//		if (strchr(extension, '.')) sprintf(buf, "dat ../ships/%s.dat -k -t data -a *", destination);
//		else sprintf(buf, "dat ../ships/%s.dat -t %s -a *", destination, extension);
//		system(buf);
		sprintf(buf, "md ..\\ships\\%s", destination);
		system(buf);
		sprintf(buf, "move * ..\\ships\\%s", destination);
		system(buf);
		delete_file("*");
		chdir("..");
*/		}
	sprintf(buf, "tmp/%s.ini", spritename);
	set_config_file(buf);
	set_config_string("Main", "Type", "SpaceSprite");
	set_config_int("SpaceSprite", "Number", (int)ss->frames());
	set_config_int("SpaceSprite", "Width", (int)ss->width());
	set_config_int("SpaceSprite", "Height", (int)ss->height());
	set_config_string("SpaceSprite", "SubType", "Normal");
	set_config_string("SpaceSprite", "Extension", extension);
	chdir("tmp");
	sprintf(buf, "dat ../ships/%s.dat -k -a *", destination);
//	system(buf);
	sprintf(buf, "move * ..\\ships\\%s", destination);
	system(buf);
//	delete_file("*");
	chdir("..");
	return;
	}

void save_samples(SpaceSprite *ss, const char *spritename, const char *destination, const char *extension) {
	}

ShipData::ShipData(char *filename) :
	references(0),
  data(NULL),
  spriteShip(NULL),
  spriteWeapon(NULL),
  spriteWeaponExplosion(NULL),
  spriteSpecial(NULL),
  spriteSpecialExplosion(NULL),
  spriteExtra(NULL),
  spriteExtraExplosion(NULL),
  num_weapon_samples(0),
  sampleWeapon(NULL),
  num_special_samples(0),
  sampleSpecial(NULL),
  num_extra_samples(0),
  sampleExtra(NULL),
  moduleVictory(NULL)
{
	int i, index = 0, count, rotate;
	const char *str;

	data = load_datafile(filename);
	if(!data) error("Error loading '%s'", filename);

	set_config_data((char *)(data[index].dat), data[index].size);
	index++;

	int num_panel_bitmaps = get_config_int("Objects", "PanelBitmaps", 0);
	if(num_panel_bitmaps < 2) error("balterwelts zugreat");
	spritePanel   = new SpaceSprite(&data[index], num_panel_bitmaps, SpaceSprite::IRREGULAR);
	index += num_panel_bitmaps;

  rotate = FALSE;
  str = get_config_string("Objects", "ShipSprites", "0");
  if(str[strlen(str) - 1] == 'r') {
//    str[strlen(str) - 1] = '\0';
    rotate = TRUE;
  }
  count = atoi(str);
  if(count > 0) {
    if(!rotate)
      spriteShip = new SpaceSprite(&data[index], count);
    else
      spriteShip = new SpaceSprite(&data[index], count, SpaceSprite::MASKED, 64);
    index += count;
  }  
//  weird_spacesprite(spriteShip);
/*	delete spriteShip;
	spriteShip = new SpaceSprite("ships/andgu", "ShipSprite");
	set_config_data((char *)(data[0].dat), data[0].size);*/

  rotate = FALSE;
  str = get_config_string("Objects", "WeaponSprites", "0");
  if(str[strlen(str) - 1] == 'r') {
//    str[strlen(str) - 1] = '\0';
    rotate = TRUE;
  }
  count = atoi(str);
  if(count > 0) {
    if(!rotate)
      spriteWeapon = new SpaceSprite(&data[index], count);
    else
      spriteWeapon = new SpaceSprite(&data[index], count, SpaceSprite::MASKED, 64);
    index += count;
  }
/*	delete spriteWeapon;
	spriteWeapon = new SpaceSprite("ships/andgu", "WeaponSprite");
	set_config_data((char *)(data[0].dat), data[0].size);*/

  rotate = FALSE;
  str = get_config_string("Objects", "WeaponExplosion", "0");
  if(str[strlen(str) - 1] == 'r') {
//    str[strlen(str) - 1] = '\0';
    rotate = TRUE;
  }
  count = atoi(str);
  if(count > 0) {
    if(!rotate)
      spriteWeaponExplosion = new SpaceSprite(&data[index], count);
    else
      spriteWeaponExplosion = new SpaceSprite(&data[index], count, SpaceSprite::MASKED, 64);
    index += count;
  }


  rotate = FALSE;
  str = get_config_string("Objects", "SpecialSprites", "0");
  if(str[strlen(str) - 1] == 'r') {
//    str[strlen(str) - 1] = '\0';
    rotate = TRUE;
  }
  count = atoi(str);
  if(count > 0) {
    if(!rotate)
      spriteSpecial = new SpaceSprite(&data[index], count);
    else
      spriteSpecial = new SpaceSprite(&data[index], count, SpaceSprite::MASKED, 64);
    index += count;
  }

  rotate = FALSE;
  str = get_config_string("Objects", "SpecialExplosion", "0");
  if(str[strlen(str) - 1] == 'r') {
//    str[strlen(str) - 1] = '\0';
    rotate = TRUE;
  }
  count = atoi(str);
  if(count > 0) {
    if(!rotate)
      spriteSpecialExplosion = new SpaceSprite(&data[index], count);
    else
      spriteSpecialExplosion = new SpaceSprite(&data[index], count, SpaceSprite::MASKED, 64);
    index += count;
  }

  rotate = FALSE;
  str = get_config_string("Objects", "ExtraSprites", "0");
  if(str[strlen(str) - 1] == 'r') {
//    str[strlen(str) - 1] = '\0';
    rotate = TRUE;
  }
  count = atoi(str);
  if(count > 0) {
    if(!rotate)
      spriteExtra = new SpaceSprite(&data[index], count);
    else
      spriteExtra = new SpaceSprite(&data[index], count, SpaceSprite::MASKED, 64);
    index += count;
  }

  rotate = FALSE;
  str = get_config_string("Objects", "ExtraExplosion", "0");
  if(str[strlen(str) - 1] == 'r') {
//    str[strlen(str) - 1] = '\0';
    rotate = TRUE;
  }
  count = atoi(str);
  if(count > 0) {
    if(!rotate)
      spriteExtraExplosion = new SpaceSprite(&data[index], count);
    else
      spriteExtraExplosion = new SpaceSprite(&data[index], count, SpaceSprite::MASKED, 64);
    index += count;
  }

  moduleVictory = (Music *)(data[index].dat);
  index++;

  count = get_config_int("Objects", "WeaponSamples", 0);
	num_weapon_samples = count;
  if(count > 0) {
    sampleWeapon = new SAMPLE*[count];
    for(i = 0; i < count; i++) {
      sampleWeapon[i] = (SAMPLE *)(data[index].dat);
      index++;
    }
  }
	else sampleWeapon = NULL;

  count = get_config_int("Objects", "SpecialSamples", 0);
	num_special_samples = count;
  if(count > 0) {
    sampleSpecial = new SAMPLE*[count];
    for(i = 0; i < count; i++) {
      sampleSpecial[i] = (SAMPLE *)(data[index].dat);
      index++;
    }
  }
	else sampleSpecial = NULL;

  count = get_config_int("Objects", "ExtraSamples", 0);
	num_extra_samples = count;
  if(count > 0) {
    sampleExtra = new SAMPLE*[count];
    for(i = 0; i < count; i++) {
      sampleExtra[i] = (SAMPLE *)(data[index].dat);
      index++;
    }
  }
	else sampleExtra = NULL;


	return;
	if (tw_alert("transform this datafile?", "No", "Yes") != 2) 
		return;
	char dname[512], fname[512], header[8192];
	sprintf(dname, strstr(filename, "shp")+3);
	dname[strlen(dname)-4] = 0;
	sprintf (header, "[Main]\n");
	sprintf (header, "type = Ship\n");

//panel bitmaps
/*	sprintf (header, "num_panel_bitmaps = %d\n", num_panel_bitmaps);
	for (i = 0; i < num_panel_bitmaps; i += 1) {
		sprintf(fname, "%s/panel%03d.pcx", dname, i);
		save_bitmap(fname, bitmapPanel[i], NULL);
		}*/

//sound effects
/*	fprintf (f, "num_weapon_samples = %d\n", num_weapon_samples);
	for (i = 0; i < num_weapon_samples; i += 1) {
		sprintf(fname, "%s/WeaponSample%03d.wav", dname, i);
		//save_sample(fname, bitmapPanel[i]);
		}
	fprintf (f, "num_special_samples = %d\n", num_special_samples);
	for (i = 0; i < num_weapon_samples; i += 1) {
		sprintf(fname, "%s/SpecialSample%03d.wav", dname, i);
		//save_sample(fname, bitmapPanel[i]);
		}
	fprintf (f, "num_extra_samples = %d\n", num_extra_samples);
	for (i = 0; i < num_extra_samples; i += 1) {
		sprintf(fname, "%s/ExtraSample%03d.wav", dname, i);
		//save_sample(fname, bitmapPanel[i]);
		}
	fclose(f);*/

//SpaceSprites
	sprintf(fname, "%s/000index.txt", dname);
	set_config_file(fname);
	
//	moduleVictory;
	save_spacesprite2(spriteShip,             "ShipSprite",             dname, ".bmp");
//	save_spacesprite(spriteWeapon,           "WeaponSprite",           dname, ".bmp");
//	save_spacesprite(spriteWeaponExplosion,  "WeaponExplosionSprite",  dname, ".bmp");
//	save_spacesprite(spriteSpecial,          "SpecialSprite",          dname, ".bmp");
//	save_spacesprite(spriteSpecialExplosion, "SpecialExplosionSprite", dname, ".bmp");
//	save_spacesprite(spriteExtra,            "ExtraSprite",            dname, ".bmp");
//	save_spacesprite(spriteExtraExplosion,   "ExtraExplosionSprite",   dname, ".bmp");
	return;
	}

ShipData::~ShipData()
{
	if(spriteShip)
    delete spriteShip;
  if(spriteWeapon)
    delete spriteWeapon;
  if(spriteWeaponExplosion)
    delete spriteWeaponExplosion;
  if(spriteSpecial)
    delete spriteSpecial;
  if(spriteSpecialExplosion)
    delete spriteSpecialExplosion;
  if(spriteExtra)
    delete spriteExtra;

  if (spritePanel)
    delete spritePanel;

  unload_datafile(data);
	}
