#ifndef _MELEE_H
#include "../melee.h"
#endif

#ifndef _MSHPPAN_H
#define _MSHPPAN_H

extern int PANEL_WIDTH;
extern int PANEL_HEIGHT;

class ShipPanel : public Presence {
  protected:
  BITMAP *panel;
  BITMAP *captain;

  int panel_x;
  int panel_y;
  int captain_x;
  int captain_y;

  int crew_old;
  int batt_old;
  int batt_light;

	char panel_needs_update;
	char captain_needs_update;

  char old_thrust;         // previous keypresses for ship
  char old_turn_left;
  char old_turn_right;
  char old_fire_weapon;
  char old_fire_special;

  int deathframe;

  public:
  Ship *ship;

  ShipPanel(Ship *oship);
  virtual ~ShipPanel();

	virtual void draw_stuff(int x, int y, int w, int h, int dx, int dy, int m, int value, int max, int color, int bcolor);
	//used for drawing crew & battery bars

  virtual int exists();
	//does it still need calculate & animate calls, is it on the way to destruction

	virtual void refresh();
	//causes redraw sometime

	virtual void hide();
	//remove the panel from the screen
	virtual void locate(int x, int y);
	//move the panel to x, y //add width & height later?

  virtual void calculate();
	//called every frame
  virtual void animate(Frame *space); 
	//the parameter "space" is not used
	};

#endif