#include <string.h>
#include <stdio.h>
#include <float.h>
#include <allegro.h>


#include "../melee.h"
REGISTER_FILE
#include "../scp.h"
#include "../frame.h"

#include "mview.h"
#include "mgame.h"
#include "mcbodies.h"
#include "mshppan.h"
#include "mcontrol.h"
#include "mship.h"

#include "../util/aastr.h"


typedef struct {
	int      x;
	int      y;
	} StarLocation;
class StarLayer {
	public:
	double scroll_x, scroll_y;
	double w, h;
	SpaceSprite *pic;
	int num_stars;
	StarLocation *s;
	double depth;
	StarLayer (SpaceSprite *p, int n, int width, int height) ;
	~StarLayer ();
	void StarLayer::animate(Frame *space);
	void scroll (double dx, double dy);
	};

class Stars {
	double depth;
	int num_pics;
	SpaceSprite **pic;
	int num_layers;
	StarLayer **layer;
	public:
	void set_depth (int i) ;
	Stars();
	~Stars();
	void animate(Frame *space);
	void scroll (double dx, double dy);
	} static *stars = NULL;

StarLayer::StarLayer (SpaceSprite *p, int n, int width, int height) {
	scroll_x = scroll_y = 0;
	pic = p;
	w = width;
	h = height;
	num_stars = n;
	depth = 1.0;
	s = new StarLocation[num_stars];
	for (int i = 0; i < num_stars; i++) {
		s[i].x = rand() % (int)(w);
		s[i].y = rand() % (int)(h);
		}
	}

StarLayer::~StarLayer () {
	delete s;
	}

void StarLayer::scroll (double dx, double dy) {
	scroll_x += depth * dx;
	while (scroll_x > w) scroll_x -= w;
	while (scroll_x < 0) scroll_x += w;
	scroll_y += depth * dy;
	while (scroll_y > h) scroll_y -= h;
	while (scroll_y < 0) scroll_y += h;
	return;
	}

void Stars::set_depth (int d) {
	depth = log(1 - d / 260.0) / log(2);
	for (int i = 0; i < num_layers; i += 1) {
		layer[i]->depth = pow (2, depth * (i+.5) / (num_layers));
		}
	return;
	}

Stars::Stars() {
	int i;
	depth = 0.5;
	num_pics = 3;
	pic = new SpaceSprite*[num_pics];
	for(i = 0; i < num_pics; i++) {
		pic[i] = new SpaceSprite(&(melee[MELEE_STAR + i]), 1);
		}
	set_config_file("client.ini");
	int num_stars = get_config_int("Stars", "Number", 150);
	num_layers = get_config_int("Stars", "Layers", 6);
	layer = new StarLayer*[num_layers];
	for (i = 0; i < num_layers; i += 1) {
		layer[i] = new StarLayer(pic[ i * num_pics / num_layers], num_stars/num_layers, 4096, 4096);
		}
	set_config_file("client.ini");
	set_depth(get_config_int("View", "StarDepth", 192));
	}

Stars::~Stars() {
	int i;
	for(i = 0; i < num_pics; i++) delete pic[i];
	delete pic;
	for(i = 0; i < num_layers; i++) delete layer[i];
	delete layer;
	}
/*
void StarLayer::animate(Frame *frame) {
// speed this up sometime
	int i;
	double sx, sy;
	double tx, ty;
	int wx, wy;
	wx = (int) (0.5 + pic->width() * space_zoom);
	wy = (int) (0.5 + pic->height() * space_zoom);
	if (wx < 1) wx = 1;
	if (wy < 1) wy = 1;
	BITMAP *tmp = create_bitmap(wx, wy);
	clear_to_color(tmp, bitmap_mask_color(tmp));
//	BITMAP *p = pic->get_bitmap(0);
//	stretch_blit(p, tmp, 0, 0, p->w, p->h, 0, 0, wx, wy);
	pic->draw(0, 0, wx, wy, 0, tmp);
	tx = (frame->frame->w - wx)/2;
	ty = (frame->frame->h - wy)/2;
	for(i = 0; i < num_stars; i += 1) {
		sx = s[i].x + scroll_x;
		sy = s[i].y + scroll_y;
		while (sx > w/2) sx -= w;
		while (sy > h/2) sy -= h;
		sx = sx * space_zoom + tx;
		sy = sy * space_zoom + ty;
//		pic->draw(sx, sy, wx, wy, 0, frame);
		draw_sprite(frame->frame, tmp, (int)sx, (int)sy);
		frame->add_box(sx, sy, wx, wy);
		}
	destroy_bitmap(tmp);
	return;
	}*/
void StarLayer::animate(Frame *frame) {
	int i;
	double sx, sy;
	double tx, ty;
/*	if (antia_on) {
		int wx, wy;
		wx = (int) (0.5 + pic->width() * space_zoom);
		wy = (int) (0.5 + pic->height() * space_zoom);
		if (wx < 1) wx = 1;
		if (wy < 1) wy = 1;
		BITMAP *tmp = create_bitmap(wx, wy);
		clear_to_color(tmp, bitmap_mask_color(tmp));
		pic->draw(0, 0, wx, wy, 0, tmp);
		tx = (frame->frame->w - wx)/2;
		ty = (frame->frame->h - wy)/2;
		for(i = 0; i < num_stars; i += 1) {
			sx = s[i].x + scroll_x;
			sy = s[i].y + scroll_y;
			while (sx > w/2) sx -= w;
			while (sy > h/2) sy -= h;
			sx = sx * space_zoom + tx;
			sy = sy * space_zoom + ty;
			draw_sprite(frame->frame, tmp, (int)sx, (int)sy);
			frame->add_box(sx, sy, wx, wy);
			}
		destroy_bitmap(tmp);
		}
	else */{
		double wx, wy;
		wx = pic->width() * space_zoom;
		wy = pic->height() * space_zoom;
//		if (wx < 2) wx *= 1;
//		if (wy < 2) wy *= 1;
		tx = (frame->frame->w - wx)/2;
		ty = (frame->frame->h - wy)/2;
		for(i = 0; i < num_stars; i += 1) {
			sx = s[i].x + scroll_x;
			sy = s[i].y + scroll_y;
			while (sx > w/2) sx -= w;
			while (sy > h/2) sy -= h;
			sx = sx * space_zoom + tx;
			sy = sy * space_zoom + ty;
			pic->draw(sx, sy, wx, wy, 0, frame);
			frame->add_box(sx, sy, wx+2, wy+2);
			}
		}
	return;
	}

void Stars::animate(Frame *space) {
	int i;
  for(i = num_layers - 1; i >= 0; i -= 1) {
		layer[i]->animate(space);
		}
	return;
	}

void Stars::scroll (double dx, double dy) {
	int i;
  for(i = num_layers - 1; i >= 0; i -= 1) {
		layer[i]->scroll(dx, dy);
		}
	return;
	}


void View::config() {
	return;
	}
void View::set_background (int color) {
	if (frame) frame->background_color = color;
	refresh();
	}
bool View::screen2game(double *_x, double *_y) {
	double x = *_x, y = *_y;
	double ox=x, oy=y; 
	x -= view_x;
	y -= view_y;
	x /= space_zoom;
	y /= space_zoom;
	x += space_x;
	y += space_y;
	x = normalize(x, X_MAX);
	y = normalize(y, Y_MAX);
	*_x = x;
	*_y = y;
	if ((ox < view_x) || (ox >= view_x + view_w) || (oy < view_y) || (oy >= view_y + view_h))
		return false;
	return true;
	}
void View::focus(SpaceLocation *la, SpaceLocation *lb) {
	if (!la && !lb) return;
	if (!la) la = lb;
	if (!lb) lb = la;
	double x2, y2;
	x = la->normal_x();
	y = la->normal_y();
	x2 = lb->normal_x();
	y2 = lb->normal_y();
	double a, b, c, d;
	a = min_delta(x, x2, X_MAX);
	b = min_delta(y, y2, Y_MAX);
	c = view_w / (fabs(a) + 1);
	d = view_h / (fabs(b) + 1);
	if (c > d) c = d;
	x = normalize(x-a/2, X_MAX);
	y = normalize(y-b/2, Y_MAX);
	if (lb != la) z = c;
	return;
	}
/*void View::see_also(SpaceLocation *o) {
	if (!o) return;
	double x2, y2;
	x2 = b->normal_x();
	y2 = b->normal_y();
	double a, b, c, d;
	a = min_delta(x, x2, X_MAX);
	b = min_delta(y, y2, Y_MAX);
	c = view_x / (fabs(a) + 1);
	d = view_y / (fabs(b) + 1);
	if (c > d) c = d;
	x = normalize(x-a/2, X_MAX);
	y = normalize(y-b/2, Y_MAX);
	z = c;
	return;
	}*/
//make these static...
double space_zoom = 1./3;
double space_x = 0;
double space_y = 0;
int FULL_REDRAW = 0;
void View::set_view (double x, double y, double zoom, double smooth_time) {
	static double odx = 0, ody = 0;
  double dx, dy;
  space_x += view_w / 2 / space_zoom;
  space_y += view_h / 2 / space_zoom;
  dx = min_delta( space_x, x, X_MAX);
  dy = min_delta( space_y, y, Y_MAX);
	double dd = fabs(dx - odx) + fabs(dy - ody);
	double r = sqrt(dx * dx + dy * dy);
	odx = dx;
	ody = dy;
	if (dd * space_zoom < 100) {
		r *= space_zoom;
		if (r < 9) {
			dx *= smooth_time / 1000.;
			dy *= smooth_time / 1000.;
			}
		else {
			dx = dx * sqrt(r) * smooth_time / 3000.;
			dy = dy * sqrt(r) * smooth_time / 3000.;
			}
		}
	if (stars) stars->scroll(dx, dy);
  space_x -= dx;
  space_y -= dy;
	space_x_stars -= dx;
	space_y_stars -= dy;
  space_zoom = zoom;
	if (space_zoom < 0.05) space_zoom = 0.05;
  space_x -= view_w / 2 / space_zoom;
  space_y -= view_h / 2 / space_zoom;
	while (space_x > X_MAX) space_x -= X_MAX;
	while (space_x < 0) space_x += X_MAX;
	while (space_y > Y_MAX) space_y -= Y_MAX;
	while (space_y < 0) space_y += Y_MAX;
	return;
  }
void View::refresh() {
	if (frame) frame->add_box(0, 0, view_w, view_h);
	return;
	}
void View::set_window(BITMAP *dest, int x, int y, int w, int h) {
	if (dest && (dest != screen)) throw "non-screen output not yet supported";
	if (frame) delete frame;
	frame = NULL;
	if (!dest) return;
	frame = new Frame(x, y, w, h, 1024);
	view_x = x;
	view_y = y;
	view_w = w;
	view_h = h;
	return;
	}
void View::init(View *old) {
	if (old) {
		frame = old->frame;
		space_x_stars = old->space_x_stars;
		space_y_stars = old->space_y_stars;
		space_x = old->space_x;
		space_y = old->space_y;
		space_zoom = old->space_zoom;
		x = old->x;
		y = old->y;
		z = old->z;
		}
	else {
		frame = NULL;
		space_x_stars = 0;
		space_y_stars = 0;
		space_x = 0;
		space_y = 0;
		space_zoom = 1;
		x = 0;
		y = 0;
		z = 1;
		}
	if (melee && !stars) stars = new Stars();
	return;
	}
void View::deinit() {
/*	if (stars) {
		delete stars;
		stars = NULL;
		}*/
	return;
	}
void View::set_depth(int depth) {
	if (stars) stars->set_depth(depth);
	}
void View::calculate(Game *game, int time) {}


void message_type::out(char *string, int dur, int c) {
	ASSERT (c < 256);
	if (num_messages == max_messages - 1) {
		messages[0].end_time = -1;
		clean();
		}
	if (num_messages >= max_messages - 1) throw "bad dog!";
	messages[num_messages].string = strdup(string);
	if (game) messages[num_messages].end_time = game->game_time + dur;
	else messages[num_messages].end_time = 0 + dur;
	messages[num_messages].color = palette_color[c];
	num_messages += 1;
	animate(NULL);clean();return;//
	if (!game) animate(NULL);
	else if (game->is_paused()) animate(NULL);
	clean();
	return;
	}
void message_type::print(int dur, int c, const char *format, ...) {
	char buf[512];
	va_list those_dots;
	va_start (those_dots, format);
	vsprintf(buf, format, those_dots);
	va_end (those_dots);
	out(buf, dur, c);
	return;
	}
void message_type::clean() {
	int kill_time;
	if (game) kill_time = game->game_time;
	else kill_time = 0;
	for (int i = 0; i < num_messages; i += 1) {
		if (messages[i].end_time <= kill_time) {
			free (messages[i].string);
			num_messages -= 1;
			memmove (&messages[i], &messages[i+1], (num_messages - i) * sizeof(entry_type));
			i -= 1;
			}
		}
	return;
	}
void message_type::flush() {
	for (int i = 0; i < num_messages; i += 1) {
		free (messages[i].string);
		}
	num_messages = ox = oy = 0;
	return;
	}

void message_type::animate(Frame *frame) {
	int i, x = 0, y = 0, tmp;
	BITMAP *bmp;
	if (frame) {
		text_mode(-1);
		bmp = frame->frame;
		}
	else {
		text_mode(0);
		acquire_screen();
		bmp = screen;
		}
	clean();
	if (!frame) rectfill(bmp, 0, 0, ox, oy, 0);
	for (i = 0; i < num_messages; i += 1) {
		textprintf(bmp, font, 0, y, messages[i].color, "%s", messages[i].string);
		tmp = text_length(font, messages[i].string);
		if (x < tmp) x = tmp;
		y += text_height(font);
		}
	if (frame) frame->add_box(0, 0, x, y);	
	else release_screen();
	ox = x;
	oy = y;
	return;
	}
message_type message;

void View::animate(Game *game) {
	::space_zoom = this->space_zoom;
	::space_x = this->space_x;
	::space_y = this->space_y;
	frame->erase();
	if (stars) stars->animate(frame);
	int col = 4;
//	((Physics*)game)->animate(frame); // damn C++
	game->animate(frame);
	message.animate(frame);

	scare_mouse();
	acquire_screen();
	frame->draw();
	release_screen();
	unscare_mouse();
	return;
	}
void View::animate_target(Frame *frame, SpaceLocation *t, int dx, int dy, int r, int c) {
	double x, y;
	r = int( r * space_zoom/2);
	x = t->normal_x() - space_x - view_w/2 / space_zoom;
	while (x < -X_MAX/2) x += X_MAX;
	x *= space_zoom;
	x += dx;
	if ((x*2 > -(view_w+r)) && (x*2 < (view_w+r))) {
		y = t->normal_y() - space_y - view_h/2 / space_zoom;
		while (y < -Y_MAX/2) y += Y_MAX;
		y *= space_zoom;
		y += dy;
		if ((y*2 > -(view_h+r*2)) && (y*2 < (view_h+(r*2)))) {
			x += view_w/2;
			y += view_h/2;
			r /= 2;
			vline (frame->frame, (int)x, (int)(y)-r*2, (int)(y)-r, c);
			vline (frame->frame, (int)x, (int)(y)+r*2, (int)(y)+r, c);
			hline (frame->frame, (int)(x)-r*2, (int)y, (int)(x)-r, c);
			hline (frame->frame, (int)(x)+r*2, (int)y, (int)(x)+r, c);
			circle (frame->frame, (int)x, int(y), (r*3)>>1, c);
		  frame->add_box((int)(x-r*2), (int)(y-r*2), (int)(r*4)+1, (int)(r*4)+1);
			}
		}
	return;
	}







class View_Everything : public View {
	public:
	virtual void calculate(Game *game, int time);
	};
void View_Everything::calculate (Game *game, int time) {
	double a, b;
	a = view_w / double(X_MAX);
	b = view_h / double(Y_MAX);
	if (b < a) a = b;
	set_view(X_MAX/2, Y_MAX/2, a, time);
	return;
	}




class View_Hero : public View {
	double f;
	double max, min;
	public:
	virtual void calculate(Game *game, int time);
	virtual void init(View *old);
	virtual void set_window (BITMAP *dest, int x, int y, int w, int h);
	};
void View_Hero::init(View *old) {
	View::init(old);
	f = 0;
	return;
	}
void View_Hero::set_window (BITMAP *dest, int x, int y, int w, int h) {
	View::set_window (dest, x, y, w, h);
	max = view_h / 240.0;
	min = view_h / 2400.0;
	return;
	}
void View_Hero::calculate (Game *game, int time) {
	if (key[KEY_EQUALS]) z *= 1 + 0.001 * time;
	if (key[KEY_MINUS])  z /= 1 + 0.001 * time;
	if (z < min) z = min;
	if (z > max) z = max;
	if (key[KEY_0]) f += 0.008 * time;
	else f -= 0.008 * time;
	if (f < 0) f = 0;
	if (f > 1.2) f = 1.2;
/*	if ((game->hero >= 0) && game->control[game->hero]->ship) {
		focus ( game->control[game->hero]->ship );
		x += (f) * view_w / z * cos(game->control[game->hero]->ship->get_angle() * ANGLE_RATIO) / 4;
		y += (f) * view_h / z * sin(game->control[game->hero]->ship->get_angle() * ANGLE_RATIO) / 4;
		}*/
	SpaceLocation *c = NULL;
	if (game->num_focuses) c = game->focus[game->focus_index]->get_focus();
	if (c) {
		focus ( c );
		x += (f) * view_w / z * cos(c->get_angle() * ANGLE_RATIO) / 4;
		y += (f) * view_h / z * sin(c->get_angle() * ANGLE_RATIO) / 4;
		}
	set_view(x, y, z, time);
	return;
	}




class View_Enemy : public View {
	public:
	virtual void calculate(Game *game, int time);
	};
void View_Enemy::calculate (Game *game, int time) {
	SpaceLocation *c = NULL;
	if (game->num_focuses) c = game->focus[game->focus_index]->get_focus();
	if (!c) return;
	if (c->target && !c->target->isInvisible()) {
		focus(c, c->target);
		z /= 1.4;
		time *= 2;
		}
	else focus(c, NULL);
	if (z > 1) z = 1;
	set_view(x, y, z, time);
	return;
	}




class View_Enemy_Discrete : public View {
	public:
	virtual void calculate(Game *game, int time);
	};
void View_Enemy_Discrete::calculate (Game *game, int time) {
	SpaceLocation *c = NULL;
	if (game->num_focuses) c = game->focus[game->focus_index]->get_focus();
	if (!c) return;
	if (c->target && !c->target->isInvisible()) {
		focus(c, c->target);
		z /= 1.4;
		time *= 2;
		}
	else focus(c, NULL);
	if (z > 1) z = 1;
	if (z < 0.5) z = 0.25;
	else if (z < 1) z = 0.5;
	else if (z > 1) z = 1;
	set_view(x, y, z, time);
	return;
	}








View *view = NULL;
int view_num = -1;

const char num_views = 4;
static char *gcc_sucks_dick[num_views + 1] = 
		{"Everything", "Hero", "Enemy", "Enemy_Discrete", NULL};
char **view_name = gcc_sucks_dick;

void force_view (View *bob) {
	View *oldview = view;
	view = bob;
	if (view) view->init(oldview);
	if (oldview) {
		oldview->deinit();
		delete oldview;
		}
	}
void set_view (int type) {
	if (type == -1) type = 0;
	if (type == view_num) return;
	View *nview;
	switch (type) {
		case 0:
			nview = new View_Everything();
			break;
		case 1:
			nview = new View_Hero();
			break;
		case 2:
			nview = new View_Enemy();
			break;
		case 3:
			nview = new View_Enemy_Discrete();
			break;
		default:
			nview = NULL;
			break;
		}
	if (nview) view_num = type;
	if (nview) force_view(nview);
	return;
	}
int view2number(const char *name) {
	if (!name) return -1;
	for (int i = 0; i < num_views; i += 1) {
		if (!strcmp(name, view_name[i])) return i;
		}
	return -1;
	}
