#ifndef _MELEE_H
#include "../melee.h"
#endif

#ifndef _MVIEW_H
#define _MVIEW_H

extern View *view;
extern int view_num;

extern double space_zoom;
extern double space_x;
extern double space_y;

extern const char num_views;
extern char **view_name;
void set_view (int type) ;
void force_view (View *) ;
int view2number(const char *name) ;

class Stars;
class Game;

class View {
	protected:
	double x, y, z;
	double space_x, space_y; 
	double space_zoom;
	double space_x_stars, space_y_stars; 
	void focus (SpaceLocation *a, SpaceLocation *b = NULL);
//	void see_also (SpaceLocation *other);
	virtual void set_view (double x, double y, double zoom, double smooth_time) ;
	Frame *frame;
	public:
	int view_x, view_y, view_w, view_h;
	virtual void animate_target(Frame *frame, SpaceLocation *t, int dx, int dy, int r, int c) ;
	virtual void set_background (int color);
	//translates screen coordinates to game coordinates
	virtual bool screen2game(double *x, double *y);
//	virtual bool game2screen(double *x, double *y);
	//sets starfield depth.  later one to set color depth will be added...
	virtual void set_depth (int depth);
	//called more or less every game tic, with the amount of time passed
	virtual void calculate(Game *game, int time);
	//draws the screen
	virtual void animate(Game *game);
	//called when a new view is created
	virtual void init(View *old);
	//called when the screen needs to be redrawn
	virtual void refresh();
	//called when a vew is destroyed
	virtual void deinit();
	//sets the output region...
	virtual void set_window ( BITMAP *dest, int x, int y, int w, int h);
	//configure keys or whatever
	virtual void config();
	};

class message_type {
	enum { max_messages = 16 };
	struct entry_type {
		char *string;
		int end_time;
		int color;
		} messages[max_messages];
	int ox, oy;
	int num_messages;
	void clean();
	public:
	message_type() {num_messages = ox = oy = 0;}
	void animate(Frame *frame);
	void flush();
	void out(char *string, int dur = 2000, int c = 15);
	void print(int dur, int c, const char *format, ...);
	} extern message;

#endif