#include "../ship.h"
REGISTER_FILE

class GlathrielDestroyer : public Ship {
  double       weaponRange;
  double       weaponVelocity;
  int          weaponDamage;
  int          weaponArmour;
  int          sidelasers;
  int          armingtime;
  double       spreed;
  int          laserdamage;
  int          lasercolor;
  int          laserduration;
  double       laserRange;
  double       lasersweep;

  double       specialRange;
  double       specialVelocity;
  int          specialDamage;
  int          specialArmour;

  public:
  GlathrielDestroyer(double ox, double oy, double shipAngle,
		ShipData *shipData, unsigned int code);

  protected:
  virtual int activate_weapon();
  virtual int activate_special();
};

class GlathrielMissile : public Missile {
    int missileactive;
    int missileArming;
    int  sidelasers;
    double spreed;
    int laserdamage;
    int lasercolor;
    int laserduration;
    double laserRange;
    double lasersweep;

  public:
  GlathrielMissile(double ox, double oy, double oangle, double ov,
    int odamage, double orange, int oarmour, double otrate, Ship *oship,
    SpaceSprite *osprite,int osidelasers,int oarmingtime,double ospreed,
    int olaserdamage,int olasercolor,int olaserduration,double olaserRange,
    double olasersweep);

  virtual void calculate();
};

class GlathrielSpot : public Shot {
  int spottime;
  public:
  GlathrielSpot::GlathrielSpot(double oangle,Ship *oship, SpaceLocation *opos,
       SpaceSprite *osprite,int osidelasers,double ospreed,
    int olaserdamage,int olasercolor,int olaserduration,double olaserRange);

  virtual void calculate();
};

class GlathrielMiniMissile : public Missile {
  public:
  GlathrielMiniMissile(double ox, double oy, double oangle, double ov,
    int odamage, double orange, int oarmour, double otrate, Ship *oship,
    SpaceSprite *osprite);
};

GlathrielDestroyer::GlathrielDestroyer(double ox, double oy, double shipAngle,
	ShipData *shipData, unsigned int code) 
	:
  Ship(ox, oy, shipAngle, shipData, code) {

  weaponRange    = scale_range(get_config_float("Weapon", "Range", 0));
  weaponVelocity = scale_velocity(get_config_float("Weapon", "Velocity", 0));
  weaponDamage   = get_config_int("Weapon", "Damage", 0);
  weaponArmour   = get_config_int("Weapon", "Armour", 0);
  sidelasers     = get_config_int("Weapon", "Sidelasers",0);
  armingtime     = get_config_int("Weapon", "ArmingTime",0);
  spreed         = get_config_float("Weapon","Spreed",0);
  laserdamage    = get_config_int("Weapon","LaserDamage",0);
  lasercolor     = get_config_int("Weapon","LaserColor",0);
  laserduration  = get_config_int("Weapon","LaserDuration",0);
  laserRange     = scale_range(get_config_float("Weapon","LaserRange",0));
  lasersweep    = get_config_float("Weapon","LaserSweep",0);

  specialRange    = scale_range(get_config_float("Special", "Range", 0));
  specialVelocity = scale_velocity(get_config_float("Special", "Velocity", 0));
  specialDamage   = get_config_int("Special", "Damage", 0);
  specialArmour   = get_config_int("Special", "Armour", 0);
}

static const int trate = 0;

int GlathrielDestroyer::activate_weapon() {
  game->addItem(new GlathrielMissile(
    0.0, (height() / 2.0), angle, weaponVelocity, weaponDamage, weaponRange,
    weaponArmour, trate, this, data->spriteWeapon,sidelasers,armingtime,
    spreed,laserdamage,lasercolor,laserduration,laserRange,lasersweep));
  return(TRUE);
}

int GlathrielDestroyer::activate_special() {
	game->addItem(new GlathrielMiniMissile(
		0.0, (height() / 3.0), angle - 25.0 + ((double)(random() % 11) * 5.0), specialVelocity,
		specialDamage, specialRange, specialArmour, trate, this, data->spriteSpecial));
	game->addItem(new GlathrielMiniMissile(
		0.0, (height() / 3.0), angle - 25.0 + ((double)(random() % 11) * 5.0), specialVelocity,
		specialDamage, specialRange, specialArmour, trate, this, data->spriteSpecial));
	if (random()&1) {
		game->addItem(new GlathrielMiniMissile(
			0.0, (height() / 3.0), angle - 25.0 + ((double)(random() % 11) * 5.0), specialVelocity,
			specialDamage, specialRange, specialArmour, trate, this, data->spriteSpecial));
		}
	return(TRUE);
	}

GlathrielMissile::GlathrielMissile(double ox, double oy, double oangle,
  double ov, int odamage, double orange, int oarmour, double otrate,
  Ship *oship, SpaceSprite *osprite,int osidelasers,int oarmingtime,double ospreed,
    int olaserdamage,int olasercolor,int olaserduration,double olaserRange,
    double olasersweep) :
//  HomingMissile(ox, oy, oangle, ov, odamage, orange, oarmour, otrate, oship,
//	osprite)
  Missile(oship, ox, oy, oangle, ov, odamage, orange, oarmour, oship,
    osprite)
{
  explosionSprite     = data->spriteWeaponExplosion;
  explosionFrameCount = 10;
  explosionFrameSize  = 50;
  missileactive = FALSE;
  missileArming = oarmingtime;
  sidelasers = osidelasers;
  spreed = ospreed;
  laserdamage = olaserdamage;
  lasercolor = olasercolor;
  laserduration = olaserduration;
  laserRange = olaserRange;
  lasersweep = olasersweep;
}

void GlathrielMissile::calculate()
{
  Missile::calculate();
  if (!missileactive) {
    missileArming -= frame_time;
    if (missileArming <= 0)
      missileactive = TRUE;
  } else {
    SpaceObject *o, *t = NULL;
    double oldrange = 999999;
    Query a;
    for (a.begin(this, bit(LAYER_SHIPS),(laserRange *.85));
           a.current; a.next()) {
		o = a.currento;
		if (!o->sameTeam(this) && !o->isInvisible() && (distance(o) < oldrange) && !(o->isAsteroid() || o->isPlanet())
		  && (normalize(trajectory_angle(o)-angle,360) < lasersweep) ||
		  ((normalize(trajectory_angle(o)-angle,360) > (360 - lasersweep)))){
			t = o;
			oldrange = distance(o);
			}
                  }
    if (t) {
      game->addItem(new GlathrielSpot(angle,ship,this,data->spriteExtra,
      sidelasers,spreed,laserdamage,lasercolor,laserduration,laserRange));
      damage = armour;
      handle_damage(this);
      }
   }
}

GlathrielSpot::GlathrielSpot(double oangle,Ship *oship, SpaceLocation *opos,
       SpaceSprite *osprite,int osidelasers,double ospreed,
    int olaserdamage,int olasercolor,int olaserduration,double olaserRange) :
       Shot(oship,0,0,oangle,0,0,-1.0,1,opos,osprite)
{
  collide_flag_anyone = 0;
  collide_flag_sameteam = 0;
  game->addItem(new Laser(this, angle,pallete_color[olasercolor],
    olaserRange,olaserdamage,olaserduration,this,0,0));
  for (int i = 1;i<=osidelasers;i++) {
    game->addItem(new Laser(this, angle+(i*ospreed),pallete_color[olasercolor],
      olaserRange,olaserdamage,olaserduration,this,0,0));
    game->addItem(new Laser(this, angle-(i*ospreed),pallete_color[olasercolor],
      olaserRange,olaserdamage,olaserduration,this,0,0));
    }
  spottime = 1000;
}

void GlathrielSpot::calculate()
{
  Shot::calculate();
  if (spottime > 0) {
    spottime -= frame_time;
  } else {
  state=0;
  }
}

GlathrielMiniMissile::GlathrielMiniMissile(double ox, double oy, double oangle,
  double ov, int odamage, double orange, int oarmour, double otrate,
  Ship *oship, SpaceSprite *osprite) :

//  HomingMissile(ox, oy, oangle, ov, odamage, orange, oarmour, otrate, oship,
//	osprite)
  Missile(oship, ox, oy, oangle, ov, odamage, orange, oarmour,  oship, 
    osprite)
{
}




REGISTER_SHIP(GlathrielDestroyer)
