#include "../ship.h"
REGISTER_FILE

class OstokDisplacer : public Ship {
  double       weaponRange;
  double       weaponVelocity;
  int          weaponDamage;
  int          weaponArmour;

  //This is from the Arilou code
  int just_teleported;

    public:
  OstokDisplacer(double ox, double oy, double shipAngle,
		ShipData *shipData, unsigned int code);

  virtual int activate_weapon();
  virtual int activate_special();

  //This is from the Arilou code
  protected:
	virtual void inflict_damage(SpaceObject *other);
	virtual void calculate();

};

OstokDisplacer::OstokDisplacer(double ox, double oy, double shipAngle,
	ShipData *shipData, unsigned int code) 
	:
  Ship(ox, oy, shipAngle, shipData, code)
{

  //From Arilou
  just_teleported = 0;


  weaponRange    = scale_range(get_config_float("Weapon", "Range", 0));
  weaponVelocity = scale_velocity(get_config_float("Weapon", "Velocity", 0));
  weaponDamage   = get_config_int("Weapon", "Damage", 0);
  weaponArmour   = get_config_int("Weapon", "Armour", 0);

}

int OstokDisplacer::activate_weapon()
{
  game->addItem(new Missile(this, 0.0, (height() / 2.0),
    angle, weaponVelocity, weaponDamage, weaponRange, weaponArmour,
    this, data->spriteWeapon));
  return(TRUE);
}


//this is all from arilou
void OstokDisplacer::inflict_damage(SpaceObject *other) {
	if (just_teleported && other->mass) {
		this->directDamage = 999;
		this->handle_damage(other);
		}
	Ship::inflict_damage(other);
	return;
	}

int OstokDisplacer::activate_special()
{

	double dx, dy; //teleport location
	double tx, ty; //target teleport location
	if ((target != NULL) && (!target->isInvisible()) && (target->mass > 0)) 
	{
		//from Arilou code
		//dx = (double)(random() % (int)(3000)) - 1500;
		//dy = (double)(random() % (int)(3000)) - 1500;
		
		tx = normal_x();
		ty = normal_y();
		dx = target->normal_x();
		dy = target->normal_y();
		
		target->translate(tx - target->normal_x(), ty - target->normal_y());
		translate(dx - normal_x(), dy - normal_y());
		just_teleported = 1;


	}

	return(TRUE);
	
	
}

void OstokDisplacer::calculate() {
	just_teleported = 0;
	Ship::calculate();
}




REGISTER_SHIP(OstokDisplacer)
