#include "../ship.h"
REGISTER_FILE

class RekojAssassin : public Ship {
	double weaponRange;
	int    weaponDamage;
	double weaponVelocity;
	int    weaponArmour;

	bool   specialMatchSpeed;

	int    extraColor;
	double extraRange;
	int    extraDamage;
	int    extraAngle;
	int    extraDelay;
	int    extraBlip;
	int    extraArcLimit;

	int		 normal_recharge;
	int    normal_rate;
	




	public:
	RekojAssassin(double ox, double oy, double angle, ShipData *data, unsigned int code);

	virtual int activate_weapon();
	virtual int activate_special();
	virtual void calculate();
};


RekojAssassin::RekojAssassin(double ox, double oy, double angle, ShipData *data, unsigned int code) 
	:
	Ship(ox, oy, angle, data, code)

{
  weaponRange			= scale_range(get_config_float("Weapon", "Range", 0));
  weaponDamage		= get_config_int("Weapon", "Damage", 0);
	weaponVelocity	= scale_velocity(get_config_float("Weapon", "Velocity", 0));
  weaponArmour		= get_config_int("Weapon", "Armour", 0);

	specialMatchSpeed = false;

  extraColor			= get_config_int("Extra", "Color", 0);
  extraRange			= scale_range(get_config_float("Extra", "Range", 0));
  extraDamage			= get_config_int("Extra", "Damage", 0);
	extraDelay			= get_config_int("Extra", "Delay", 0);
	extraArcLimit		= get_config_float("Extra", "ArcLimit", 0);
	extraBlip				= 0;

	normal_recharge = recharge_amount;
	normal_rate			= recharge_rate;

}

int RekojAssassin::activate_weapon()
{
	double shipVelocity = sqrt(vx*vx + vy*vy);

	game->addItem(new Missile(this, 0.0, (height() / 2.0),
		angle, fabs(shipVelocity)+weaponVelocity, weaponDamage, weaponRange, weaponArmour,
		this, data->spriteWeapon));

  return(TRUE);
}

int RekojAssassin::activate_special()
{ 
	specialMatchSpeed = !specialMatchSpeed;
  return(TRUE);
}

void RekojAssassin::calculate()
	{

	Ship::calculate();

	if (target != NULL) {
		
			if (distance(target) > weaponRange) 
				 specialMatchSpeed = false;

			if (specialMatchSpeed) {
				nextkeys &= ~(KEYFLAG_THRUST);
				recharge_step=0;
				recharge_rate=0;
				recharge_amount=0;

				vx = target->get_vx();
				vy = target->get_vy();
				} else specialMatchSpeed = false;
		}
	 else specialMatchSpeed = false;

	 if (batt==0)  specialMatchSpeed = false;

	 if (!specialMatchSpeed) {
		 recharge_rate=normal_rate;
		 recharge_amount=normal_recharge;
		 }
		 



	//Laser finder
	if (target != NULL)
		if (target->isInvisible()) {
			extraBlip++;
			if (extraBlip==extraDelay) {
				double angleDiff;
				double blipAngle;
				
				angleDiff = trajectory_angle(target) - angle; //reference is angle of ship

				if (angleDiff < 0) angleDiff += 360.0;

				if (angleDiff > 180 && angleDiff < (360 - extraArcLimit)) blipAngle = angle-extraArcLimit;
				 else if (angleDiff > extraArcLimit && angleDiff < 180) blipAngle = angle+extraArcLimit;
					else blipAngle = trajectory_angle(target);

				blipAngle = normalize(blipAngle,360);

				extraBlip=0;
				game->addItem(new Laser(this, blipAngle,
					pallete_color[extraColor], extraRange, extraDamage, weapon_rate,
					this, width()/11, (h / 2.07), true));
				}
			}


	}

REGISTER_SHIP(RekojAssassin)
