
#include "../ship.h"
REGISTER_FILE

class SlylandroProbe2 : public Ship {
  int frame;
  int thrustActive;
  int thrustForward;
  int segments;
  int segment_length, segment_dispersion;
  int rnd_angle, aiming, dispersion;

  int weaponDamage, weaponArmour, weaponLifetime, weaponFuel;
  double weaponMaxSpeed, weaponAcceleration, weaponTurnRate, weaponAccelAngle;

  double specialRange;

  int sprite_index2;

  public:
  SlylandroProbe2(double ox, double oy, double shipAngle,
    ShipData *shipData, unsigned int code);

  int crewPanelColor();

  virtual void calculate_thrust();
  virtual void calculate_hotspots();
  virtual int activate_weapon();
  virtual void calculate();
  virtual void inflict_damage(SpaceObject *other);
  virtual void calculate_fire_special();
//  virtual int activate_special();
};

class SlylandroMissile : public SpaceObject
{
  double accel_rate, turn_rate, max_speed, accel_angle;
  int fuel, lifetime, armour;
  double get_aim(SpaceObject *tgt);
  int hotspot_frame;
  public:
  SlylandroMissile (SpaceLocation *creator, double oaccel, double omaxspeed, double oturnrate,
                    int olifetime, int ofuel, int odamage, int oarmour, SpaceSprite *osprite, double oaa);
  virtual void calculate();
  virtual void handle_damage(SpaceLocation *source);
  virtual void inflict_damage(SpaceObject *other);
};

class SlylandroLaser2 : public Laser {
	int level;
	SpaceLocation *target;
//        double t_x, t_y;
	Ship *ship;
	double base_length, aiming, dispersion;

  public:
  SlylandroLaser2(Ship *lship, SpaceLocation *lroot, SpaceLocation *ltarget, 
			int llevel, int b_length, int r_length,
                        int r_angle, int oaiming, int odispersion);

  virtual void calculate();
};

SlylandroProbe2::SlylandroProbe2(double ox, double oy, double shipAngle,
	ShipData *shipData, unsigned int code)
	:
	Ship(ox, oy, shipAngle, shipData, code),
  frame(0),
  thrustActive(FALSE),
  thrustForward(TRUE)
{
        weaponAcceleration = scale_acceleration(get_config_float("Weapon", "Acceleration", 0),0);
        weaponMaxSpeed  = scale_velocity(get_config_float("Weapon", "MaxSpeed", 0));
        weaponTurnRate  = scale_turning(get_config_float("Weapon", "TurnRate", 0));
        weaponDamage    = get_config_int("Weapon", "Damage", 0);
        weaponArmour    = get_config_int("Weapon", "Armour", 0);
        weaponLifetime  = get_config_int("Weapon", "Lifetime", 0);
        weaponFuel      = get_config_int("Weapon", "Fuel", 0);
        weaponAccelAngle= get_config_float("Weapon", "AccelAngle", 180);

        specialRange    = scale_range(get_config_float("Special", "Range", 0));
        
	sprite_index2 = random() & 63;

        segment_length = get_config_int("Weapon", "SegmentLength",0);
        segment_dispersion = get_config_int("Weapon", "SegmentLengthDispersion",0);
        segments = get_config_int("Weapon", "Segments", 0);
        rnd_angle = get_config_int("Weapon", "RandomAngle", 0);
        aiming = get_config_int("Weapon", "Aiming", 0);
        dispersion = get_config_int("Weapon", "Dispersion", 0);
}

int SlylandroProbe2::crewPanelColor()
{
  return pallete_color[8];
}

void SlylandroProbe2::calculate_fire_special()
{
}

void SlylandroProbe2::calculate()
{
	Ship::calculate();

  frame+= frame_time;
  if(frame >= 50) {
    frame -= 50;
    if(thrustForward) {
      sprite_index2++;
      if(sprite_index2 == 64)
        sprite_index2 = 0;
    } else {
      sprite_index2--;
      if(sprite_index2 == -1)
        sprite_index2 = 63;
    }
  }
	sprite_index = sprite_index2;

}

void SlylandroProbe2::calculate_hotspots() {
	}
        
/*int SlylandroProbe2::activate_special() {
        Query q;
        double r = 1e40;
        SpaceObject *tgt = NULL;
        for (q.begin(this, OBJECT_LAYERS, specialRange); q.currento; q.next())
                if ((q.currento->isAsteroid()) && (distance(q.currento)<1e40)) {
                        tgt = (SpaceObject*)q.currento;
                        r = distance(q.currento); }
        if (tgt) {
                game->addItem(new SlylandroLaser2( this, this, tgt, segments, segment_length,
                                         segment_dispersion, rnd_angle, aiming, dispersion));
	        batt = batt_max;
	        play_sound2(data->sampleSpecial[0]);

                return true; }
        else    return false;
}*/


void SlylandroProbe2::calculate_thrust() {
	if (thrust && !thrustActive) {
		angle = angle + 180.0;
		if (angle > 360.0) angle -= 360.0;
		}
	thrustActive = thrust;
	thrust = true;
	Ship::calculate_thrust();
	thrust = thrustActive;
	return;
	}

int SlylandroProbe2::activate_weapon()
{
        game->addItem(new SlylandroMissile(this, weaponAcceleration, weaponMaxSpeed, weaponTurnRate,
                          weaponLifetime, weaponFuel, weaponDamage, weaponArmour, data->spriteWeapon, weaponAccelAngle));
        return(TRUE);
}

void SlylandroProbe2::inflict_damage(SpaceObject *other) {
	if (!fire_special || !other->isAsteroid()) {
		Ship::inflict_damage(other);
		return;	}
	damage_factor = 1;
	Ship::inflict_damage(other);
	damage_factor = 0;
	batt = batt_max;
	play_sound2(data->sampleSpecial[0]);
	return;
	}


SlylandroMissile::SlylandroMissile (SpaceLocation *creator, double oaccel, double omaxspeed, double oturnrate, int olifetime, int ofuel, int odamage, int oarmour, SpaceSprite *osprite, double oaa) :
        SpaceObject(creator,creator->normal_x(),creator->normal_y(),
        creator->get_angle(), osprite)
{
        accel_rate = oaccel;
        turn_rate = oturnrate;
        max_speed = omaxspeed;
        damage_factor = odamage;
        armour = oarmour;
        lifetime = olifetime;
        fuel = ofuel;
        accel_angle = oaa;
        sprite_index = (int(angle/5.625)+16)&63;
        vx = creator->get_vx();
        vy = creator->get_vy();
        hotspot_frame = 0;
}

double SlylandroMissile::get_aim(SpaceObject *tgt) {
        double tvx = tgt->get_vx();
        double tvy = tgt->get_vy();
        double rx  = min_delta(tgt->normal_x(), normal_x(), X_MAX);
        double ry  = min_delta(tgt->normal_y(), normal_y(), Y_MAX);
        double r2  = rx*rx + ry*ry;
        double u2  = max_speed * max_speed;
        double d2v = u2 - (tvx*tvx + tvy*tvy);
        double t = (rx*tvx + ry*tvy);
        double q, p;
        if (fabs(d2v/u2) > 0.01 ) {
                q = t*t + r2*d2v;
                if (q > 0) q = sqrt(q);
                else    return (1e10);
                p = (t+q)/d2v;
                q = (t-q)/d2v;
                if (p > 0) t = p;
                else       t = q;
                if (t < 0) return (1e10); }
        else {
                if (fabs(t)<1e-6) return (1e10);
                else    t = - 0.5 * r2 / t;
                if (t < 0) return (1e10); }
        t = normalize(atan3(tvy*t + ry, tvx*t + rx) * 180 / PI - angle, 360);
        if (t > 180) t -= 360;
        return (t);
}

void SlylandroMissile::calculate()
{
        SpaceObject::calculate();
        lifetime -= frame_time;
        if (hotspot_frame > 0)
                hotspot_frame -= frame_time;
        if (lifetime <= 0) {
                state = 0;
                return; }
        if ((!target) && (fuel > 0)) {
                accelerate(this, angle, accel_rate*frame_time, max_speed);
                fuel -= frame_time;
                if (hotspot_frame <= 0) {
                        game->addItem(new Animation(this, x - cos(angle*ANGLE_RATIO)*8,
                                                    y - sin(angle*ANGLE_RATIO)*8,
                                                    data->spriteExtra, 0, 6, 50, LAYER_HOTSPOTS));
                        hotspot_frame += 50; }
                return; }
        if ((fuel >= 0) && target && !target->isInvisible()) {
		double d_a = get_aim(target);
		double ta = turn_rate * frame_time;
		if (fabs(d_a) < ta) ta = fabs(d_a);
		if (d_a > 0) angle += ta;
		else angle -= ta;
		angle = normalize(angle, 360);
                sprite_index = ((int)(angle / 5.625) + 16)&63;
                if (fabs(d_a) < accel_angle) {
                        accelerate(this, angle, accel_rate*frame_time, max_speed);
                        fuel -= frame_time;
                        if (hotspot_frame <= 0) {
                                game->addItem(new Animation(this, x - cos(angle*ANGLE_RATIO)*8,
                                                            y - sin(angle*ANGLE_RATIO)*8,
                                                            data->spriteExtra, 0, 6, 50, LAYER_HOTSPOTS));
                                hotspot_frame += 50; }
                }
        }
}

void SlylandroMissile::handle_damage(SpaceLocation *source)
{
        if ((armour -= (damage + directDamage)) <= 0) {
                state = 0;
                game->addItem(new Animation(this, x, y, game->sparkSprite, 0, SPARK_FRAMES, scale_frames(0), LAYER_EXPLOSIONS));
        }
}

void SlylandroMissile::inflict_damage(SpaceObject *other)
{
        if (!other->isShot()) {
                state = 0;
                game->addItem(new Animation(this, x, y, game->sparkSprite, 0, SPARK_FRAMES, scale_frames(0), LAYER_EXPLOSIONS));
        }
        SpaceObject::inflict_damage(other);
}


SlylandroLaser2::SlylandroLaser2(Ship *lship, SpaceLocation *lroot, 
		SpaceLocation *ltarget, int llevel, int b_length, int r_length,
                int r_angle, int oaiming, int odispersion) :
		Laser(lship, 0, pallete_color[15], 0.0, 1, 300, lroot, 0.0, 0.0),
		level(llevel), target(ltarget), ship(lship),
                aiming(oaiming), dispersion(odispersion)
{
	base_length = (random()%(2*r_length+1) - r_length) + b_length;
	x = pos->normal_x();
	y = pos->normal_y();
	if (target) angle = trajectory_angle(target);
	else angle = random() % 360;
	if (ship != pos) {
		x += ((SlylandroLaser2 *)(pos))->edge_x();
		y += ((SlylandroLaser2 *)(pos))->edge_y();
		}
	angle += (random() % (r_angle*2+1)) - r_angle;
	color = pallete_color[79 - level * 2 - (random()%8)];
	if (level) game->addItem(new SlylandroLaser2(ship, this, target, level-1, b_length,
                                         r_length, r_angle, aiming, dispersion));
	}

void SlylandroLaser2::calculate() {
	Laser::calculate();
	if (frame < (frame_count/2)) length = base_length * (frame) / frame_count;
	else length = base_length * (frame_count-frame) / frame_count;
	if (!pos->exists()) return;
	x = pos->normal_x();
	y = pos->normal_y();
	if (ship != pos) {
		x += ((SlylandroLaser2 *)(pos))->edge_x();
		y += ((SlylandroLaser2 *)(pos))->edge_y();
		}
	if (!target) return;
        double d_a = normalize(trajectory_angle(target) - angle, 360);
        if (d_a > 180) d_a -= 360;
        if (d_a > 0)
                angle += (aiming + dispersion*(-50+random()%101) / sqrt(frame_time)) * frame_time / 100.0;
        else
                angle -= (aiming + dispersion*(-50+random()%101) / sqrt(frame_time)) * frame_time / 100.0;
	if (!target->exists()) target = NULL;
	return;
	}


REGISTER_SHIP(SlylandroProbe2)
