/************************************************/
/*	Modified from Earthling Cruiser		*/
/*	Mines lifted from Vux			*/
/*	highlight taken from Owa		*/
/************************************************/
/*	In total defiance of Timewarp tradition	*/
/*	I have COMMENTED MY CODE! Muhahahahaha!	*/
/*			-Corona688, 2001	*/
/************************************************/

#include "../ship.h"
REGISTER_FILE

#define RadScale (3.14159/180.)

//Target structure, includes Ship * and Time_Count.
struct Marked
{
	Ship *Tagged;
	int Time_Count;
};

class StrivanarScrutinizer : public Ship {
	double	weaponRange;
	double	weaponVelocity;
	int	weaponDamage;
	int	weaponArmour;
	double	weaponTurnRate;

	double	specialRange;	//Range of marker beacons
	double	specialFan;	//How wide a spread the beacons are fired in
	int	specialFrames;
	int	specialMarkernum;
	double specialVelocity;	//Velocity of marker beacons

	Marked Tag;	//Struct that holds data on a tagged ship

//	Ship *Tagged;	//Whenever a Marker lands on an opponent, this will point to the opponent.
			//Otherwise, this will be NULL.

public:
	StrivanarScrutinizer(double ox, double oy, double shipAngle,
	ShipData *shipData, unsigned int code);

protected:
	void calculate();
	virtual int activate_weapon();
	virtual int activate_special();

};

/* This section contains ALL my code on the homing missile. */
class TechMissile : public HomingMissile
{
public:
	TechMissile(double ox, double oy, double oangle, double ov,
		int odamage, double orange, int oarmour, double otrate, Ship *oship,
		SpaceSprite *osprite, Ship *Target);

	virtual void calculate();
};

//I have overloaded the missile tracking function with one that can track
//invisible ships.  Note that these missiles are not fired unless a Marker
//has attached to something.
void TechMissile::calculate() {
	Missile::calculate();

	//This used to be if(target&&!invisible()), or something like that.
	if (target) {
		double d_a = normalize(trajectory_angle(target) - (angle + turn_step), 360);
		if (d_a > 180) d_a -= 360;
		if (fabs(d_a) < turn_rate *frame_time) turn_step += d_a;
		else if (d_a > 0) turn_step += turn_rate *frame_time;
		else turn_step -= turn_rate *frame_time;
		while(fabs(turn_step) > 5.625/2) {
			if(turn_step < 0.0) {
				angle -= 5.625;
				turn_step += 5.625;
				}
			else if (turn_step > 0.0) {
				angle += 5.625;
				turn_step -= 5.625;
				}
			}
		angle = normalize(angle, 360);
		}

	sprite_index = (int)(angle / 5.625) + 16;
	sprite_index &= 63;

	vx = v * cos(angle * ANGLE_RATIO);
	vy = v * sin(angle * ANGLE_RATIO);
	return;
}

//This is the overloaded function, for a missle that homes in on a beacon
//instead of targeting something automatically.
TechMissile::TechMissile(double ox, double oy, double oangle,
	double ov, int odamage, double orange, int oarmour, double otrate,
	Ship *oship, SpaceSprite *osprite,Ship *Target) :
	HomingMissile(oship, ox, oy, oangle, ov, odamage, orange, oarmour, otrate, 
	oship, osprite, Target)
{
	collide_flag_sameship = bit(LAYER_SHIPS) | bit(LAYER_SHOTS);
	explosionSprite     = data->spriteWeaponExplosion;
	explosionFrameCount = 10;
	explosionFrameSize  = 50;
}
/* Missile section ends here.	*/

/*This section contains ALL my code for the red flashing hilight on ships. */

//These are the spots of red flashing light that appear on 'marked' ships.
//Modified from the Owa disable special.
class Hilight : public SpaceObject
{
	int 	frame_min;
	int	frame_max;
	int	frame_count;
	int	MaxTime;
	Marked	*mk;		//Pointer to target structure

public:

	Hilight(Marked *otarget, Ship *ocreator, SpaceSprite *osprite, int Delay,
		int FrameMin, int FrameMax);

	virtual void target_died();
	virtual void calculate();
	void reset_time();
};

Hilight::Hilight(Marked *otarget, Ship *ocreator, SpaceSprite *osprite,
	int Delay, int FrameMin,int FrameMax) :
	SpaceObject(ocreator, otarget->Tagged->normal_x(), otarget->Tagged->normal_y(), 0.0, osprite),
	frame_min(FrameMin),
	frame_max(FrameMax),
	frame_count(0),
	MaxTime(Delay)
{
	mk=otarget;
	id = 0x36;
	sprite_index = frame_count;
	collide_flag_anyone = 0;
	layer = LAYER_SPECIAL;
}

void Hilight::target_died()
{
	state = 0;
	mk->Tagged=NULL;
	return;
}

void Hilight::calculate()
{
	frame_count++;
	if(frame_count>=frame_max)	frame_count=frame_min;
	sprite_index=frame_count;

	//If the mothership doesn't exist, turn the hilight off.
	if(!ship->exists())
	{
		state=0;
		return;
	}

	//If the target doesn't exist, turn the hilight off.
	if(mk->Tagged==NULL)
	{
		state=0;
		mk->Tagged=NULL;
		mk->Time_Count=0;

		return;
	}

	//Move Hilight to current position of target
	x = mk->Tagged->normal_x();
	y = mk->Tagged->normal_y();


	//If time has run out, turn off hilight.
	if(mk->Time_Count>=MaxTime)
	{
		mk->Tagged=NULL;
		mk->Time_Count=1;
		state = 0;
	}

	SpaceObject::calculate();
	return;
}

void Hilight::reset_time()
{
//  disableframe = 0;
}
/*Hilight secton ends here.	*/

/*This contains ALL my code for the loose marker beacons. */
//These are loose marker beacons, modified from Vux limpets.
class Marker : public AnimatedShot
{
	double local_angle;
	int D_Time;
	Marked *To_Target;
public:
	Marker(double ox, double oy, double ov, double s_angle, Marked *Tag, int Duration,
		double orange, int oarmour, Ship *oship, SpaceSprite *osprite, int ofcount, int ofsize);

	virtual void calculate();
	virtual void inflict_damage(SpaceObject *other);
};

Marker::Marker(double ox, double oy, double ov, double s_angle, Marked *Tag, int Duration,
	double orange, int oarmour, Ship *oship, SpaceSprite *osprite,
	int ofsize, int ofcount) :
	AnimatedShot(oship, ox, oy, 0.0, ov, 0, orange, oarmour, oship, osprite,
	ofcount, ofsize), local_angle(s_angle)
{
	To_Target=Tag;
	D_Time=Duration;

	angle = local_angle;
	vx    = v * cos(angle * ANGLE_RATIO);
	vy    = v * sin(angle * ANGLE_RATIO);

	//If the mothership is dead, so is this loose beacon.
	if(!ship->exists())	state = 0;
}

void Marker::calculate()
{
	state=1;

	//If the mothership is destroyed, any loose beacons also die.
	if(!ship->exists())
	{
		state = 0;
		return;
	}

	AnimatedShot::calculate();
}

void Marker::inflict_damage(SpaceObject *other)
{
	//If the target isn't a ship, don't latch on.
	if(!other->isShip())
	{
		if (other->damage_factor || other->mass) state = 0;
		return;
	}



	sound.play(data->sampleExtra[0]);	//Play the 'hull clamp' sound

	//If you've tagged a different ship, make a new Hilight
	if((Ship *)other!=To_Target->Tagged)
	{
		To_Target->Tagged=(Ship *)other;	//Record pointer to ship
		To_Target->Time_Count=0;

		game->addItem(new Hilight(To_Target,ship,data->spriteExtraExplosion,
			D_Time, 1,63));
	}

	//If it's the same ship, just refill the time delay.
	else	To_Target->Time_Count=0;

		state = 0;				//Remove it from melee
}
/*Marker code ends here. */

/*This contains my code for the Strivinar Scrutinezer. */

StrivanarScrutinizer::StrivanarScrutinizer(double ox, double oy, double shipAngle,
	ShipData *shipData, unsigned int code) :
	Ship(ox, oy, shipAngle, shipData, code)
{

	weaponRange    = scale_range(get_config_float("Weapon", "Range", 0));
	weaponVelocity = scale_velocity(get_config_float("Weapon", "Velocity", 0));
	weaponDamage   = get_config_int("Weapon", "Damage", 0);
	weaponArmour   = get_config_int("Weapon", "Armour", 0);
	weaponTurnRate = scale_turning(get_config_float("Weapon", "TurnRate", 0));

	specialRange  = scale_range(get_config_float("Special", "Range", 0));
	specialFrames = get_config_int("Special", "Frames", 0);
	specialFan = get_config_float("Special","Fan",0);
	specialVelocity=scale_velocity(get_config_float("Special","Velocity",0));
	specialMarkernum=get_config_int("Special","Markers",0);

	collide_flag_sameship = bit(LAYER_SHOTS);
	Tag.Tagged=NULL;
	Tag.Time_Count=0;
}
void StrivanarScrutinizer::calculate()
{
	/*My code*/

	//If beacon has latched onto something...
	if(Tag.Tagged!=NULL)
	{	//If that 'something' doesn't exist, turn it off.
		if(!Tag.Tagged->exists())
		{
			Tag.Tagged=NULL;
			Tag.Time_Count=0;
		}

		//Play 'hull clamp' sound if Time_Count is a multiple of 50.
		if((Tag.Time_Count%50)==0)
			sound.play(data->sampleExtra[1]);
		Tag.Time_Count++;
	}
	/*End of my code*/

	Ship::calculate();
}


int StrivanarScrutinizer::activate_weapon()
{
	if(Tag.Tagged==NULL)
	{
		return(FALSE);
	}

	if(!Tag.Tagged->exists())
	{
		Tag.Tagged=NULL;
		Tag.Time_Count=0;
		return(FALSE);
	}

	float xpos;
	xpos=10.*sin((angle+51.42)*RadScale);
	game->addItem(new TechMissile(xpos, (height() * .5), angle, weaponVelocity, weaponDamage, weaponRange,
				weaponArmour, weaponTurnRate, this, data->spriteWeapon,Tag.Tagged));


	return(TRUE);
}

int StrivanarScrutinizer::activate_special()
{
	float min=angle-(specialFan/2);
	float max=angle+(specialFan/2);
	float step=(max-min)/specialMarkernum;

	for(float num=min; num<max; num+=step)
		game->addItem(new Marker(0, 0 ,specialVelocity, num, &Tag,specialFrames, specialRange, 2., this,data->spriteSpecial, 100, 5));

	return(TRUE);
}

/*My code ends here. */



REGISTER_SHIP(StrivanarScrutinizer)
