#include "../ship.h"
REGISTER_FILE

class VirtaoLimb : public Ship {
  double       weaponRange;
  double       weaponVelocity;
  int          weaponDamage;
  int          weaponArmour;
  double       weaponTurnRate;

  double specialRange;
  double specialPower;

  public:
  VirtaoLimb(double ox, double oy, double shipAngle,
		ShipData *shipData, unsigned int code);

  protected:
  virtual int activate_weapon();
  virtual int activate_special();
};

class VirtaoMissile : public HomingMissile {
  public:
  VirtaoMissile(double ox, double oy, double oangle, double ov,
    int odamage, double orange, int oarmour, double otrate, Ship *oship,
    SpaceSprite *osprite);
};

VirtaoLimb::VirtaoLimb(double ox, double oy, double shipAngle,
	ShipData *shipData, unsigned int code) 
	:
  Ship(ox, oy, shipAngle, shipData, code) {

  weaponRange    = scale_range(get_config_float("Weapon", "Range", 0));
  weaponVelocity = scale_velocity(get_config_float("Weapon", "Velocity", 0));
  weaponDamage   = get_config_int("Weapon", "Damage", 0);
  weaponArmour   = get_config_int("Weapon", "Armour", 0);
  weaponTurnRate = scale_turning(get_config_float("Weapon", "TurnRate", 0));

  specialRange  = scale_range(get_config_float("Special", "Range", 0));
  specialPower  = scale_range(get_config_float("Special", "Power", 0));

}

int VirtaoLimb::activate_weapon() {
  game->addItem(new VirtaoMissile(
    0.0, (height() / 2.0), angle, weaponVelocity, weaponDamage, weaponRange,
    weaponArmour, weaponTurnRate, this, data->spriteWeapon));
  return(TRUE);
}

int VirtaoLimb::activate_special() {
  int fire = FALSE;

	Query q;
	for (q.begin(this, ALL_LAYERS, specialRange);q.current;q.next()) {
		if (q.current->canCollide(this)) {
			double a = trajectory_angle(q.current) * PI / 180;
			q.current->translate(cos(a) * 300, sin(a) * specialPower);
			fire = TRUE;
			}
		}
	q.end();
	if (fire) play_sound((SAMPLE *)(melee[MELEE_BOOM + 0].dat));

	return(fire);
	}

VirtaoMissile::VirtaoMissile(double ox, double oy, double oangle,
  double ov, int odamage, double orange, int oarmour, double otrate, 
  Ship *oship, SpaceSprite *osprite) :
  HomingMissile(oship, ox, oy, oangle, ov, odamage, orange, oarmour, otrate, oship, osprite, oship->target)
{
  explosionSprite     = data->spriteWeaponExplosion;
  explosionFrameCount = 10;
  explosionFrameSize  = 50;
}




REGISTER_SHIP(VirtaoLimb)
