/* sorry for the tons of tests... dunno where to insert checks/validations */

#include "../ship.h"
REGISTER_FILE
#include <string.h>
#include "../melee/mview.h"

class WasxClone;

class WasxSuperposition : public Ship {
	double weaponRange;
	double weaponVelocity;
	int    weaponDamage;
	double weaponArmour;

	int    specialArmour;
	int    num_Clone;
	int    max_Clone;

	//int	   FireWeapon[3];
	int		 FireWeapon[4];

	int	   SpawnFresh;
	int    SpawnLifeCost;
	int    SpawnFormation;


	WasxClone **Clone;

	public:
	WasxSuperposition(double ox, double oy, double shipAngle,
		ShipData *shipData, unsigned int code);

	friend class WasxClone;
	
	virtual int  isInvisible(); 
	virtual int  activate_weapon();
	virtual int  activate_special();
	// virtual int  canCollide(SpaceLocation *source);

	};


class WasxShot : public Shot {
	public:
	WasxShot(double x, double y, double angle, double velocity, int damage, 
			double range, int armour, Ship *ship);
	virtual void inflict_damage(SpaceObject *other) ;
	};

class WasxClone : public Ship {
	WasxSuperposition *MotherShip;
	Control  *cntrl;
	ShipData *shipData;

	double weaponRange;
	double weaponVelocity;
	int    weaponDamage;
	double weaponArmour;

	int    specialArmour;
	int	   initialVelocity;
	int	   Forming;

	public:
	WasxClone(double ox, double oy, double shipAngle,
		ShipData *shipData, Control *cntrl, WasxSuperposition *MotherShip);
	int     CloneIndex;

    virtual int  activate_weapon(); 
	  // virtual int  canCollide(SpaceLocation *source);
    virtual void handle_damage(SpaceLocation *source);
	virtual void calculate();
	virtual void death();

	};

WasxSuperposition::WasxSuperposition(double ox, double oy, double shipAngle,
		ShipData *shipData, unsigned int code) :
		Ship(ox, oy, shipAngle, shipData, code)

	{

	weaponDamage = get_config_int("Weapon", "Damage", 0);
	weaponArmour = get_config_int("Weapon", "Armour", 0);
	weaponRange  = scale_range(get_config_float("Weapon", "Range", 0));
	weaponVelocity  = scale_velocity(get_config_float("Weapon", "Velocity", 0));

	specialArmour = get_config_int( "Special", "Armour", 0);

	max_Clone = 4; // there are hard-coded routines here ie. switch statements
	num_Clone = 0;

	SpawnFresh	   = get_config_int("Others", "SpawnFresh", 0);
	SpawnLifeCost  = get_config_int("Others", "SpawnLifeCost", 0);
	SpawnFormation = get_config_int("Others", "SpawnFormation", 0);

	if (SpawnLifeCost == 0 && crew >= 4) crew -= 4;


  collide_flag_anyone   = ALL_LAYERS;
  collide_flag_sameship = ~bit(LAYER_SHOTS) & ~bit(LAYER_SHIPS);
  collide_flag_sameteam = bit(LAYER_SHIPS);

	// collide_flag_sameship    = ~bit(LAYER_SHOTS) & ~bit(LAYER_SHIPS);
	//collide_flag_anyone  = ALL_LAYERS;


	Clone      = new WasxClone*[max_Clone];
	/*for (int i = 0; i < max_Clone; i += 1) {
		Clone[i] = NULL;
		FireWeapon[i] = FALSE;
		}
		*/

	for (int i = 1; i <= max_Clone; i += 1) {
		Clone[i] = NULL;
		FireWeapon[i] = FALSE;
		}
	}


WasxShot::WasxShot(double x, double y, double angle, double velocity, 
		 int damage, double range, int armour, Ship *ship) :
		Shot(ship, x, y, angle, velocity, damage, range, armour, ship, 
				ship->data->spriteWeapon, 0)
	{
	}

void WasxShot::inflict_damage(SpaceObject *other) {
	if (!sameShip(other)) {
		Shot::inflict_damage(other);
		}
	return;
	}

int WasxSuperposition::isInvisible() {
	if (num_Clone == max_Clone) return(true);
	 else return false;
} 

int WasxSuperposition::activate_weapon() {

    if (this == NULL 
	|| !this->exists() 
	|| ship == NULL 
	|| !ship->exists()) return(FALSE);


	double AngleWithLead = angle;
	double TargetRange   = 0;
	int    WeaponOffSet;
	int    j;

	/* for (j=0; j < max_Clone; j += 1) {
		FireWeapon[j] = TRUE;
	} */

	for (j=1; j <= max_Clone; j += 1) {
		FireWeapon[j] = TRUE;
	} 

	if (target !=NULL && target->exists()) TargetRange = distance(target);

	TargetRange = TargetRange / weaponVelocity;

	for (WeaponOffSet=1; WeaponOffSet < 4; WeaponOffSet += 1 ) {
		
		double WOS  = (ship->width() + ship->height()) / 2;

		switch (WeaponOffSet) {
		case 1:
				WOS = WOS * 0.15;
				break;
		case 2:
				WOS = WOS * -0.15;
				break;
		default:
				WOS = 0.0;
		} // switch

		if (target != NULL && target->exists()) {
			double x = min_delta( normal_x(),target->normal_x() - 
					(get_vx() - target->get_vx()) * TargetRange, X_MAX) ;

			double y = min_delta( normal_y(), target->normal_y() - 
					(get_vy() - target->get_vy()) * TargetRange, Y_MAX) ;

			if (!target->isInvisible()) AngleWithLead = (atan3(y, x) * 180 / PI - 180);

        } 
		double rVelocity;
		int rv = int (random() & 3); 
		switch (rv) {
		case 1:
			rVelocity = weaponVelocity * .75;
			break;
		case 2:
			rVelocity = weaponVelocity * .85;
			break;
		case 3:
			rVelocity = weaponVelocity * .95;
			break;
		default:
			rVelocity = weaponVelocity;
		}


		
		game->addItem(new WasxShot( WOS, WOS,AngleWithLead, rVelocity, weaponDamage,
			  weaponRange, weaponArmour, this));
	} // for


	return(TRUE);

	}

int WasxSuperposition::activate_special() {

    if (this == NULL 
		|| !this->exists() 
		|| ship == NULL 
		|| !ship->exists()) return(FALSE);
	
	int i;
	double dx, dy, da, mx, my;
	int SpecialActivated = FALSE;

	dx = dy = da = mx = my = 0;

	for (i=0; (i < 2) && (num_Clone < max_Clone) && (crew > SpawnLifeCost); i +=1) {
		if (num_Clone == max_Clone) {
			num_Clone -= 1;
			Clone[0]->state = 0;
			memcpy(&Clone[0], &Clone[1], sizeof(WasxSuperposition*) * num_Clone);
			Clone[num_Clone] = NULL;
			}

		// these lines are made obsolete/overridden by formation routine???
		if (i==0) {
			dx = normal_x() + cos((angle +  30) * ANGLE_RATIO) * 100; 
			dy = normal_y() + sin((angle +  30) * ANGLE_RATIO) * 100;
			da = angle + 5.625;
		}
		 else {
			 dx = normal_x() + cos((angle + 330) * ANGLE_RATIO) * 100;
			 dy = normal_y() + sin((angle + 330) * ANGLE_RATIO) * 100;
			 da = angle - 5.625;
		 }
		 // upto here
		crew -= int(SpawnLifeCost);
		num_Clone += 1;
		WasxClone *tmp = new WasxClone(dx,dy,da,data ,control, this);

		mx = normal_x();
		my = normal_y();
		if (turn_left || turn_right) {
			tmp->translate(mx-dx, my-dy);
			translate(dx-mx, dy-my);
		}

		game->addItem(tmp);
		SpecialActivated = TRUE;

	}
	if (!SpecialActivated) return(FALSE);
	 return(TRUE);
	}


/* int WasxSuperposition::canCollide(SpaceLocation *other) {
	if (this == NULL 
	|| !this->exists() 
	|| ship == NULL 
	|| !ship->exists()) return(FALSE);


    if (other->isShip() && sameTeam(other)) return(FALSE);
		else return(TRUE); // isAlly doesn't work?

	} */

WasxClone::WasxClone(double ox, double oy, double shipAngle,
		ShipData *shipData, Control *cntrl, WasxSuperposition *MotherShip) :
		Ship(ox, oy, shipAngle, shipData, MotherShip->ally_flag),
		CloneIndex(0)
	{

	if (this == NULL 
	|| !this->exists() 
	|| ship == NULL 
	|| !ship->exists()
	|| MotherShip == NULL 
	|| !MotherShip->exists()) return;
			
			
	layer = LAYER_SHIPS;
 	
	initialVelocity = TRUE;
	Forming			= TRUE;

	// all this assignments really needed??? or is there a better way?
	this->MotherShip			= MotherShip;  
	this->shipData				= shipData;
	this->ally_flag				= MotherShip->ally_flag;

  collide_flag_anyone   = ALL_LAYERS;
  collide_flag_sameship = ~bit(LAYER_SHOTS) & ~bit(LAYER_SHIPS);
  collide_flag_sameteam = bit(LAYER_SHIPS);


	//this->collide_flag_sameship		= ~bit(LAYER_SHOTS) & ~bit(LAYER_SHIPS); // how do i make this thing work?
	// this->collide_flag_ally		= 0;
	this->collide_flag_anyone	= ALL_LAYERS;

	this->weaponDamage			= MotherShip->weaponDamage;
	this->weaponArmour			= MotherShip->weaponArmour;
	this->weaponRange			= MotherShip->weaponRange;
	this->weaponVelocity		= MotherShip->weaponVelocity;
	this->accel_rate			= MotherShip->accel_rate; 
	this->speed_max				= MotherShip->speed_max ;
	this->mass					= MotherShip->mass;

	if (MotherShip->SpawnFresh==0) 	this->crew	= MotherShip->crew ;
	 else this->crew = MotherShip->specialArmour;

	if (MotherShip->target != NULL && MotherShip->target->exists()) this->target = MotherShip->target;

	//this->CloneIndex			= MotherShip->num_Clone-1;
	this->CloneIndex			= MotherShip->num_Clone;

	this->specialArmour			= MotherShip->specialArmour;

	vx = ship->get_vx() + .2 * cos(angle*PI/180);
	vy = ship->get_vy() + .2 * sin(angle*PI/180);
	}

int WasxClone::activate_weapon() {

	
    if (this == NULL 
	|| !this->exists() 
	|| ship == NULL 
	|| !ship->exists()
	|| MotherShip == NULL 
	|| !MotherShip->exists()) return(FALSE);

	// redundant code starts here : same as WasxSuperposition::activate_weapon 
	// use function instead in future version passing ship and target as parameters

	double AngleWithLead = angle;
	double TargetRange   = 0;
	int    WeaponOffSet;


	if (target != NULL && target->exists()) TargetRange = distance(target);

	TargetRange = TargetRange / weaponVelocity;

	for (WeaponOffSet=1; WeaponOffSet < 4; WeaponOffSet += 1 ) {
		
		double WOS  = (ship->width() + ship->height()) / 2;

		switch (WeaponOffSet) {
		case 1:
				WOS = WOS * 0.15;
				break;
		case 2:
				WOS = WOS * -0.15;
				break;
		default:
				WOS = 0.0;
		} // switch

		if (target != NULL && target->exists()) {
			double x = min_delta(normal_x(),target->normal_x() - 
					(get_vx() - target->get_vx()) * TargetRange, X_MAX) ;

			double y = min_delta( normal_y(), target->normal_y() - 
					(get_vy() - target->get_vy()) * TargetRange, Y_MAX) ;

			if (!target->isInvisible()) AngleWithLead = (atan3(y, x) * 180 / PI - 180);

        } 
		double rVelocity;
		int rv = int (random() & 3); 
		switch (rv) {
		case 1:
			rVelocity = weaponVelocity * .75;
			break;
		case 2:
			rVelocity = weaponVelocity * .85;
			break;
		case 3:
			rVelocity = weaponVelocity * .95;
			break;
		default:
			rVelocity = weaponVelocity;
		}


		
		game->addItem(new WasxShot( WOS, WOS,AngleWithLead, rVelocity, weaponDamage,
			  weaponRange, weaponArmour, ship));
	} // for

	return(TRUE);

}

/* int WasxClone::canCollide(SpaceLocation *other) {
	if (this == NULL 
	|| !this->exists() 
	|| ship == NULL 
	|| !ship->exists()
	|| MotherShip == NULL 
	|| !MotherShip->exists()) return(FALSE);

   if (other->isShip() && sameTeam(other)) return(FALSE);
	    else return(TRUE); 

}  */

void WasxClone::handle_damage(SpaceLocation *source) {
		if (this == NULL 
		|| !this->exists() 
		|| ship == NULL 
		|| !ship->exists()
		|| MotherShip == NULL 
		|| !MotherShip->exists()) return;

	if (damage+directDamage > 0) {
		crew -= damage + directDamage;
		damage = 0;
		directDamage = 0;
		if (crew <= 0) {
			MotherShip->num_Clone -= 1;
			state=0; 
		}
	}
}
 
void WasxClone::calculate() {

	SpaceObject::calculate();

	Ship::calculate();

	if (this == NULL 
	|| !this->exists() 
	|| ship == NULL 
	|| !ship->exists()
	|| MotherShip == NULL 
	|| !MotherShip->exists()) {
	state = 0;
	return;
	}
	

	// Angle for left/right
	angle = MotherShip->get_angle();

	// Velocity for initial thrust
	if (initialVelocity) {
		vx *= 1 - .0005 * frame_time;
		vy *= 1 - .0005 * frame_time;
		if (vx * vx + vy * vy < 0.05 * 0.05) {
			vx *= 0;
			vy *= 0;
			initialVelocity=FALSE;	

		} 
		if (MotherShip->thrust) initialVelocity = FALSE;
	}  else if (MotherShip->thrust) accelerate(this, angle, accel_rate * frame_time , speed_max);

	// Try to retain a certain distance to gain formation from Mothership
	if (MotherShip->SpawnFormation == 1) {
    	double RelAngle;

		if (abs(distance(MotherShip)) > 150 ||
			abs(distance(MotherShip)) < 50) {
			switch (CloneIndex) {
			case 1:	// upper right
				RelAngle = 45;
				break;
			case 2: // upper left
				RelAngle = 315;
				break;
			case 3: // lower left
				RelAngle = 225;
				break;
			case 4: // lower right
				RelAngle = 135;
			}
			RelAngle += trajectory_angle(MotherShip);

			vx = (.2 * cos(RelAngle * PI/180)) ;
			vy = (.2 * sin(RelAngle * PI/180)) ;
			
			Forming=TRUE;
		}

		if (Forming) {
			if (abs(distance(MotherShip)) >  50 &&
				abs(distance(MotherShip)) < 150) {
				Forming = FALSE;
			}
		}


	} 


	// Hot spots
	if((MotherShip->thrust) && (MotherShip->hotspot_frame <= 0)) {
		game->addItem(new Animation(this, 
				normal_x() - (cos(angle * ANGLE_RATIO) * w / 2.5),
				normal_y() - (sin(angle * ANGLE_RATIO) * h / 2.5),
				game->hotspotSprite, 0, HOTSPOT_FRAMES, time_ratio, LAYER_HOTSPOTS));
		}

	// Re-acquire target (needed once targetting a new opponent)
	if (MotherShip->target != NULL && MotherShip->target->exists()) target = MotherShip->target;

	// Activate Weapon
	if (MotherShip->FireWeapon[CloneIndex])
		this->activate_weapon();

	MotherShip->FireWeapon[CloneIndex] = FALSE;


}

void WasxClone::death() {

	if (this == NULL 
	|| !this->exists() 
	|| ship == NULL 
	|| !ship->exists()
	|| MotherShip == NULL 
	|| !MotherShip->exists()) {
	state = 0;
	return;
	}
/*
	for (int i = 0; i < ((WasxSuperposition*)ship)->num_Clone; i += 1) {
		if (((WasxSuperposition*)ship)->Clone[i] == this) {

			((WasxSuperposition*)ship)->Clone[i] = NULL;
			delete ((WasxSuperposition*)ship)->Clone[i];
			((WasxSuperposition*)ship)->num_Clone -= 1;

			memmove(&((WasxSuperposition*)ship)->Clone[i], &((WasxSuperposition*)ship)->Clone[i+1], 
				(((WasxSuperposition*)ship)->num_Clone-i) * sizeof(WasxClone*));

			((WasxSuperposition*)ship)->Clone[i]->CloneIndex = i;

			return;
			}
		}
	*/

	for (int i = 1; i <= ((WasxSuperposition*)ship)->num_Clone; i += 1) {
		if (((WasxSuperposition*)ship)->Clone[i] == this) {

			((WasxSuperposition*)ship)->Clone[i] = NULL;
			delete ((WasxSuperposition*)ship)->Clone[i];
			((WasxSuperposition*)ship)->num_Clone -= 1;

			memmove(&((WasxSuperposition*)ship)->Clone[i], &((WasxSuperposition*)ship)->Clone[i+1], 
				(((WasxSuperposition*)ship)->num_Clone-i) * sizeof(WasxClone*));

			((WasxSuperposition*)ship)->Clone[i]->CloneIndex = i;

			return;
			}
		}


	}


REGISTER_SHIP(WasxSuperposition)