//ZekfahanShocker lousy code by Richardyzo@ig.com.br

#include "../ship.h"
REGISTER_FILE

class ZekfahanShocker : public Ship {
  double       weaponRange;
  double       weaponVelocity;
  int          weaponDamage;
  int          weaponArmour;

  double	specialRange;
  double	specialVelocity;
  int		specialDamage;
  int		specialArmour;
  int		specialFrames;
  int           shockingFrames;
  int		shockVar;

  public:
  ZekfahanShocker(double ox, double oy, double shipAngle,
		ShipData *shipData, unsigned int code);

  protected:
  virtual int activate_weapon();
  virtual int activate_special();
  virtual void calculate();

};

class Shockwave : public AnimatedShot {

  public:
  Shockwave(double ox, double oy, double oangle, double ov,
  int odamage, double orange, int oarmour, Ship *oship, SpaceLocation *opos,
  SpaceSprite *osprite, int ofcount, int ofsize);

  virtual void inflict_damage(SpaceObject *other);
};

ZekfahanShocker::ZekfahanShocker(double ox, double oy, double shipAngle,
	ShipData *shipData, unsigned int code) 
	:
  Ship(ox, oy, shipAngle, shipData, code)
{
  weaponRange    = scale_range(get_config_float("Weapon", "Range", 0));
  weaponVelocity = scale_velocity(get_config_float("Weapon", "Velocity", 0));
  weaponDamage   = get_config_int("Weapon", "Damage", 0);
  weaponArmour   = get_config_int("Weapon", "Armour", 0);

  specialRange    = scale_range(get_config_float("Special", "Range", 0));
  specialVelocity = scale_velocity(get_config_float("Special", "Velocity", 0));
  specialDamage   = get_config_int("Special", "Damage", 0);
  specialArmour   = get_config_int("Special", "Armour", 0);
  specialFrames   = get_config_int("Special", "Frames", 0);
  shockingFrames  = 0;
  shockVar        = 0;
}

int ZekfahanShocker::activate_weapon()
{
	play_sound2(data->sampleWeapon[0]);
  game->addItem(new AnimatedShot(this, 42.0, 15.0, angle , weaponVelocity,
    weaponDamage, weaponRange, weaponArmour, this, data->spriteWeapon, 5, 12, 1.0));
  game->addItem(new AnimatedShot(this, -42.0, 15.0, angle , weaponVelocity,
    weaponDamage, weaponRange, weaponArmour, this, data->spriteWeapon, 5, 12, 1.0));
  return(TRUE);
}

int ZekfahanShocker::activate_special() {
  if(shockingFrames == 0)
  {
	play_sound2(data->sampleSpecial[0]);
        shockingFrames = specialFrames;
	shockVar = 1;
	recharge_amount = 0;
  }
  return(TRUE);
}

void ZekfahanShocker::calculate()
{ 
  if(shockVar == 1)
  {
   if(shockingFrames > 0) {
     shockingFrames -= frame_time;
     }
   if(shockingFrames == 2500 ) {
     game->addItem( new FixedAnimation(this, this, data->spriteSpecial, 0, 6, 30, LAYER_EXPLOSIONS));
     }
   if(shockingFrames == 2000 ) {
	play_sound2(data->sampleSpecial[0]);
     game->addItem( new FixedAnimation(this, this, data->spriteSpecial, 0, 6, 30, LAYER_EXPLOSIONS));
     }
   if(shockingFrames == 1500 ) {
	play_sound2(data->sampleSpecial[0]);
     game->addItem( new FixedAnimation(this, this, data->spriteSpecial, 0, 6, 30, LAYER_EXPLOSIONS));
     }
   if(shockingFrames == 1000 ) {
	play_sound2(data->sampleSpecial[0]);
     game->addItem( new FixedAnimation(this, this, data->spriteSpecial, 0, 6, 30, LAYER_EXPLOSIONS));
     }
   if(shockingFrames == 500 ) {
	play_sound2(data->sampleSpecial[0]);
     game->addItem( new FixedAnimation(this, this, data->spriteSpecial, 0, 6, 30, LAYER_EXPLOSIONS));
     }
   if(shockingFrames == 50 ) {
	play_sound2(data->sampleSpecial[1]);
     game->addItem( new Shockwave(0, 70, angle , specialVelocity, specialDamage, specialRange, specialArmour, this, this, data->spriteSpecial, 2, 50));
     shockingFrames = 0;
     shockVar = 0;
     recharge_amount = 1;
     }
  }
   Ship::calculate();
}

Shockwave::Shockwave(double ox, double oy, double oangle, double ov,
  int odamage, double orange, int oarmour, Ship *oship, SpaceLocation *opos,
  SpaceSprite *osprite, int ofcount, int ofsize) :
  AnimatedShot(oship, ox, oy, oangle, ov, odamage, orange, oarmour, oship, osprite, ofcount, ofsize)
{
  collide_flag_anyone = (ALL_LAYERS);
}

void Shockwave::inflict_damage(SpaceObject *other) {
	play_sound2(data->sampleSpecial[2]);
	if(damage_factor > 0) {other->directDamage += damage_factor;}
	other->handle_damage(this);
	game->addItem( new Animation(this, x, y, data->spriteSpecial, 0, 6, 30, LAYER_EXPLOSIONS));
	return;
	}




REGISTER_SHIP(ZekfahanShocker)
