#include "../ship.h"
REGISTER_FILE

class ShofixtiScout : public Ship {
  public:
  double       weaponRange;
  double       weaponVelocity;
  int          weaponDamage;
  int          weaponArmour;

  double       specialRange;
  int          specialFrames;
  int          specialDamage;
  int          flipSwitch;
  int          glory;

  ShofixtiScout(double ox, double oy, double angle, ShipData *data, unsigned int code);

  virtual int activate_weapon();
  virtual void calculate_fire_special();
};

ShofixtiScout::ShofixtiScout(double ox, double oy, double angle, ShipData *data, unsigned int code) 
	:
	Ship(ox, oy, angle, data, code)
{
  weaponRange    = scale_range(get_config_float("Weapon", "Range", 0));
  weaponVelocity = scale_velocity(get_config_float("Weapon", "Velocity", 0));
  weaponDamage   = get_config_int("Weapon", "Damage", 0);
  weaponArmour   = get_config_int("Weapon", "Armour", 0);

  specialRange  = scale_range(get_config_float("Special", "Range", 0));
  specialFrames = get_config_int("Special", "Frames", 0);
  specialDamage = get_config_int("Special", "Damage", 0);
  flipSwitch    = FALSE;
  glory         = 0;
}

int ShofixtiScout::activate_weapon()
{
  game->addItem(new Missile(this, 0.0, (h / 2.0),
    angle, weaponVelocity, weaponDamage, weaponRange, weaponArmour,
    this, data->spriteWeapon));
  return(TRUE);
}

void ShofixtiScout::calculate_fire_special() {
  int gloryDamage;

  if(fire_special) {
    if(!flipSwitch) {
      flipSwitch = TRUE;
      glory++;
      if(glory == 3) {
				Query q;
				for (q.begin(this, OBJECT_LAYERS, specialRange); q.currento; q.next()) {
					gloryDamage = (int)ceil((specialRange - distance(q.currento)) / specialRange * specialDamage);
					q.currento->directDamage += gloryDamage;
					q.currento->handle_damage(this);
					}
				this->directDamage += specialDamage;
				this->handle_damage(this);
				game->addItem(new Animation(this, x, y, data->spriteSpecial, 
						0, specialFrames, 50, LAYER_EXPLOSIONS));
				play_sound2(data->sampleSpecial[0]);
				}
			else {
				spritePanel->overlay(1, 5+glory, spritePanel->get_bitmap(2));
				spritePanel->overlay(1, 5+glory, spritePanel->get_bitmap(3));
				spritePanel->overlay(1, 5+glory, spritePanel->get_bitmap(4));
				spritePanel->overlay(1, 5+glory, spritePanel->get_bitmap(5));
				spritePanel->overlay(1, 5+glory, spritePanel->get_bitmap(1));
/*				blit(data->bitmapPanel[5 + glory], panelBitmap[1], 0, 23, 0, 23,
						CAPTAIN_WIDTH, 7);
				blit(data->bitmapPanel[5 + glory], panelBitmap[2], 0, 23, 0, 23,
						CAPTAIN_WIDTH, 7);
				blit(data->bitmapPanel[5 + glory], panelBitmap[3], 0, 23, 0, 23,
						CAPTAIN_WIDTH, 7);
				blit(data->bitmapPanel[5 + glory], panelBitmap[4], 0, 23, 0, 23,
						CAPTAIN_WIDTH, 7);
				blit(data->bitmapPanel[5 + glory], panelBitmap[5], 0, 23, 0, 23,
						CAPTAIN_WIDTH, 7);*/
				}
			}
		}
	else
    flipSwitch = FALSE;
	return;
	}



REGISTER_SHIP ( ShofixtiScout )
