#include "../ship.h"
REGISTER_FILE

class SupoxBlade : public Ship {
  public:
  double       weaponRange;
  double       weaponVelocity;
  int          weaponDamage;
  int          weaponArmour;

  SupoxBlade(double ox, double oy, double shipAngle,
    ShipData *shipData, unsigned int code);

  virtual void calculate_thrust();
  virtual void calculate_turn_left();
  virtual void calculate_turn_right();
  virtual void calculate_hotspots();

  virtual int activate_weapon();
  virtual void calculate_fire_special();
};

SupoxBlade::SupoxBlade(double ox, double oy, double shipAngle,
	ShipData *shipData, unsigned int code)
	:
	Ship(ox, oy, shipAngle, shipData, code)
{

  weaponRange    = scale_range(get_config_float("Weapon", "Range", 0));
  weaponVelocity = scale_velocity(get_config_float("Weapon", "Velocity", 0));
  weaponDamage   = get_config_int("Weapon", "Damage", 0);
  weaponArmour   = get_config_int("Weapon", "Armour", 0);
}

void SupoxBlade::calculate_thrust()
{

  if(thrust || ((fire_special) && (turn_left || turn_right || thrust))) {
    if((fire_special) && (turn_left)) {
			accelerate(this, angle-90, accel_rate * frame_time, speed_max);
    }
    if((fire_special) && (turn_right)) {
			accelerate(this, angle+90, accel_rate * frame_time, speed_max);
    }
    if((fire_special) && (thrust)) {
			accelerate(this, angle+180, accel_rate * frame_time, speed_max);
    }
    if((!fire_special) && (thrust)) {
			accelerate(this, angle, accel_rate * frame_time, speed_max);
    }

  }
}

void SupoxBlade::calculate_turn_left()
{
  if(!fire_special)
    Ship::calculate_turn_left();
}

void SupoxBlade::calculate_turn_right()
{
  if(!fire_special)
    Ship::calculate_turn_right();
}

void SupoxBlade::calculate_hotspots()
{
  if(!fire_special)
    Ship::calculate_hotspots();
}

int SupoxBlade::activate_weapon()
{
  game->addItem(new Missile(this, 0.0, (height() / 2.0),
    angle, weaponVelocity, weaponDamage, weaponRange, weaponArmour,
    this, data->spriteWeapon));
  return(TRUE);
}

void SupoxBlade::calculate_fire_special() {}



REGISTER_SHIP(SupoxBlade)
