#include "../ship.h"
REGISTER_FILE

class DoogConstructor : public Ship {
  double       weaponRange;
  double       weaponVelocity;
  int          weaponDamage;
  int          weaponArmour;

  public:
  DoogConstructor(double ox, double oy, double shipAngle,
    ShipData *shipData, unsigned int code);

  virtual int activate_weapon();
  virtual int activate_special();
};
DoogConstructor::DoogConstructor(double ox, double oy, double shipAngle,
	ShipData *shipData, unsigned int code)
	:
	Ship(ox, oy, shipAngle, shipData, code)
{
  weaponRange    = scale_range(get_config_float("Weapon", "Range", 0));
  weaponVelocity = scale_velocity(get_config_float("Weapon", "Velocity", 0));
  weaponDamage   = get_config_int("Weapon", "Damage", 0);
  weaponArmour   = get_config_int("Weapon", "Armour", 0);
}

int DoogConstructor::activate_weapon()
{
	double a;
	if (target && !target->isInvisible()) {
		double r = distance(target);
		r = r / weaponVelocity;
		double x = min_delta( normal_x() , target->normal_x() - 
				(get_vx() - target->get_vx()) * r, X_MAX);
		double y = min_delta( normal_y() , target->normal_y() - 
				(get_vy() - target->get_vy()) * r, Y_MAX);
		a = atan3(y, x) * 180 / PI - 180;
		}
	else a = angle;
  game->addItem(new Missile(this, 0.0, 0.0, a , weaponVelocity,
    weaponDamage, weaponRange, weaponArmour, this, data->spriteWeapon));
  return(TRUE);
}

int DoogConstructor::activate_special()
{
  int regen;

  if (crew >= crew_max)
    regen = FALSE;
  else {
    crew++;
    regen = TRUE;}
  return (regen);
}



REGISTER_SHIP(DoogConstructor)
