
#include <stdlib.h>
#include <stdio.h>
#include <time.h>
#include <string.h>
#include <errno.h>
#include <allegro.h>
#include <assert.h>

#ifdef ALLEGRO_MSVC
	#include <winalleg.h>
	#include <crtdbg.h>
#endif 

int  GFX_TIMEWARP =  
#if defined GFX_DIRECTX_WIN
GFX_DIRECTX_WIN
#elif defined GFX_XWINDOWS
GFX_XWINDOWS
#elif defined GFX_BEOS_WINDOWED
GFX_BEOS_WINDOWED
#else
GFX_AUTODETECT
#endif
;
int  GFX_TIMEWARP_FULLSCREEN = GFX_AUTODETECT;

int fullscreen;
int antia_on;
DATAFILE *scppal = NULL;;
const char *tw_version() {
	static char tw_version_string[1024];
	sprintf(tw_version_string, "%s %s", __TIME__, __DATE__);
	return tw_version_string;
	}

#include "melee.h"
REGISTER_FILE
#include "libs.h"
#include "scp.h"
#include "gui.h"
#include "frame.h"

#include "melee/mview.h"
#include "melee/mcontrol.h"
#include "melee/mcbodies.h"
#include "melee/mgame.h"

#include "melee/mmain.h"
#include "melee/mnet1.h"
#include "games/ggob.h"
#include "util/net_tcp.h"
#include "util/aastr.h"


#define SCPGUI_MUSIC   0
#define SCPGUI_TITLE   1

#define TITLE_DIALOG_BOX    0
#define TITLE_DIALOG_EDIT   1
#define TITLE_DIALOG_OK     2
#define TITLE_DIALOG_CANCEL 3

int gamma_correction = 0;

DATAFILE *scp = NULL;

FILE *debug_file;

void showTitle();
void change_options();
void change_teams();
void init_video();
void init_gamma();

int update_gamma(void *dp3, int val);
int  getKey();

#define MAIN_DIALOG_BOX               0
#define MAIN_DIALOG_MELEE             1
#define MAIN_DIALOG_MELEE_EXTENDED    2
#define MAIN_DIALOG_TEAMS             3
#define MAIN_DIALOG_OPTIONS           4
#define MAIN_DIALOG_HELP              5
#define MAIN_DIALOG_EXIT              6

DIALOG mainDialog[] = {
  // (dialog proc)     (x)   (y)   (w)   (h)   (fg)  (bg)  (key) (flags)  (d1)  (d2)  (dp)
  { d_shadow_box_proc, 40,  40,   180,  215,   255,  0,    0,    0,       0,    0,    NULL, NULL, NULL },
  { d_button_proc,     45,  45,   170,   30,   255,  0,    0,    D_EXIT,  0,    0,    (void *)"Melee" , NULL, NULL },
  { d_button_proc,     45,  80,   170,   30,   255,  0,    0,    D_EXIT,  0,    0,    (void *)"Extended Menu" , NULL, NULL },
  { d_button_proc,     45,  115,  170,   30,   255,  0,    0,    D_EXIT,  0,    0,    (void *)"Teams" , NULL, NULL },
  { d_button_proc,     45,  150,  170,   30,   255,  0,    0,    D_EXIT,  0,    0,    (void *)"Options", NULL, NULL },
  { d_button_proc,     45,  185,  170,   30,   255,  0,    0,    D_EXIT,  0,    0,    (void *)"Help", NULL, NULL },
  { d_button_proc,     45,  220,  170,   30,   255,  0,    0,    D_EXIT,  0,    0,    (void *)"Exit", NULL, NULL },
  { NULL,              0,   0,    0,     0,    255,  0,    0,    0,       0,    0,    NULL, NULL, NULL }
};


static int old_x = 0, old_y = 0, old_z = 0, old_fullscreen = false;
/*------------------------------
		Error generator
------------------------------*/
int __error_flag = 0;
int tw_alert(char *message, char *b1, char *b2, char *b3) {
	char *s1 = strdup(message);
	char *s2 = NULL, *s3 = NULL;
	s2 = strchr(s1, '\n');
	if (s2) {
		s2[0] = 0;
		s2 += 1;
		s3 = strchr(s2, '\n');
		if (s3) {
			s3[0]= 0;
			s3 += 1;
			}
		}
	return alert3(s1, s2, s3, b1, b2, b3, 0, 0, 0);
	}
void error(const char *format, ...) {
	char error_string[2048];
	if (format) {
		va_list those_dots;
		va_start (those_dots, format);
		vsprintf(error_string, format, those_dots);
		va_end (those_dots);
		}
	else error_string[0] = 0;
	int i;
	if (!strncmp(error_string, "quit", 4)) throw 0;
	if (!strncmp(error_string, "Quit", 4)) throw 0;
	if (!strncmp(error_string, "QUIT", 4)) throw 0;
	if (old_z == 0) {
		allegro_message("Critcal Error: %s\n", error_string);
		throw -1;
		}
	i = tw_alert(error_string, "Abort", "Retry", "Debug");
	if (i == 3) {
		__error_flag |= 1;
		(*((int*)0)) = 0;
//		throw -1;
		}
	if (i == 2) return;
	throw 0;
	}
void tw_error(const char *format, ...) {
	int i;
	char error_string[2048];
	if (format) {
		va_list those_dots;
		va_start (those_dots, format);
		vsprintf(error_string, format, those_dots);
		va_end (those_dots);
		}
	else error_string[0] = 0;
	if (old_z == 0) {
		allegro_message("Critcal Error: %s\n", error_string);
		__error_flag = 1;
		return;
		}
	i = tw_alert(error_string, "Okay", "Debug");
	if (i == 2) __error_flag = 1;
	return;
	}
static void tw_error_exit(char* message) {
	if (old_z != 0) {
		char buf[500];
		sprintf(buf, "Error: %s", message);
		tw_alert (buf, "Quit");
		}
	else allegro_message("Critical Error: %s\n", message);
	allegro_exit();
	exit(1);
	}



#define DIAGNOSTICS_DIALOG_EXIT           1
#define DIAGNOSTICS_DIALOG_MAIN           3
#define DIAGNOSTICS_DIALOG_FILES          5
#define DIAGNOSTICS_DIALOG_VERSION_TXT    7
static DIALOG diagnostics_dialog[] =
{
  // (dialog proc)     (x)   (y)   (w)   (h)   (fg)  (bg)  (key) (flags)     (d1)  (d2)  (dp)
  { d_box_proc,        0,   0,     640,  480,  255,  0,    0,    0,          0,    0,    NULL, NULL, NULL },
  { d_button_proc,     10,  10,    300,  40,   255,  0,    0,    D_EXIT,     0,    0,    (void *)"Exit Diagnostics Screen" , NULL, NULL },
  { d_text_proc,       15,  65,    620,  15,   255,  0,    0,    0,          0,    0,    (void *)"Compile-time Options", NULL, NULL },
  { d_textbox_proc,    10,  80,    620,  90,   255,  0,    0,    0,          0,    0,    NULL, NULL, NULL },
  { d_text_proc,       15,  175,   620,  15,   255,  0,    0,    0,          0,    0,    (void *)"Compile Times", NULL, NULL },
  { d_textbox_proc,    10,  190,   620,  90,   255,  0,    0,    0,          0,    0,    NULL, NULL, NULL },
  { d_text_proc,       15,  285,   620,  15,   255,  0,    0,    0,          0,    0,    (void *)"version.txt", NULL, NULL },
  { d_textbox_proc,    10,  300,   620,  90,   255,  0,    0,    0,          0,    0,    NULL, NULL, NULL },
  { NULL,              0,    0,    0,    0,    255,  0,    0,    0,          0,    0,    NULL, NULL, NULL }
};
void show_diagnostics() {
	int i;
	char buffy[100000];//fix sometime
	char *tmp;
	PACKFILE *f;
	f = pack_fopen ("./version.txt", F_READ);
	if (!f) strcpy(buffy, "Failed to load version.txt");
	else {
		i = pack_fread (buffy, 99999, f);
		pack_fclose(f);
		buffy[i] = 0;
		}
	set_dialog_color(diagnostics_dialog, pallete_color[0], pallete_color[15]);
	diagnostics_dialog[DIAGNOSTICS_DIALOG_VERSION_TXT].dp = (void *) buffy;
	char buffy2[100000];//fix sometime
	diagnostics_dialog[DIAGNOSTICS_DIALOG_FILES].dp = (void *) buffy2;
	tmp = buffy2;
	for (i = 0; i < num_registered_files; i += 1) {
		tmp += sprintf(tmp, "%s %s %s\n", registered_files[i].ftime, registered_files[i].fdate, registered_files[i].fname);
		}

	char buffy3[16000];//yeah right
	diagnostics_dialog[DIAGNOSTICS_DIALOG_MAIN].dp = (void *) buffy3;
	tmp = buffy3;
	tmp += sprintf(tmp, "ALLEGRO version = %s\n", ALLEGRO_VERSION_STR);
	tmp += sprintf(tmp, "Platform = %s\n", ALLEGRO_PLATFORM_STR);
	tmp += sprintf(tmp, "Network type = %s\n", NetTCP::network_type());
	tmp += sprintf(tmp, "Compiler = ");
	#if defined __MINGW32__
		tmp += sprintf(tmp, "MINGW (gcc)\n");
	#elif defined __BORLANDC__
		tmp += sprintf(tmp, "Borland\n");
	#elif defined _MSC_VER
		tmp += sprintf(tmp, "Micorosft Visual C++\n");
	#elif defined DJGPP
		tmp += sprintf(tmp, "DJGPP (gcc)\n");
	#elif defined __GNUC__
		tmp += sprintf(tmp, "gcc\n");
	#else
		tmp += sprintf(tmp, "???\n");
	#endif
	tmp += sprintf(tmp, "Blah = %s\n", tw_version());
	#if defined NO_JGMOD
		tmp += sprintf(tmp, "JGMOD (music) Disabled\n");
	#else 
		tmp += sprintf(tmp, "JGMOD (music) Enabled\n");
	#endif
	#if defined NO_ALLEGRO_4
		tmp += sprintf(tmp, "ALLEGRO 4 extentions Disabled\n");
	#else 
		tmp += sprintf(tmp, "ALLEGRO 4 extentions Enabled\n");
	#endif
	popup_dialog(diagnostics_dialog, 1);
	return;
	}
void keyjamming_tester() {
	int i, j = 0;
	acquire_screen();
	clear_to_color(screen, 0);
	textprintf(screen, font, 40, 20, palette_color[15], "Press the keys combinations you wish to test");
	textprintf(screen, font, 40, 40, palette_color[15], "When you're finished, press F10");
	release_screen();
	while (!key[KEY_F10]) {
		acquire_screen();
		rectfill(screen, 50, 60, 250, 60 + 20 * j, palette_color[0]);
		j = 0;
		poll_keyboard();
		for (i = 0; i < KEY_MAX; i += 1) if (key[i]) {
			textprintf(screen, font, 50, 60+j*20, palette_color[15], "%s", key_string[i]);
			j += 1;
			}
		release_screen();
		rest(10);
		}
	showTitle();
	while (key[KEY_F10]) poll_keyboard();
	clear_keybuf();
	return;
	}


static const char *log_types[] = {"Normal", "Playback", "Net1Server", "Net1Client", NULL};

void play_game ( const char *_gametype_name, const char *_logtype_name ) {
	bool gui_stuff;
	char gametype_name[1024];
	char logtype_name[1024];
	strncpy(gametype_name, _gametype_name, 1000);
	strncpy(logtype_name, _logtype_name, 1000);
	char *c;
	for (c = gametype_name; c = strchr(c, '_'); *c = ' ');
	for (c = logtype_name; c = strchr(c, '_'); *c = ' ');
	if (scp) {
		gui_stuff = true;
		sound.stop_music();
		if (scp) unload_datafile(scp);
		scp = NULL;
		}
	try {
		delete game;
		game = NULL;
		union {Log *log; NetLog *netlog;};
		log = NULL;
		if (0) ;
		else if (!strcmp(logtype_name, log_types[0])) {
			log = new Log();
			log->init();
			}
		else if (!strcmp(logtype_name, log_types[1])) {
			log = new PlaybackLog();
			log->init();
			log->load("demo.log");
			}
		else if (!strcmp(logtype_name, log_types[2])) {
			log = new NetLog();
			log->init();
			log->type = Log::log_net1server;
			}
		else if (!strcmp(logtype_name, log_types[3])) {
			log = new NetLog();
			log->init();
			log->type = Log::log_net1client;
			}
		else {
			error("that loging mode isn't supported at the moment...");
			}
		GameType *type = gametype(gametype_name);
		if (type) game = type->new_game();
		else throw "wait a sec... I can't find that game type";
		game->preinit();
		game->init(log);
		game->play();
		game->log->deinit();
		}
	catch (int i) {
		if (i == -1) throw;
		if (__error_flag) throw;
		if (i != 0) tw_error ("%s %s caught int %d", __FILE__, __LINE__, i);
		if (__error_flag) throw;
		}
	catch (const char *str) {
		if (__error_flag) throw;
		tw_error("message: \"%s\"", str);
		if (__error_flag) throw;
		}
	catch (...) {
		if (__error_flag) throw;
		tw_error("Ack(2)!!!\nAn error occured!\nBut I don't know what error!");
		if (__error_flag) throw;
		}
	if (gui_stuff) {
		scp = load_datafile("scpgui.dat");
		sound.play_music((Music *)(scp[SCPGUI_MUSIC].dat), TRUE);
		showTitle();
		}
	return;
	}

#define MELEE_EX_DIALOG_BOX         0
#define MELEE_EX_DIALOG_LOGLIST     1
#define MELEE_EX_DIALOG_SAVE        2
#define MELEE_EX_DIALOG_CLEAR_STATE 3
#define MELEE_EX_DIALOG_KEYTESTER   4
#define MELEE_EX_DIALOG_DIAGNOSTICS 5
#define MELEE_EX_DIALOG_GAMELIST    6
#define MELEE_EX_DIALOG_EXIT        7

DIALOG melee_ex_dialog[] = {
  // (dialog proc)     (x)  (y)   (w)   (h)   (fg)  (bg)  (key) (flags)  (d1)  (d2)  (dp)
  { d_shadow_box_proc, 5,   5,    420,  230,  255,  0,    0,    0,       0,    0,    NULL, NULL, NULL },
  { d_list_proc2,      10,  10,   140,  75,   255,  0,    0,    D_EXIT,  0,    0,    (void *)genericListboxGetter, NULL, log_types },
  { d_button_proc,     10,  90,   145,  20,   255,  0,    0,    D_EXIT,  0,    0,    (void *)"Save Demo" , NULL, NULL },
  { d_button_proc,     10,  115,  145,  20,   255,  0,    0,    D_EXIT,  0,    0,    (void *)"Clear State", NULL, NULL },
  { d_button_proc,     10,  140,  145,  20,   255,  0,    0,    D_EXIT,  0,    0,    (void *)"Key Tester", NULL, NULL },
  { d_button_proc,     10,  165,  145,  20,   255,  0,    0,    D_EXIT,  0,    0,    (void *)"Diagnostics", NULL, NULL },
  { d_list_proc2,      165, 10,   255,  190,  255,  0,    0,    D_EXIT,  0,    0,    (void *)genericListboxGetter, NULL, game_names },//doesn't hold the right value until main() begins
  { d_button_proc,     30,  205,  290,  20,   255,  0,    0,    D_EXIT,  0,    0,    (void *)"Main Menu", NULL, NULL },
  { NULL,              0,   0,    0,    0,    255,  0,    0,    0,       0,    0,    NULL, NULL, NULL }
};
void extended_menu(int i = -1) {
	set_dialog_color(melee_ex_dialog, pallete_color[0], pallete_color[15]);
	melee_ex_dialog[MELEE_EX_DIALOG_LOGLIST].d1 = 0;
	melee_ex_dialog[MELEE_EX_DIALOG_GAMELIST].dp3 = game_names;
	if (i == -1) i = popup_dialog ( melee_ex_dialog, MELEE_EX_DIALOG_GAMELIST );
	switch (i) {
		case -1:
		case MELEE_EX_DIALOG_EXIT: {
			return;
			}
		break;
		case MELEE_EX_DIALOG_SAVE: {
			if (!game || !game->log) {
				tw_alert ( "Aaaaarggh! No recording to save!", ":(");
				return;
				}
			game->log->save("demo.log");
			}
		break;
		case MELEE_EX_DIALOG_CLEAR_STATE: {
			delete game;
			game = NULL;
			unload_all_ship_data();
			}
		break;
		case MELEE_EX_DIALOG_DIAGNOSTICS: {
			show_diagnostics();
			}
		break;
		case MELEE_EX_DIALOG_KEYTESTER: {
			keyjamming_tester();
			}
		break;
		case MELEE_EX_DIALOG_LOGLIST:
		case MELEE_EX_DIALOG_GAMELIST: {
			play_game(game_names[melee_ex_dialog[MELEE_EX_DIALOG_GAMELIST].d1], log_types[melee_ex_dialog[MELEE_EX_DIALOG_LOGLIST].d1]);
			/*
			sound.stop_music();
			if (scp) unload_datafile(scp);
			scp = NULL;
			try {
				delete game;
				game = NULL;
				union {Log *log; NetLog *netlog;};
				log = NULL;

				switch (melee_ex_dialog[MELEE_EX_DIALOG_LOGLIST].d1) {
					case 0: {
						log = new Log();
						log->init();
						log->type = Log::log_normal;
						}
					break;
					case 1: {
						log = new Log();
						log->init();
						log->type = Log::log_playback;
						log->load("demo.log");
						}
					break;
					case 2: {
						log = new NetLog();
						log->init();
						log->type = Log::log_net1server;
						}
					break;
					case 3: {
						log = new NetLog();
						log->init();
						log->type = Log::log_net1client;
						}
					break;
					default: {
						error("that loging mode isn't supported at the moment...");
						}
					break;
					}
				GameType *type = gametype(game_names[melee_ex_dialog[MELEE_EX_DIALOG_GAMELIST].d1]);
				if (type) game = type->new_game();
				else throw "wait a sec... I can't find that game type";
				game->preinit();
				game->init(log);
				game->play();
				}
			catch (int i) {
				if (i == -1) throw;
				if (__error_flag) throw;
				if (i != 0) tw_error ("%s %s caught int %d", __FILE__, __LINE__, i);
				if (__error_flag) throw;
				}
			catch (const char *str) {
				if (__error_flag) throw;
				tw_error("message: \"%s\"", str);
				if (__error_flag) throw;
				}
			catch (...) {
				if (__error_flag) throw;
				tw_error("Ack(2)!!!\nAn error occured!\nBut I don't know what error!");
				if (__error_flag) throw;
				}
			palette_color[0] = 0;
			scp = load_datafile("scpgui.dat"); //loading all data again
			sound.play_music((Music *)(scp[SCPGUI_MUSIC].dat), TRUE);*/
			}
		}
	showTitle();
	return;
	}

char title_str[80];

DIALOG titleDialog[] = {
  // (dialog proc)     (x)   (y)   (w)   (h)   (fg)  (bg)  (key) (flags)  (d1)  (d2)  (dp)
  { d_box_proc,        180,  210,  280,  60,   255,  0,    0,    0,       0,    0,    NULL, NULL, NULL },
  { d_edit_proc,       190,  220,  260,  10,   255,  0,    0,    0,       80,   0,    title_str, NULL, NULL },
  { d_button_proc,     255,  240,  60,   18,   255,  0,    0,    D_EXIT,  0,    0,    (void *)"OK", NULL, NULL },
  { d_button_proc,     325,  240,  60,   18,   255,  0,    0,    D_EXIT,  0,    0,    (void *)"Cancel", NULL, NULL },
  { NULL,              0,    0,    0,    0,    255,  0,    0,    0,       0,    0,    NULL, NULL, NULL }
};

char dialog_string[20][128];

#define MAX_PLAYERS 8
#define MAX_CONFIGURATIONS 4
char *playerListboxGetter(int index, int *list_size) ;
char *controlListboxGetter(int index, int *list_size) ;
char *viewListboxGetter(int index, int *list_size) ;

static FONT *backup_font = NULL;

int    mainRet = 0, shipRet = 0, keyRet = 0, fleetRet = 0, optionsRet= 0;


char *player_type[MAX_PLAYERS];
int player_config[MAX_PLAYERS];

Control *load_player(int i) {
	char tmp[32];
	Control *r = NULL;
	sprintf (tmp, "Config%d", player_config[i]);
	r = getController(player_type[i], tmp);
	if (r) r->load("scp.ini", tmp);
	return r;
	}

int main(int argc, char *argv[]) {
	int i;
	const char *auto_game = NULL, *auto_log = NULL;

	#ifdef __BEOS__
		/* set cwd to path of exe */
		/* to allow running from icon */
		int ip;
		char datapath[256];
		for (ip=strlen(argv[0]) ; argv[0][ip]!='/' ; ip--);
		strncpy(datapath, argv[0], ip);
		chdir(datapath);
	#endif
	
	#ifdef ALLEGRO_MSVC
		_CrtSetDbgFlag(_CRTDBG_REPORT_FLAG|_CRTDBG_LEAK_CHECK_DF);
	#endif
	allegro_init();
	try {
		set_window_title("Star Control : TimeWarp");

		install_timer();
		install_keyboard(); poll_keyboard();
		install_mouse(); poll_mouse();

		set_color_conversion(COLORCONV_NONE);

		init_time();
		init_ships();
		srand(time(NULL));

		set_keyboard_rate(0,0);
		set_config_file("client.ini");

		color_depth      = get_config_int("Video", "BitsPerPixel", 16);
		screen_x         = get_config_int("Video", "ScreenWidth", 640);
		screen_y         = get_config_int("Video", "ScreenHeight", 480);
		fullscreen       = get_config_int("Video", "FullScreen", false);
		antia_on         = get_config_int("Video", "Anti-Aliasing", 1);

		gamma_correction = get_config_int("View", "Gamma", 0);
		set_view(view2number(get_config_string("View", "View", NULL)));
		for (i = 0; i < argc; i += 1) {
			if (false) ;
			else if (!strcmp(argv[i], "-res") && (argc > i + 2)) {
				screen_x = atoi(argv[i+1]);
				screen_y = atoi(argv[i+2]);
				i += 2;
				}
			else if (!strcmp(argv[i], "-bpp") && (argc > i + 1)) {
				color_depth = atoi(argv[i+1]);
				i += 1;
				}
			else if (!strcmp(argv[i], "-fullscreen") && (argc > i + 0)) {
				fullscreen = true;
				}
			else if (!strcmp(argv[i], "-window") && (argc > i + 0)) {
				fullscreen = false;
				}
			else if (!strcmp(argv[i], "-nosound") && (argc > i + 0)) {
				sound.disable();
				}
			else if (!strcmp(argv[i], "-play") && (argc > i + 2)) {
				auto_game = argv[i+1];
				auto_log = argv[i+2];
				i += 2;				
				}
			}

		sound.load();
		sound.set_volumes();
		backup_font = font;
		init_video();
		init_ships();
		init_fleet();

		if (auto_game) {
			play_game(auto_game, auto_log);
			throw -1;
			}

		set_config_file ("scp.ini");
		for (i = 0; i < MAX_PLAYERS; i += 1) {
			char tmp[32];
			sprintf (tmp, "Player%d", i+1);
			player_type[i] = strdup(get_config_string(tmp, "Type", "Keyboard"));
			player_config[i] = get_config_int (tmp, "Config", i % MAX_CONFIGURATIONS);
			}
		

		gui_fg_color = pallete_color[0];
		gui_bg_color = pallete_color[15];
		set_dialog_color(titleDialog, pallete_color[0], pallete_color[15]);
		scp = load_datafile("scpgui.dat");
		sound.play_music((Music *)(scp[SCPGUI_MUSIC].dat), TRUE);

		showTitle();
		do {
			set_dialog_color(mainDialog, pallete_color[0], pallete_color[15]);
			mainRet = popup_dialog(mainDialog, MAIN_DIALOG_MELEE);
			switch (mainRet) {
				case MAIN_DIALOG_MELEE:
					play_game("Melee", "Normal");
					break;
				case MAIN_DIALOG_MELEE_EXTENDED:
					extended_menu();
					break;
				case MAIN_DIALOG_OPTIONS:
					change_options();
					break;
				case MAIN_DIALOG_HELP:
					show_file("ingame.txt");
					break;
				case MAIN_DIALOG_TEAMS:
					change_teams();
					break;
				}
			} while((mainRet != MAIN_DIALOG_EXIT) && (mainRet != -1));
		sound.disable();
		remove_keyboard();
		remove_mouse();
		remove_timer();
		unload_datafile(scppal);
		}
	catch (int i) {
		if (i == -1) throw;
		if (__error_flag) throw;
		if (i != 0) tw_error ("%s %s caught int %d", __FILE__, __LINE__, i);
		if (__error_flag) throw;
		}
	catch (const char *str) {
		if (__error_flag) throw;
		tw_error("message: \"%s\"", str);
		if (__error_flag) throw;
		}
	catch (...) {
		if (__error_flag) throw;
		throw;
//		tw_error("Ack!!!\nAn error occured on startup!\nBut I don't know what error!");
		if (__error_flag) throw;
		}
	allegro_exit();
	return 0;
	}
END_OF_MAIN();

void showTitle() {
	if (!scp) error ("showTitle - gui stuff not loaded");
	BITMAP *src = (BITMAP *) scp[SCPGUI_TITLE].dat;
	acquire_screen();
	aa_stretch_blit(src, screen, 0, 0, src->w, src->h, 0, 0, screen_x, screen_y);
	release_screen();
	return;
	}

void init_gamma() {
	int i, table[256];
	if (!gamma_correction) return;
	assert (gamma_correction > 0);
	assert (gamma_correction < 256);
	for (i = 0; i < 256; i += 1) {
		table[i] = int(floor(255.5 * pow(i / 255., 1-gamma_correction/300.)));
		}
	if (color_depth != 8) {
		for (i = 0; i < 256; i += 1) {
			int r, g, b;
			b = pallete_color[i];
			if (b == bitmap_mask_color(screen)) continue;
			r = getr(b);
			g = getg(b);
			b = getb(b);
			r = table[r];
			g = table[g];
			b = table[b];
			pallete_color[i] = makecol(r, g, b);
			}
		}
	return;
	}

/*static void tw_display_switch_out() {
	if (game && !game->is_paused()) {
		game->pause();
		game->unpause();
		}
	}
static void tw_display_switch_in() {
	if (game && !game->is_paused()) {
		game->pause();
		game->unpause();
		}
	}*/
void init_video() {
	if ((color_depth != old_z) || (screen_x != old_x) || (screen_y != old_y) || (old_fullscreen != fullscreen)) {
		set_color_depth(color_depth);
		if ((game && (color_depth != old_z)) || 
				set_gfx_mode((fullscreen ? GFX_TIMEWARP_FULLSCREEN : GFX_TIMEWARP), screen_x, screen_y, 0, 0)) {
			char buffy[1024];
			sprintf (buffy, "Error switching to graphics mode(%dx%d @ %d bit):", 
					screen_x, screen_y, color_depth);
			if (old_z == 0) {
				strcat(buffy, allegro_error);
				tw_error_exit(buffy);
				}
			screen_x = old_x;
			screen_y = old_y;
			color_depth = old_z;
			fullscreen = old_fullscreen;
			set_color_depth(color_depth);
			set_gfx_mode((fullscreen ? GFX_TIMEWARP_FULLSCREEN : GFX_TIMEWARP), screen_x, screen_y, 0, 0);
			if (game) {
				alert (buffy, "Cannot change color depths during combat", "", "Resume", NULL, ' ', '\n');
				}
			else alert (buffy, allegro_error, "", "Continue", NULL, ' ', '\n');
			}
		if (set_display_switch_mode(SWITCH_BACKGROUND) == -1)
			set_display_switch_mode(SWITCH_BACKAMNESIA);
//		set_display_switch_callback(SWITCH_IN, tw_display_switch_in);
//		set_display_switch_callback(SWITCH_OUT, tw_display_switch_out);
		old_x = screen_x;
		old_y = screen_y;
		old_z = color_depth;
		old_fullscreen = fullscreen;
		font = backup_font;
		if (scppal) unload_datafile(scppal);
		scppal = load_datafile("scppal.dat");
		if (!scppal) error("Error loading SCP pallete data\n");
		font = (FONT *)(scppal[SCPPAL_FONT].dat);
		set_pallete((RGB*)(scppal[SCPPAL_PALLETE].dat)); //do gamma correction on the pallete also
		if (color_depth == 8) {
			if (!rgb_map) rgb_map = (RGB_MAP*)malloc(1<<15);
			create_rgb_table ( rgb_map, (RGB*)(scppal[SCPPAL_PALLETE].dat), NULL);
			}
		gui_bg_color = pallete_color[0];
		gui_fg_color = pallete_color[15];
		if (scp) {
			unload_datafile(scp);
			sound.stop_music();
			scp = load_datafile("scpgui.dat");
			if(!scp) error("Error loading SCP GUI data\n");
			sound.play_music((Music *)(scp[SCPGUI_MUSIC].dat), TRUE);
			showTitle();
			}
		}
	return;
	}


char *numeric_string[] = {"Zero", "One", "Two", "Three", "Four", 
		"Five", "Six", "Seven", "Eight", "Nine", "Ten", "Eleven", 
		"Twelve"};

#define FLEET_DIALOG_FLEETTITLE    0
#define FLEET_DIALOG_FLEETLIST     1
#define FLEET_DIALOG_SHIPLIST      2
#define FLEET_DIALOG_SELECT        3
#define FLEET_DIALOG_CLEAR         4
#define FLEET_DIALOG_PLAYERBOX     5
#define FLEET_DIALOG_PLAYERTEXT    6
#define FLEET_DIALOG_SAVE          7
#define FLEET_DIALOG_LOAD          8
#define FLEET_DIALOG_TITLE         9
#define FLEET_DIALOG_MAIN          10

char fleetPlayer[18];
char fleetTitleString[100];

DIALOG fleetDialog[] = {
  // (dialog proc)     (x)   (y)   (w)   (h)   (fg)  (bg)  (key) (flags)  (d1)  (d2)  (dp)
  { d_textbox_proc,    10,   10,   160,  60,   255,  0,    0,    0,       0,    0,    fleetTitleString, NULL, NULL },
  { d_list_proc,       10,   80,   240,  380,  255,  0,    0,    D_EXIT,  0,    0,    fleetListboxGetter, NULL, NULL },
  { d_text_list_proc,  400,  5,    240,  350,  255,  0,    0,    D_EXIT,  0,    0,    shipListboxGetter, NULL, NULL },
  { d_button_proc,     440,  365,  130,  40,   255,  0,    0,    D_EXIT,  0,    0,    (void *)"Select Ship", NULL, NULL },
  { d_button_proc,     440,  420,  130,  40,   255,  0,    0,    D_EXIT,  0,    0,    (void *)"Clear Slot", NULL, NULL },
  { d_box_proc,        240,  5,    140,  20,   255,  0,    0,    0,       0,    0,    NULL, NULL, NULL },
  { d_ctext_proc,      300,  10,   140,  10,   255,  0,    0,    0,       0,    0,    fleetPlayer, NULL, NULL },
  { d_button_proc,     260,  35,   130,  48,   255,  0,    0,    D_EXIT,  0,    0,    (void *)"Save Fleet", NULL, NULL },
  { d_button_proc,     260,  95,   130,  48,   255,  0,    0,    D_EXIT,  0,    0,    (void *)"Load Fleet", NULL, NULL },
  { d_button_proc,     260,  155,  130,  48,   255,  0,    0,    D_EXIT,  0,    0,    (void *)"Fleet Title", NULL, NULL },
  { d_button_proc,     260,  215,  130,  48,   255,  0,    0,    D_EXIT,  0,    0,    (void *)"Main", NULL, NULL },
  { NULL,              0,    0,    0,    0,    255,  0,    0,    0,       0,    0,    NULL, NULL, NULL }
};

void edit_fleet(int player) {
	char tmp[40];
  char path[80];
  set_dialog_color(fleetDialog, pallete_color[0], pallete_color[15]);
	sprintf (tmp, "Player%d", player+1);
	load_fleet("fleets.ini", tmp);
	sprintf(fleetPlayer, "Player %s Fleet", numeric_string[player+1]);
	do {
		sprintf(title_str, fleet_title);
		sprintf(fleetTitleString, "%s\n%d points", fleet_title, fleet_cost);

		fleetRet = do_dialog(fleetDialog, FLEET_DIALOG_SHIPLIST);

		if ((fleetRet == FLEET_DIALOG_SELECT) ||
				(fleetRet == FLEET_DIALOG_SHIPLIST)) {
			select_fleet_slot(
					fleetDialog[FLEET_DIALOG_FLEETLIST].d1,
					&shiptypes[fleetDialog[FLEET_DIALOG_SHIPLIST].d1]);
			fleetDialog[FLEET_DIALOG_FLEETLIST].d1++;
			}
		if ((fleetRet == FLEET_DIALOG_CLEAR) ||
				(fleetRet == FLEET_DIALOG_FLEETLIST)) {
			clear_fleet_slot(fleetDialog[FLEET_DIALOG_FLEETLIST].d1);
			fleetDialog[FLEET_DIALOG_FLEETLIST].d1++;
			}
		if(fleetRet == FLEET_DIALOG_SAVE) {
			sprintf(path, "fleets/");
			if(file_select("Save Fleet", path, "scf")) save_fleet(path, "Fleet");
			showTitle();
			}
		if(fleetRet == FLEET_DIALOG_LOAD) {
			sprintf(path, "fleets/");
			if(file_select("Load Fleet", path, "scf")) load_fleet(path, "Fleet");
			sprintf(title_str, fleet_title);
			sprintf(fleetTitleString, "%s\n%d points", fleet_title, fleet_cost);
			showTitle();
			}

		if(fleetRet == FLEET_DIALOG_TITLE) {
			if(do_dialog(titleDialog, TITLE_DIALOG_BOX) == TITLE_DIALOG_OK)
					sprintf(fleet_title, title_str);
			}
		} while((fleetRet != FLEET_DIALOG_MAIN) && (fleetRet != -1));
	save_fleet("fleets.ini", tmp);
	showTitle();
	}



#define TEAMS_DIALOG_BOX							0
#define TEAMS_DIALOG_TITLE						1
#define TEAMS_DIALOG_PLAYERLIST				2
#define TEAMS_DIALOG_CONTROLLIST			3
#define TEAMS_DIALOG_SELECTCONTROL		4
#define TEAMS_DIALOG_CONFIG_NUM				5
#define TEAMS_DIALOG_SETUP						6
#define TEAMS_DIALOG_FLEET						7
#define TEAMS_DIALOG_MAINMENU					8

DIALOG teamsDialog[] = {
  // (dialog proc)     (x)   (y)   (w)   (h)   (fg)  (bg)  (key) (flags)  (d1)  (d2)  (dp)
  { d_box_proc,        35,   35,   420,  420,  255,  0,    0,    0,       0,    0,    NULL, NULL, NULL },
  { d_textbox_proc,    150,  40,   200,  25,   255,  0,    0,    0,       0,    0,    (void *) "Teams Dialog", NULL, NULL },
  { d_list_proc,       40,   70,   240,  160,  255,  0,    0,    D_EXIT,  0,    0,    playerListboxGetter, NULL, NULL },
  { d_list_proc,       290,  70,   160,  160,  255,  0,    0,    D_EXIT,  0,    0,    controlListboxGetter, NULL, NULL },
  { d_button_proc,     80,   280,  220,  25,   255,  0,    0,    D_EXIT,  0,    0,    (void *)"Select Controller", NULL, NULL },
  { d_button_proc,     80,   310,  220,  25,   255,  0,    0,    D_EXIT,  0,    0,    (void *) "Switch Config #", NULL, NULL },
  { d_button_proc,     80,   340,  220,  25,   255,  0,    0,    D_EXIT,  0,    0,    (void *) "Edit Config", NULL, NULL },
  { d_button_proc,     80,   370,  220,  25,   255,  0,    0,    D_EXIT,  0,    0,    (void *) "Edit Fleet", NULL, NULL },
  { d_button_proc,     80,   400,  220,  25,   255,  0,    0,    D_EXIT,  0,    0,    (void *)"Main Menu", NULL, NULL },
  { NULL,              0,    0,    0,    0,    255,  0,    0,    0,       0,    0,    NULL, NULL, NULL }
};

void change_teams()
{
  set_config_file("scp.ini");
  set_dialog_color(teamsDialog, pallete_color[0], pallete_color[15]);
	
	int a;

	teamsDialog[TEAMS_DIALOG_PLAYERLIST].d1 = 0;
	while (1) {
		dialog_string[0][0] = 0;
		sprintf(dialog_string[0], "Config #");

		a = popup_dialog(teamsDialog, 0);
		if((a == TEAMS_DIALOG_SELECTCONTROL) || (a == TEAMS_DIALOG_CONTROLLIST)) {
			player_type[teamsDialog[TEAMS_DIALOG_PLAYERLIST].d1] = 
					control_name[teamsDialog[TEAMS_DIALOG_CONTROLLIST].d1];
			teamsDialog[TEAMS_DIALOG_PLAYERLIST].d1 += 1;

			}
		else if ((a == TEAMS_DIALOG_SETUP) || (a == TEAMS_DIALOG_PLAYERLIST)) {
			Control *tmpc = load_player(teamsDialog[TEAMS_DIALOG_PLAYERLIST].d1);
			if (tmpc) {
				showTitle();
				tmpc->setup();
				delete tmpc;
				showTitle();
				}
			}
    else if (a == TEAMS_DIALOG_CONFIG_NUM) {
			player_config[teamsDialog[TEAMS_DIALOG_PLAYERLIST].d1] += 1;
			player_config[teamsDialog[TEAMS_DIALOG_PLAYERLIST].d1] %= MAX_CONFIGURATIONS;
			}
    else if (a == TEAMS_DIALOG_FLEET) {
			edit_fleet(teamsDialog[TEAMS_DIALOG_PLAYERLIST].d1);
			showTitle();
			}
		else break;
		}
	set_config_file("scp.ini");
	for (int i = 0; i < MAX_PLAYERS; i += 1) {
		sprintf(dialog_string[0], "Player%d", i+1);
		set_config_string (dialog_string[0], "Type", player_type[i]);
		set_config_int (dialog_string[0], "Config", player_config[i]);
		}
	return;
	}

char *playerListboxGetter(int index, int *list_size)
{
	static char tmp[80];
	tmp[0] = 0;
  if(index < 0) {
    *list_size = MAX_PLAYERS;
    return NULL;
  } else {
    sprintf(tmp, "Player%d %s %d", index+1, player_type[index], player_config[index]);
		ASSERT (strlen(tmp) < 40);
    return tmp;
  }
}
char *controlListboxGetter(int index, int *list_size) 
{
	static char tmp[40];
	tmp[0] = 0;
  if(index < 0) {
    *list_size = num_controls;
    return NULL;
  } else {
    return(control_name[index]);
  }
}





#define NUM_RESOLUTIONS 5
#define NUM_DEPTHS 5
int screen_xs[NUM_RESOLUTIONS] = {640, 800, 1024, 1280, 1600};
int screen_ys[NUM_RESOLUTIONS] = {480, 600, 768, 1024, 1200};
int screen_zs[NUM_DEPTHS] = {8, 15, 16, 24, 32};

int screen_x = screen_xs[0], screen_y = screen_ys[0];
int color_depth = screen_zs[0];

char *depthListboxGetter(int index, int *list_size) {
	static char tmp[40];
	tmp[0] = 0;
	if(index < 0) {
		*list_size = NUM_DEPTHS;
		return NULL;
		} 
	else {
		sprintf (tmp, "%d bits", screen_zs[index]);
		return(tmp);
		}
	}

char *resListboxGetter(int index, int *list_size) {
	static char tmp[40];
	tmp[0] = 0;
	if(index < 0) {
		*list_size = NUM_RESOLUTIONS;
		return NULL;
		} 
	else {
		sprintf (tmp, "%dx%d", screen_xs[index], screen_ys[index]);
		return(tmp);
		}
	}
char *viewListboxGetter(int index, int *list_size) 
{
	static char tmp[40];
	tmp[0] = 0;
	if(index < 0) {
		*list_size = num_views;
		return NULL;
	} else {
		return(view_name[index]);
	}
}

#define OPTIONS_DIALOG_BOX					0
#define OPTIONS_DIALOG_GAMMA_TEXT		1
#define OPTIONS_DIALOG_GAMMA_SLIDER	2
#define OPTIONS_DIALOG_SOUND				3
#define OPTIONS_DIALOG_SOUND_SLIDER	4
#define OPTIONS_DIALOG_MUSIC				5
#define OPTIONS_DIALOG_MUSIC_SLIDER	6
#define OPTIONS_DIALOG_STARS_TEXT		7
#define OPTIONS_DIALOG_STARS_SLIDER	8
#define OPTIONS_DIALOG_AA						9
#define OPTIONS_DIALOG_FULLSCREEN		10
#define OPTIONS_DIALOG_COLOR_TEXT		11
#define OPTIONS_DIALOG_COLOR				12
#define OPTIONS_DIALOG_RES_TEXT			13	
#define OPTIONS_DIALOG_RES					14	
#define OPTIONS_DIALOG_VIEW_TEXT		15
#define OPTIONS_DIALOG_VIEW					16
#define OPTIONS_DIALOG_OK						17
#define OPTIONS_DIALOG_CANCEL				18
DIALOG optionsDialog[] = {
  // (dialog proc)     (x)   (y)   (w)   (h)   (fg) (bg) (key) (flags)  (d1)  (d2)  (dp)
  { d_box_proc,        30,   50,  460, 315,   255,  0,    0,    0,       0,    0,    NULL, NULL, NULL },
  { d_text_proc,       40,   80,  160,  20,   255,  0,    0,    0,       0,    0,    (void *)"Gamma Correction", NULL, NULL },
  { d_slider_proc,     205,  80,  180,  15,   255,  0,    0,    0,       255,  0,    NULL, NULL, NULL },
  { d_check_proc,      40,  110,  160,  20,   255,  0,    0,    0,       0,    0,    (void *)"Sound Volume ", NULL, NULL },  
  { d_slider_proc,     205, 110,  180,  15,   255,  0,    0,    0,       255,  0,    NULL, NULL, NULL },
  { d_check_proc,      40,  140,  160,  20,   255,  0,    0,    0,       0,    0,    (void *)"Music Volume ", NULL, NULL },  
  { d_slider_proc,     205, 140,  180,  15,   255,  0,    0,    0,       255,  0,    NULL, NULL, NULL },
  { d_text_proc,       40,  170,  160,  20,   255,  0,    0,    0,       0,    0,    (void *)"Star Depth", NULL, NULL },
  { d_slider_proc,     205, 170,  180,  15,   255,  0,    0,    0,       255,  0,    NULL, NULL, NULL },
  { d_check_proc,      40,  200,  160,  20,   255,  0,    0,    0,       0,    0,    (void *)"Antialiasing ", NULL, NULL },
  { d_check_proc,      240,  200,  160,  20,   255,  0,    0,    0,       0,    0,    (void *)"Full-screen ", NULL, NULL },
  { d_text_proc,       40,  240,  120,  20,   255,  0,    0,    0,       0,    0,    (void *)"Color Depth", NULL, NULL },
  { d_list_proc,       40,  255,  120,  90,   255,  0,    0,    0,       0,    0,    depthListboxGetter, NULL, NULL },
  { d_text_proc,       170, 240,  120,  20,   255,  0,    0,    0,       0,    0,    (void *)"Resolution", NULL, NULL },
  { d_list_proc,       170, 255,  120,  90,   255,  0,    0,    0,       0,    0,    resListboxGetter, NULL, NULL },
  { d_text_proc,       300, 240,  180,  20,   255,  0,    0,    0,       0,    0,    (void *)"View", NULL, NULL },
  { d_list_proc,       300, 255,  180,  90,   255,  0,    0,    0,       0,    0,    viewListboxGetter, NULL, NULL },
  { d_button_proc,     400,  80,  80,   40,   255,  0,    0,    D_EXIT,  0,    0,    (void *)"OK", NULL, NULL },
  { d_button_proc,     400, 140,  80,   40,   255,  0,    0,    D_EXIT,  0,    0,    (void *)"Cancel", NULL, NULL },
  { NULL,              0,   0,    0,    0,    255,  0,    0,    0,       0,    0,    NULL, NULL, NULL }
	};

void change_options() {
	int i, j, res, depth;
	set_dialog_color(optionsDialog, pallete_color[0], pallete_color[15]);

	if (sound.sound_on) optionsDialog[OPTIONS_DIALOG_SOUND].flags = D_SELECTED;
	else optionsDialog[OPTIONS_DIALOG_SOUND].flags = 0;
	if (sound.music_on) optionsDialog[OPTIONS_DIALOG_MUSIC].flags = D_SELECTED;
	else optionsDialog[OPTIONS_DIALOG_MUSIC].flags = 0;
	if (antia_on) optionsDialog[OPTIONS_DIALOG_AA].flags = D_SELECTED;
	else optionsDialog[OPTIONS_DIALOG_AA].flags = 0;
	if (fullscreen) optionsDialog[OPTIONS_DIALOG_FULLSCREEN].flags = D_SELECTED;
	else optionsDialog[OPTIONS_DIALOG_FULLSCREEN].flags = 0;

	optionsDialog[OPTIONS_DIALOG_GAMMA_SLIDER].d2 = gamma_correction;
	optionsDialog[OPTIONS_DIALOG_SOUND_SLIDER].d2 = sound.sound_volume;
	optionsDialog[OPTIONS_DIALOG_MUSIC_SLIDER].d2 = sound.music_volume;
	set_config_file("client.ini");
	optionsDialog[OPTIONS_DIALOG_STARS_SLIDER].d2 = get_config_int("Stars", "Depth", 192);

	optionsDialog[OPTIONS_DIALOG_VIEW].d1 = view_num;
	depth = 0;
	for (i = 0; i < NUM_DEPTHS; i += 1) if (screen_zs[i] == color_depth) depth = i;
	optionsDialog[OPTIONS_DIALOG_COLOR].d1 = depth;
	res = 0;
	for (i = 0; i < NUM_RESOLUTIONS; i += 1) 
		if ((screen_xs[i] == screen_x) && (screen_ys[i] == screen_y)) res = i;
	optionsDialog[OPTIONS_DIALOG_RES].d1 = res;
 
	optionsRet = popup_dialog(optionsDialog, OPTIONS_DIALOG_OK);

	if (optionsRet == OPTIONS_DIALOG_CANCEL) return;

	if (optionsDialog[OPTIONS_DIALOG_AA].flags==D_SELECTED) antia_on=1;
	else antia_on = 0;
	if (optionsDialog[OPTIONS_DIALOG_FULLSCREEN].flags == D_SELECTED) fullscreen = true;
	else fullscreen = false;

	gamma_correction = optionsDialog[OPTIONS_DIALOG_GAMMA_SLIDER].d2;
	i = optionsDialog[OPTIONS_DIALOG_COLOR].d1;
	j = optionsDialog[OPTIONS_DIALOG_RES].d1;
	if ((depth != i) || (res != j)) {
		color_depth = screen_zs[i];
		screen_x = screen_xs[j];
		screen_y = screen_ys[j];
		}
	init_video();

	
	set_config_file("client.ini");
	set_config_int("Video", "BitsPerPixel", color_depth);
	set_config_int("Video", "ScreenWidth", screen_x);
	set_config_int("Video", "ScreenHeight", screen_y);
	set_config_int("Video", "FullScreen", fullscreen);
	set_config_int("Video", "Anti-Aliasing", antia_on);

	set_config_int("View", "Gamma", gamma_correction);

	if (!game || !game->view_locked)	set_view(view2number(view_name[optionsDialog[OPTIONS_DIALOG_VIEW].d1]));
	set_config_string("View", "View", view_name[optionsDialog[OPTIONS_DIALOG_VIEW].d1]);

	if (view) view->set_depth(optionsDialog[OPTIONS_DIALOG_STARS_SLIDER].d2);
	set_config_int("Stars", "Depth", optionsDialog[OPTIONS_DIALOG_STARS_SLIDER].d2);

	if (optionsDialog[OPTIONS_DIALOG_MUSIC].flags==D_SELECTED) sound.music_on = true;
	else sound.music_on = FALSE;
	if (optionsDialog[OPTIONS_DIALOG_SOUND].flags==D_SELECTED) sound.sound_on = true;
	else sound.sound_on=FALSE;
	sound.sound_volume = optionsDialog[OPTIONS_DIALOG_SOUND_SLIDER].d2;
	sound.music_volume = optionsDialog[OPTIONS_DIALOG_MUSIC_SLIDER].d2;
	sound.set_volumes();
	sound.save();

	return;
	}

