#include <stdlib.h>
#include "history.h"


////////////////////////////////////////////////////////////////////////
//				Histograph stuff
////////////////////////////////////////////////////////////////////////

	
Histograph::Histograph(int max) {
	num = 0;
	this->max = max;
	sum = 0;
	element = new double[max];
	next_ratio = 2;
	next = NULL;
	}
Histograph::~Histograph() {
	if (next) delete next;
	delete element;
	}
void Histograph::add_element(double v) {
	sum += v;
	_add(sum);
	return;
	}
void Histograph::_add(double v) {
	int i;
	if (num == max) {
		num -= next_ratio;
		double v = 0;
		for (i = 0; i < next_ratio; i += 1) {
			v += element[i];
			}
		for (i = 0; i < num; i += 1) {
			element[i] = element[i+next_ratio];
			}
		if (!next) next = new Histograph(max);
		next->_add(v);
		}
	element[num] = v;
	num += 1;
	return;
	}
double Histograph::_get (int back) {
	if (back < num) return element[num-back-1];
	if (!next) return 0;
	back -= num;
	double a, b;
	a = next->_get(1 + back/next_ratio) / next_ratio;
	b = next->_get(back/next_ratio) / next_ratio;
	return b;
	}
double Histograph::get_element (int back) {
	return _get(back) - _get(back+1);
	}
double Histograph::get_average (int back1, int back2) {
	return (_get(back1) - _get(back2)) / (back2 - back1 + 1);
	}
